/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */

#include "pantalla.h"

void Pantalla::initElementosComunes () {
	printf("Cargando elementos comunes\n");
	Frame frCargando;
	char tmpch[128];
	int i;
	barradecarga = new BarraDeCarga(screen, 13, (pantalla_w/2), 304);
	

	sprintf (tmpch, "%s/miscelanea.tim", DATA_DIR);
	frCargando.loadFromRAR(tmpch, "cargando.timp");
	cargando = new Elemento();
	cargando->addFrame(frCargando);
	cargando->setX(cargando->getCentrarXen(pantalla_w/2));
	cargando->setY(cargando->getCentrarYen(pantalla_h/2));
	int sizeFont = 11;
	
	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Cargando configuración de usuario", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Cargando configuración de usuario\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// caja
	Frame frCaja;
	frCaja.loadFromRAR(tmpch, "caja.timp");
	caja = new Elemento();
	caja->addFrame(frCaja);
	caja->setX(caja->getCentrarXen(screen_w/2));
	caja->setY(caja->getCentrarYen(screen_h/2)-20);
	
	// textos de las cajas
	sprintf (tmpch, "%s/textos.tim", DATA_DIR);
	
	Frame frSalir, frSi_Sel, frNo_Sel, frSi_NoSel, frNo_NoSel, frContinuar, frEscondido;
	Frame frPausa, frFracasada;
	frSalir.loadFromRAR(tmpch, "txt_salir.timp");
	txtSalir = new Elemento();
	txtSalir->addFrame(frSalir);
	txtSalir->setX(screen_w/2);
	txtSalir->setY(210);
	txtSalir->setAlign(ALIGN_CENTER);
	txtSalir->setVAlign(VALIGN_CENTER);
	
	frContinuar.loadFromRAR(tmpch, "txt_continuar.timp");
	txtContinuar = new Elemento();
	txtContinuar->addFrame(frContinuar);
	txtContinuar->setX(screen_w/2);
	txtContinuar->setY(210);
	txtContinuar->setAlign(ALIGN_CENTER);
	txtContinuar->setVAlign(VALIGN_CENTER);
	
	frEscondido.loadFromRAR(tmpch, "txt_escondio.timp");
	txtMensajeFinal = new Elemento();
	txtMensajeFinal->addFrame(frEscondido);
	txtMensajeFinal->setX((screen_w/2)+10);
	txtMensajeFinal->setY(220);
	txtMensajeFinal->setAlign(ALIGN_CENTER);
	txtMensajeFinal->setVAlign(VALIGN_CENTER);	
	
	frFracasada.loadFromRAR(tmpch, "txt_fracasada.timp");
	txtFracasada = new Elemento();
	txtFracasada->addFrame(frFracasada);
	txtFracasada->setX((screen_w/2)+4);
	txtFracasada->setY(290);
	txtFracasada->setAlign(ALIGN_CENTER);
	txtFracasada->setVAlign(VALIGN_CENTER);	
	
	frPausa.loadFromRAR(tmpch, "txt_pausa.timp");
	txtPausa = new Elemento();
	txtPausa->addFrame(frPausa);
	txtPausa->setX(screen_w/2);
	txtPausa->setY(250);
	txtPausa->setAlign(ALIGN_CENTER);
	txtPausa->setVAlign(VALIGN_CENTER);	
	
	frSi_Sel.loadFromRAR(tmpch, "txt_si_sel.timp");
	frSi_NoSel.loadFromRAR(tmpch, "txt_si_nosel.timp");
	frNo_Sel.loadFromRAR(tmpch, "txt_no_sel.timp");
	frNo_NoSel.loadFromRAR(tmpch, "txt_no_nosel.timp");

	txtSi = new Elemento(2);
	txtSi->addFrame(frSi_Sel);
	txtSi->addFrame(frSi_NoSel);
	txtSi->setX((screen_w/2)-50);
	txtSi->setY(280);
	txtSi->setAlign(ALIGN_CENTER);
	txtSi->setVAlign(VALIGN_CENTER);
	
	txtNo = new Elemento(2);
	txtNo->addFrame(frNo_Sel);
	txtNo->addFrame(frNo_NoSel);
	txtNo->setX((screen_w/2)+50);
	txtNo->setY(280);
	txtNo->setAlign(ALIGN_CENTER);
	txtNo->setVAlign(VALIGN_CENTER);
	
	// instancia de juego
	juego = new Juego();
	juego->setHacerClip(1);	
	
	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Cargando fuentes", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Cargando fuentes\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// iniciamos las fuentes
	fuente = new Fuente();
	
	SDL_Surface *sfc;
	Frame frNivel;
	txtNivel = new Elemento();
	sfc = fuente->escribirTexto(0, 16, juego->getTituloNumeroFase(), 255, 230, 23,  0, 0, 0);
	frNivel.loadSurface(sfc);
	txtNivel->addFrame(frNivel);
	txtNivel->setX(-160);
	txtNivel->setY(170);
	txtNivel->setAlign(ALIGN_CENTER);
	txtNivel->setVAlign(VALIGN_TOP);
	
	Frame frFase;
	txtFase = new Elemento();
	sfc = fuente->escribirTexto(0, 16, juego->getTituloNombreFase(), 255, 255, 255,  0, 0, 0);
	frFase.loadSurface(sfc);
	txtFase->addFrame(frFase);
	txtFase->setX(pantalla_w);
	txtFase->setY(200);
	txtFase->setAlign(ALIGN_CENTER);
	txtFase->setVAlign(VALIGN_TOP);
	
	sprintf (tmpch, "%s/miscelanea.tim", DATA_DIR);
	
	Frame frFondoSelPoder;
	fondo_SelPoder = new Elemento();
	frFondoSelPoder.loadFromRAR(tmpch, "fondo_sel_poderes.timp");
	fondo_SelPoder->addFrame(frFondoSelPoder);
	fondo_SelPoder->setX(screen_w/2);
	fondo_SelPoder->setY(150);
	fondo_SelPoder->setAlign(ALIGN_CENTER);
	fondo_SelPoder->setVAlign(VALIGN_TOP);
	
	Frame frEscudoOn, frEscudoOff;
	
	poderEscudo = new Elemento(2);
	frEscudoOn.loadFromRAR(tmpch, "escudo_on.timp");
	frEscudoOff.loadFromRAR(tmpch, "escudo_off.timp");
	
	poderEscudo->addFrame(frEscudoOff);
	poderEscudo->addFrame(frEscudoOn);
	poderEscudo->setX(60);
	poderEscudo->setY(190);
	
	Frame frBombaOn, frBombaOff;
	
	poderBomba = new Elemento(2);
	frBombaOn.loadFromRAR(tmpch, "bomba_on.timp");
	frBombaOff.loadFromRAR(tmpch, "bomba_off.timp");
	
	poderBomba->addFrame(frBombaOff);
	poderBomba->addFrame(frBombaOn);
	poderBomba->setX(155);
	poderBomba->setY(140);
	
	Frame frClonacionOn, frClonacionOff;
	
	poderClonacion = new Elemento(2);
	frClonacionOn.loadFromRAR(tmpch, "clonacion_on.timp");
	frClonacionOff.loadFromRAR(tmpch, "clonacion_off.timp");
	
	poderClonacion->addFrame(frClonacionOff);
	poderClonacion->addFrame(frClonacionOn);
	poderClonacion->setX(260);
	poderClonacion->setY(140);
	
	Frame frCadistaOn, frCadistaOff;
	
	poderCadista = new Elemento(2);
	frCadistaOn.loadFromRAR(tmpch, "amarillo_on.timp");
	frCadistaOff.loadFromRAR(tmpch, "amarillo_off.timp");
	
	poderCadista->addFrame(frCadistaOff);
	poderCadista->addFrame(frCadistaOn);
	poderCadista->setX(355);
	poderCadista->setY(190);
	
	
	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Cargando joystick y mapa", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Cargando joystick y mapa\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// iniciamos el joystick
	joystick = new Joystick();
	joystick->initJoystick();
	
	// iniciamos mapas
	
	mapa = new Mapa();
	
	mapaagua = new MapaAgua();
	
	// iniciamos tiempo
	
	tiempo = new Tiempo();
	tiempo->CargarCarnaval();
	tiempo->CargarNieve();
	tiempo->CargarLluvia();
	
	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Creando tirititran", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Creando tirititran\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// Creamos el jugador
	jugador = new Jugador(8);
	jugador->cargarSprites(screen);
	
	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Cargando explosiones de elementos", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Cargando explosiones de elementos\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// iniciamos instacias de explosiones
	explosiones = new Explosion(screen);

	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Cargando disparos de enemigos y jugador", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Cargando disparos de enemigos y jugador\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);

	// cargar chipas
	
	sprintf (tmpch, "%s/miscelanea.tim", DATA_DIR);
	
	Frame frChispa0, frChispa1, frChispa2;
	
	frChispa0.loadFromRAR(tmpch, "shispa_0.timp");
	
	frChispa1.loadFromRAR(tmpch, "shispa_1.timp");
	
	frChispa2.loadFromRAR(tmpch, "shispa_2.timp");
	
	for (i=0; i<MAX_CHISPAS; i++) {
		chispas[i] = new Elemento(3);
		chispas[i]->addFrame(frChispa0);
		chispas[i]->addFrame(frChispa1);
		chispas[i]->addFrame(frChispa2);
		chispas[i]->setAlign(ALIGN_CENTER);
		chispas[i]->setVAlign(VALIGN_BOTTOM);
		chispas[i]->setActivo(0);
	}

	// cargamos los diparos de los enemigos
	disp_ene = new DisparosEnemigos(jugador);
	

	
	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Cargando barra y presentaciones", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Cargando barra y presentaciones\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// barra de información
	barra = new Barra(juego);
	
	Frame frPresentacion;
	sprintf (tmpch, "%s/fondos.tim", DATA_DIR);
	frPresentacion.loadFromRAR(tmpch, "presentacion.timp");
	presentacionFase = new Elemento();
	presentacionFase->addFrame(frPresentacion);
	presentacionFase->setX(0);
	presentacionFase->setY(0);


	// cargar fuente
	//fuente->initFuente();

	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Cargando música y sonidos", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Cargando música y sonidos\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);

	// que empiece la música maestro
	sonido = new Audio(config);
	sonido->initSonido();
	sonido->cargarSonido();
	
	ciclosNivel = 100;

	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Creando superficies para fondos", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Creando superficies para fondos\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// línea donde se colocarán el principio de fase
	Uint32 rmask, gmask, bmask, amask;
	Frame frBandaNivel;
    SDL_Surface *surface;
	
	rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
	surface = SDL_CreateRGBSurface(SDL_SWSURFACE | SDL_SRCALPHA, pantalla_w, 80, 8, rmask, gmask, bmask, amask);
	if ( surface == NULL ) {
		printf ("El surface no se ha creado\n");
	}
	frBandaNivel.loadSurface(surface, screen);
	banda_Nivel = new Elemento();
	banda_Nivel->setX(0);
	banda_Nivel->setY(160);
	banda_Nivel->addFrame(frBandaNivel);
	banda_Nivel->setAlpha(100);
	banda_Nivel->selFrame(0);
	
	// pantalla en negro
	/*
	Frame frNegro;
	surface = SDL_CreateRGBSurface(SDL_SWSURFACE | SDL_SRCALPHA, screen_w, screen_h, 8, rmask, gmask, bmask, amask);
	if ( surface == NULL ) {
		printf ("El surface no se ha creado\n");
	}
	frNegro.loadSurface(surface, screen);
	negro = new Elemento();
	negro->setX(0);
	negro->setY(0);
	negro->addFrame(frNegro);
	negro->setAlpha(100);
	negro->selFrame(0);
	*/
	
	Frame frNegro;
	sprintf (tmpch, "%s/miscelanea.tim", DATA_DIR);
	frNegro.loadFromRAR(tmpch, "negro.timp");
	negro = new Elemento();
	negro->addFrame(frNegro);
	negro->setX(0);
	negro->setY(0);
	
	// carga logo para cortes
	
	Frame frLogoAr;
	frLogoAr.loadFromRAR(tmpch, "logo_ar.timp");
	mitadLogoArriba = new Elemento();
	mitadLogoArriba->addFrame(frLogoAr);
	mitadLogoArriba->setX(0);
	mitadLogoArriba->setY(-240);
	
	Frame frLogoAb;
	frLogoAb.loadFromRAR(tmpch, "logo_ab.timp");
	mitadLogoAbajo = new Elemento();
	mitadLogoAbajo->addFrame(frLogoAb);
	mitadLogoAbajo->setX(0);
	mitadLogoAbajo->setY(480);
	
	Frame frVersusAr;
	frVersusAr.loadFromRAR(tmpch, "logo_ar.timp");
	mitadVersusArriba = new Elemento();
	mitadVersusArriba->addFrame(frVersusAr);
	mitadVersusArriba->setX(0);
	mitadVersusArriba->setY(0);
	mitadVersusArriba->setDY(-15);
	
	Frame frVersusAb;
	frVersusAb.loadFromRAR(tmpch, "logo_ab.timp");
	mitadVersusAbajo = new Elemento();
	mitadVersusAbajo->addFrame(frVersusAb);
	mitadVersusAbajo->setX(0);
	mitadVersusAbajo->setY(240);
	mitadVersusAbajo->setDY(15);
	

	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Creando agregadores", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Creando agregadores\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// pantalla en rojo
	Frame frRojo;
	int colorFondo = SDL_MapRGB(screen->format, 255, 0, 0);
	surface = SDL_CreateRGBSurface(SDL_SWSURFACE | SDL_SRCALPHA, screen_w, screen_h, 16, screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, screen->format->Amask);
	if ( surface == NULL ) {
		printf ("El surface no se ha creado\n");
	}
	SDL_FillRect(surface, NULL, colorFondo);
	frRojo.loadSurface(surface, screen);
	rojo = new Elemento();
	rojo->setX(0);
	rojo->setY(0);
	rojo->addFrame(frRojo);
	rojo->setAlpha(90);
	rojo->selFrame(0);
	
	// pantalla en rojo
	Frame frAmarillo;
	colorFondo = SDL_MapRGB(screen->format, 255, 255, 0);
	surface = SDL_CreateRGBSurface(SDL_SWSURFACE | SDL_SRCALPHA, screen_w, screen_h, 16, screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, screen->format->Amask);
	if ( surface == NULL ) {
		printf ("El surface no se ha creado\n");
	}
	SDL_FillRect(surface, NULL, colorFondo);
	frAmarillo.loadSurface(surface, screen);
	amarillo = new Elemento();
	amarillo->setX(0);
	amarillo->setY(0);
	amarillo->addFrame(frAmarillo);
	amarillo->setAlpha(90);
	amarillo->selFrame(0);
	
	// cargar estela de la bomba
	Frame frEstela;
	sprintf (tmpch, "%s/miscelanea.tim", DATA_DIR);
	frEstela.loadFromRAR(tmpch, "estela_bomba.timp");
	estela_bomba = new Elemento();
	estela_bomba->addFrame(frEstela);
	estela_bomba->setX(0);
	estela_bomba->setY(screen_h);
	estela_bomba->setDX(0);
	estela_bomba->setDY(-90);
	
	// cargar agregadores
	
	Frame frAg0, frAg1, frAg2, frAg3, frAg4, frAg5, frAg6, frAg7, frAg8;
	Frame frAg9, frAg10, frAg11, frAg12, frAg13, frAg14, frAg15, frAg16, frAg17;
	Frame frAg18, frAg19, frAg20, frAg21, frAg22, frAg23, frAg24, frAg25, frAg26;

	sprintf (tmpch, "%s/agregadores.tim", DATA_DIR);
	frAg0.loadFromRAR(tmpch, "ag_poder_0.timp");
	frAg1.loadFromRAR(tmpch, "ag_poder_1.timp");
	frAg2.loadFromRAR(tmpch, "ag_poder_2.timp");
	frAg3.loadFromRAR(tmpch, "ag_poder_3.timp");
	frAg4.loadFromRAR(tmpch, "ag_poder_4.timp");
	frAg5.loadFromRAR(tmpch, "ag_poder_5.timp");
	frAg6.loadFromRAR(tmpch, "ag_poder_6.timp");
	frAg7.loadFromRAR(tmpch, "ag_poder_7.timp");
	frAg8.loadFromRAR(tmpch, "ag_poder_8.timp");
	frAg9.loadFromRAR(tmpch, "ag_vida_0.timp");
	frAg10.loadFromRAR(tmpch, "ag_vida_1.timp");
	frAg11.loadFromRAR(tmpch, "ag_vida_2.timp");
	frAg12.loadFromRAR(tmpch, "ag_vida_3.timp");
	frAg13.loadFromRAR(tmpch, "ag_vida_4.timp");
	frAg14.loadFromRAR(tmpch, "ag_vida_5.timp");
	frAg15.loadFromRAR(tmpch, "ag_vida_6.timp");
	frAg16.loadFromRAR(tmpch, "ag_vida_7.timp");
	frAg17.loadFromRAR(tmpch, "ag_vida_8.timp");
	frAg18.loadFromRAR(tmpch, "ag_disparo_0.timp");
	frAg19.loadFromRAR(tmpch, "ag_disparo_1.timp");
	frAg20.loadFromRAR(tmpch, "ag_disparo_2.timp");
	frAg21.loadFromRAR(tmpch, "ag_disparo_3.timp");
	frAg22.loadFromRAR(tmpch, "ag_disparo_4.timp");
	frAg23.loadFromRAR(tmpch, "ag_disparo_5.timp");
	frAg24.loadFromRAR(tmpch, "ag_disparo_6.timp");
	frAg25.loadFromRAR(tmpch, "ag_disparo_7.timp");
	frAg26.loadFromRAR(tmpch, "ag_disparo_8.timp");

	for (i=0; i < MAXAGREGADORES; i++) {
		agregadores[i] = new Agregador(27);
		agregadores[i]->addFrame(frAg0);
		agregadores[i]->addFrame(frAg1);
		agregadores[i]->addFrame(frAg2);
		agregadores[i]->addFrame(frAg3);
		agregadores[i]->addFrame(frAg4);
		agregadores[i]->addFrame(frAg5);
		agregadores[i]->addFrame(frAg6);
		agregadores[i]->addFrame(frAg7);
		agregadores[i]->addFrame(frAg8);
		agregadores[i]->addFrame(frAg9);
		agregadores[i]->addFrame(frAg10);
		agregadores[i]->addFrame(frAg11);
		agregadores[i]->addFrame(frAg12);
		agregadores[i]->addFrame(frAg13);
		agregadores[i]->addFrame(frAg14);
		agregadores[i]->addFrame(frAg15);
		agregadores[i]->addFrame(frAg16);
		agregadores[i]->addFrame(frAg17);
		agregadores[i]->addFrame(frAg18);
		agregadores[i]->addFrame(frAg19);
		agregadores[i]->addFrame(frAg20);
		agregadores[i]->addFrame(frAg21);
		agregadores[i]->addFrame(frAg22);
		agregadores[i]->addFrame(frAg23);
		agregadores[i]->addFrame(frAg24);
		agregadores[i]->addFrame(frAg25);
		agregadores[i]->addFrame(frAg26);
		agregadores[i]->posicionAleatoria();
		agregadores[i]->selFrame(0);
	}
	

	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Creando enemigos Generales de tipo 1", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Creando enemigos Generales de tipo 1\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// cargar gaviotas oscuras
	
	Frame frEstornino0, frEstornino1, frEstornino2, frEstornino3, frEstornino4, frEstornino5; 
	Frame frEstornino6, frEstornino7, frEstornino8, frEstornino9, frEstornino10, frEstornino11;
	Frame frEstornino12, frEstornino13, frEstornino14, frEstornino15, frEstornino16, frEstornino17;
	
	sprintf (tmpch, "%s/ene_generales.tim", DATA_DIR);
	frEstornino0.loadFromRAR(tmpch, "gaviota1_0.timp");
	frEstornino1.loadFromRAR(tmpch, "gaviota1_1.timp");
	frEstornino2.loadFromRAR(tmpch, "gaviota1_2.timp");
	frEstornino3.loadFromRAR(tmpch, "gaviota1_3.timp");
	frEstornino4.loadFromRAR(tmpch, "gaviota1_4.timp");
	frEstornino5.loadFromRAR(tmpch, "gaviota1_5.timp");
	frEstornino6.loadFromRAR(tmpch, "gaviota1_6.timp");
	frEstornino7.loadFromRAR(tmpch, "gaviota1_7.timp");
	frEstornino8.loadFromRAR(tmpch, "gaviota1_8.timp");
	frEstornino9.loadFromRAR(tmpch, "gaviota1_9.timp");
	frEstornino10.loadFromRAR(tmpch, "gaviota1_10.timp");
	frEstornino11.loadFromRAR(tmpch, "gaviota1_11.timp");
	frEstornino12.loadFromRAR(tmpch, "gaviota1_12.timp");
	frEstornino13.loadFromRAR(tmpch, "gaviota1_13.timp");
	frEstornino14.loadFromRAR(tmpch, "gaviota1_14.timp");
	frEstornino15.loadFromRAR(tmpch, "gaviota1_15.timp");
	frEstornino16.loadFromRAR(tmpch, "gaviota1_16.timp");
	frEstornino17.loadFromRAR(tmpch, "gaviota1_17.timp");

	for (i=0; i < MAXENE_GEN1; i++) {
		gaviotas[i] = new GeneralNivel1(18);
		gaviotas[i]->addFrame(frEstornino0);
		gaviotas[i]->addFrame(frEstornino1);
		gaviotas[i]->addFrame(frEstornino2);
		gaviotas[i]->addFrame(frEstornino3);
		gaviotas[i]->addFrame(frEstornino4);
		gaviotas[i]->addFrame(frEstornino5);
		gaviotas[i]->addFrame(frEstornino6);
		gaviotas[i]->addFrame(frEstornino7);
		gaviotas[i]->addFrame(frEstornino8);
		gaviotas[i]->addFrame(frEstornino9);
		gaviotas[i]->addFrame(frEstornino10);
		gaviotas[i]->addFrame(frEstornino11);
		gaviotas[i]->addFrame(frEstornino12);
		gaviotas[i]->addFrame(frEstornino13);
		gaviotas[i]->addFrame(frEstornino14);
		gaviotas[i]->addFrame(frEstornino15);
		gaviotas[i]->addFrame(frEstornino16);
		gaviotas[i]->addFrame(frEstornino17);
		gaviotas[i]->setTipoElemento(GAVIOTA1);
		gaviotas[i]->selFrame(0);
	}
	
	// cargar gaviotas blancas
	
	frEstornino0.loadFromRAR(tmpch, "gaviota2_0.timp");
	frEstornino1.loadFromRAR(tmpch, "gaviota2_1.timp");
	frEstornino2.loadFromRAR(tmpch, "gaviota2_2.timp");
	frEstornino3.loadFromRAR(tmpch, "gaviota2_3.timp");
	frEstornino4.loadFromRAR(tmpch, "gaviota2_4.timp");
	frEstornino5.loadFromRAR(tmpch, "gaviota2_5.timp");
	frEstornino6.loadFromRAR(tmpch, "gaviota2_6.timp");
	frEstornino7.loadFromRAR(tmpch, "gaviota2_7.timp");
	frEstornino8.loadFromRAR(tmpch, "gaviota2_8.timp");
	frEstornino9.loadFromRAR(tmpch, "gaviota2_9.timp");
	frEstornino10.loadFromRAR(tmpch, "gaviota2_10.timp");
	frEstornino11.loadFromRAR(tmpch, "gaviota2_11.timp");
	frEstornino12.loadFromRAR(tmpch, "gaviota2_12.timp");
	frEstornino13.loadFromRAR(tmpch, "gaviota2_13.timp");
	frEstornino14.loadFromRAR(tmpch, "gaviota2_14.timp");
	frEstornino15.loadFromRAR(tmpch, "gaviota2_15.timp");
	frEstornino16.loadFromRAR(tmpch, "gaviota2_16.timp");
	frEstornino17.loadFromRAR(tmpch, "gaviota2_17.timp");
	
	for (i=0; i < MAXENE_GEN1; i++) {
		gaviotas2[i] = new GeneralNivel1(18);
		gaviotas2[i]->addFrame(frEstornino0);
		gaviotas2[i]->addFrame(frEstornino1);
		gaviotas2[i]->addFrame(frEstornino2);
		gaviotas2[i]->addFrame(frEstornino3);
		gaviotas2[i]->addFrame(frEstornino4);
		gaviotas2[i]->addFrame(frEstornino5);
		gaviotas2[i]->addFrame(frEstornino6);
		gaviotas2[i]->addFrame(frEstornino7);
		gaviotas2[i]->addFrame(frEstornino8);
		gaviotas2[i]->addFrame(frEstornino9);
		gaviotas2[i]->addFrame(frEstornino10);
		gaviotas2[i]->addFrame(frEstornino11);
		gaviotas2[i]->addFrame(frEstornino12);
		gaviotas2[i]->addFrame(frEstornino13);
		gaviotas2[i]->addFrame(frEstornino14);
		gaviotas2[i]->addFrame(frEstornino15);
		gaviotas2[i]->addFrame(frEstornino16);
		gaviotas2[i]->addFrame(frEstornino17);
		gaviotas2[i]->setTipoElemento(GAVIOTA2);
		gaviotas2[i]->selFrame(0);
	}
	
	// cargar naves pequeñas
	
	frEstornino0.loadFromRAR(tmpch, "navepeq_0.timp");
	frEstornino1.loadFromRAR(tmpch, "navepeq_1.timp");
	frEstornino2.loadFromRAR(tmpch, "navepeq_2.timp");
	frEstornino3.loadFromRAR(tmpch, "navepeq_3.timp");
	frEstornino4.loadFromRAR(tmpch, "navepeq_4.timp");
	frEstornino5.loadFromRAR(tmpch, "navepeq_5.timp");
	frEstornino6.loadFromRAR(tmpch, "navepeq_6.timp");
	frEstornino7.loadFromRAR(tmpch, "navepeq_7.timp");
	frEstornino8.loadFromRAR(tmpch, "navepeq_8.timp");
	frEstornino9.loadFromRAR(tmpch, "navepeq_9.timp");
	frEstornino10.loadFromRAR(tmpch, "navepeq_10.timp");
	frEstornino11.loadFromRAR(tmpch, "navepeq_11.timp");
	frEstornino12.loadFromRAR(tmpch, "navepeq_12.timp");
	frEstornino13.loadFromRAR(tmpch, "navepeq_13.timp");
	frEstornino14.loadFromRAR(tmpch, "navepeq_14.timp");
	frEstornino15.loadFromRAR(tmpch, "navepeq_15.timp");
	frEstornino16.loadFromRAR(tmpch, "navepeq_16.timp");
	frEstornino17.loadFromRAR(tmpch, "navepeq_17.timp");


	for (i=0; i < MAXENE_GEN1; i++) {
		navepeq[i] = new GeneralNivel1(18);
		navepeq[i]->addFrame(frEstornino0);
		navepeq[i]->addFrame(frEstornino1);
		navepeq[i]->addFrame(frEstornino2);
		navepeq[i]->addFrame(frEstornino3);
		navepeq[i]->addFrame(frEstornino4);
		navepeq[i]->addFrame(frEstornino5);
		navepeq[i]->addFrame(frEstornino6);
		navepeq[i]->addFrame(frEstornino7);
		navepeq[i]->addFrame(frEstornino8);
		navepeq[i]->addFrame(frEstornino9);
		navepeq[i]->addFrame(frEstornino10);
		navepeq[i]->addFrame(frEstornino11);
		navepeq[i]->addFrame(frEstornino12);
		navepeq[i]->addFrame(frEstornino13);
		navepeq[i]->addFrame(frEstornino14);
		navepeq[i]->addFrame(frEstornino15);
		navepeq[i]->addFrame(frEstornino16);
		navepeq[i]->addFrame(frEstornino17);
		navepeq[i]->setTipoElemento(NAVEPEQUENYA);
		navepeq[i]->selFrame(0);
	}
	
	// cargar lanchas
	Frame frHel0, frHel1, frHel2, frHel3, frHel4, frHel5; 
	Frame frHel6, frHel7, frHel8, frHel9, frHel10, frHel11;
	Frame frHel12, frHel13, frHel14, frHel15, frHel16, frHel17;
	Frame frHel18, frHel19, frHel20, frHel21, frHel22, frHel23;
	Frame frHel24, frHel25, frHel26, frHel27, frHel28, frHel29;
	Frame frHel30, frHel31;
	
	frHel0.loadFromRAR(tmpch, "helicoptero_0a.timp");
	frHel1.loadFromRAR(tmpch, "helicoptero_1a.timp");
	frHel2.loadFromRAR(tmpch, "helicoptero_2a.timp");
	frHel3.loadFromRAR(tmpch, "helicoptero_3a.timp");
	frHel4.loadFromRAR(tmpch, "helicoptero_4a.timp");
	frHel5.loadFromRAR(tmpch, "helicoptero_5a.timp");
	frHel6.loadFromRAR(tmpch, "helicoptero_6a.timp");
	frHel7.loadFromRAR(tmpch, "helicoptero_7a.timp");
	frHel8.loadFromRAR(tmpch, "helicoptero_8a.timp");
	frHel9.loadFromRAR(tmpch, "helicoptero_9a.timp");
	frHel10.loadFromRAR(tmpch, "helicoptero_10a.timp");
	frHel11.loadFromRAR(tmpch, "helicoptero_11a.timp");
	frHel12.loadFromRAR(tmpch, "helicoptero_12a.timp");
	frHel13.loadFromRAR(tmpch, "helicoptero_13a.timp");
	frHel14.loadFromRAR(tmpch, "helicoptero_14a.timp");
	frHel15.loadFromRAR(tmpch, "helicoptero_15a.timp");
	
	frHel16.loadFromRAR(tmpch, "helicoptero_0b.timp");
	frHel17.loadFromRAR(tmpch, "helicoptero_1b.timp");
	frHel18.loadFromRAR(tmpch, "helicoptero_2b.timp");
	frHel19.loadFromRAR(tmpch, "helicoptero_3b.timp");
	frHel20.loadFromRAR(tmpch, "helicoptero_4b.timp");
	frHel21.loadFromRAR(tmpch, "helicoptero_5b.timp");
	frHel22.loadFromRAR(tmpch, "helicoptero_6b.timp");
	frHel23.loadFromRAR(tmpch, "helicoptero_7b.timp");
	frHel24.loadFromRAR(tmpch, "helicoptero_8b.timp");
	frHel25.loadFromRAR(tmpch, "helicoptero_9b.timp");
	frHel26.loadFromRAR(tmpch, "helicoptero_10b.timp");
	frHel27.loadFromRAR(tmpch, "helicoptero_11b.timp");
	frHel28.loadFromRAR(tmpch, "helicoptero_12b.timp");
	frHel29.loadFromRAR(tmpch, "helicoptero_13b.timp");
	frHel30.loadFromRAR(tmpch, "helicoptero_14b.timp");
	frHel31.loadFromRAR(tmpch, "helicoptero_15b.timp");
	
	for (i=0; i < MAXENE_GEN1; i++) {
		helicoptero[i] = new Helicoptero(32);
		helicoptero[i]->addFrame(frHel0);
		helicoptero[i]->addFrame(frHel1);
		helicoptero[i]->addFrame(frHel2);
		helicoptero[i]->addFrame(frHel3);
		helicoptero[i]->addFrame(frHel4);
		helicoptero[i]->addFrame(frHel5);
		helicoptero[i]->addFrame(frHel6);
		helicoptero[i]->addFrame(frHel7);
		helicoptero[i]->addFrame(frHel8);
		helicoptero[i]->addFrame(frHel9);
		helicoptero[i]->addFrame(frHel10);
		helicoptero[i]->addFrame(frHel11);
		helicoptero[i]->addFrame(frHel12);
		helicoptero[i]->addFrame(frHel13);
		helicoptero[i]->addFrame(frHel14);
		helicoptero[i]->addFrame(frHel15);
		helicoptero[i]->addFrame(frHel16);
		helicoptero[i]->addFrame(frHel17);
		helicoptero[i]->addFrame(frHel18);
		helicoptero[i]->addFrame(frHel19);
		helicoptero[i]->addFrame(frHel20);
		helicoptero[i]->addFrame(frHel21);
		helicoptero[i]->addFrame(frHel22);
		helicoptero[i]->addFrame(frHel23);
		helicoptero[i]->addFrame(frHel24);
		helicoptero[i]->addFrame(frHel25);
		helicoptero[i]->addFrame(frHel26);
		helicoptero[i]->addFrame(frHel27);
		helicoptero[i]->addFrame(frHel28);
		helicoptero[i]->addFrame(frHel29);
		helicoptero[i]->addFrame(frHel30);
		helicoptero[i]->addFrame(frHel31);
		helicoptero[i]->setTipoElemento(HELICOPTERO);
		helicoptero[i]->setIntervaloFrames(1);
		helicoptero[i]->selFrame(0);
	}
	
	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Creando enemigos Generales de tipo 2", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Creando enemigos Generales de tipo 2\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// cargar naves medianas
	
	Frame frNave0a, frNave0b, frNave0c;
	Frame frNave1a, frNave1b, frNave1c;
	Frame frNave2a, frNave2b, frNave2c;
	Frame frNave3a, frNave3b, frNave3c;
	
	frNave0a.loadFromRAR(tmpch, "mediana1_0a.timp");
	frNave0b.loadFromRAR(tmpch, "mediana1_0b.timp");
	frNave0c.loadFromRAR(tmpch, "mediana1_0c.timp");
	frNave1a.loadFromRAR(tmpch, "mediana1_1a.timp");
	frNave1b.loadFromRAR(tmpch, "mediana1_1b.timp");
	frNave1c.loadFromRAR(tmpch, "mediana1_1c.timp");
	frNave2a.loadFromRAR(tmpch, "mediana1_2a.timp");
	frNave2b.loadFromRAR(tmpch, "mediana1_2b.timp");
	frNave2c.loadFromRAR(tmpch, "mediana1_2c.timp");
	frNave3a.loadFromRAR(tmpch, "mediana1_3a.timp");
	frNave3b.loadFromRAR(tmpch, "mediana1_3b.timp");
	frNave3c.loadFromRAR(tmpch, "mediana1_3c.timp");
	
	for (i=0; i < MAXENE_GEN2; i++) {
		navemed[i] = new GeneralNivel2(12);
		navemed[i]->addFrame(frNave0a);
		navemed[i]->addFrame(frNave0b);
		navemed[i]->addFrame(frNave0c);
		navemed[i]->addFrame(frNave1a);
		navemed[i]->addFrame(frNave1b);
		navemed[i]->addFrame(frNave1c);
		navemed[i]->addFrame(frNave2a);
		navemed[i]->addFrame(frNave2b);
		navemed[i]->addFrame(frNave2c);
		navemed[i]->addFrame(frNave3a);
		navemed[i]->addFrame(frNave3b);
		navemed[i]->addFrame(frNave3c);
		navemed[i]->setTipoElemento(NAVEMEDIANA);
		navemed[i]->selFrame(0);
	}
	
	// cargar gavibots
	
	frNave0a.loadFromRAR(tmpch, "mediana2_0a.timp");
	frNave0b.loadFromRAR(tmpch, "mediana2_0b.timp");
	frNave0c.loadFromRAR(tmpch, "mediana2_0c.timp");
	frNave1a.loadFromRAR(tmpch, "mediana2_1a.timp");
	frNave1b.loadFromRAR(tmpch, "mediana2_1b.timp");
	frNave1c.loadFromRAR(tmpch, "mediana2_1c.timp");
	frNave2a.loadFromRAR(tmpch, "mediana2_2a.timp");
	frNave2b.loadFromRAR(tmpch, "mediana2_2b.timp");
	frNave2c.loadFromRAR(tmpch, "mediana2_2c.timp");
	frNave3a.loadFromRAR(tmpch, "mediana2_3a.timp");
	frNave3b.loadFromRAR(tmpch, "mediana2_3b.timp");
	frNave3c.loadFromRAR(tmpch, "mediana2_3c.timp");
	
	for (i=0; i < MAXENE_GEN2; i++) {
		gavibot[i] = new GeneralNivel2(12);
		gavibot[i]->addFrame(frNave0a);
		gavibot[i]->addFrame(frNave0b);
		gavibot[i]->addFrame(frNave0c);
		gavibot[i]->addFrame(frNave1a);
		gavibot[i]->addFrame(frNave1b);
		gavibot[i]->addFrame(frNave1c);
		gavibot[i]->addFrame(frNave2a);
		gavibot[i]->addFrame(frNave2b);
		gavibot[i]->addFrame(frNave2c);
		gavibot[i]->addFrame(frNave3a);
		gavibot[i]->addFrame(frNave3b);
		gavibot[i]->addFrame(frNave3c);
		gavibot[i]->setTipoElemento(GAVIBOTS);
	}
	
	// cargar avispas
	
	frNave0a.loadFromRAR(tmpch, "abispa_0a.timp");
	frNave0b.loadFromRAR(tmpch, "abispa_0b.timp");
	frNave0c.loadFromRAR(tmpch, "abispa_0c.timp");
	frNave1a.loadFromRAR(tmpch, "abispa_1a.timp");
	frNave1b.loadFromRAR(tmpch, "abispa_1b.timp");
	frNave1c.loadFromRAR(tmpch, "abispa_1c.timp");
	frNave2a.loadFromRAR(tmpch, "abispa_2a.timp");
	frNave2b.loadFromRAR(tmpch, "abispa_2b.timp");
	frNave2c.loadFromRAR(tmpch, "abispa_2c.timp");
	frNave3a.loadFromRAR(tmpch, "abispa_3a.timp");
	frNave3b.loadFromRAR(tmpch, "abispa_3b.timp");
	frNave3c.loadFromRAR(tmpch, "abispa_3c.timp");
	
	for (i=0; i < MAXENE_GEN2; i++) {
		avispa[i] = new GeneralNivel2(12);
		avispa[i]->addFrame(frNave0a);
		avispa[i]->addFrame(frNave0b);
		avispa[i]->addFrame(frNave0c);
		avispa[i]->addFrame(frNave1a);
		avispa[i]->addFrame(frNave1b);
		avispa[i]->addFrame(frNave1c);
		avispa[i]->addFrame(frNave2a);
		avispa[i]->addFrame(frNave2b);
		avispa[i]->addFrame(frNave2c);
		avispa[i]->addFrame(frNave3a);
		avispa[i]->addFrame(frNave3b);
		avispa[i]->addFrame(frNave3c);
		avispa[i]->setTipoElemento(AVISPA);
	}
	
	cargando->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFont, "Creando enemigos Generales de tipo 3", 255, 230, 23, 0,0,0, pantalla_w/2, pantalla_h/2);
	printf("Creando enemigos Generales de tipo 3\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// cargar nave grande
	
	Frame frNave0, frNave1, frNave2;
	Frame frSombra;
	Frame frFuego00, frFuego01, frFuego10, frFuego11;
	
	frNave0.loadFromRAR (tmpch, "navegrande_0.timp");	
	frNave1.loadFromRAR(tmpch, "navegrande_1.timp");
	frNave2.loadFromRAR(tmpch, "navegrande_2.timp");
	
	frSombra.loadFromRAR(tmpch, "navegrande_sombra.timp");
	
	frFuego00.loadFromRAR(tmpch, "fuego0_0.timp");
	frFuego01.loadFromRAR(tmpch, "fuego0_1.timp");

	frFuego10.loadFromRAR(tmpch, "fuego1_0.timp");
	frFuego11.loadFromRAR(tmpch, "fuego1_1.timp");
	
	
	for (i=0; i < MAXENE_GEN3; i++) {
		navegrande[i] = new GeneralNivel3(3);
		navegrande[i]->addFrame(frNave0);
		navegrande[i]->addFrame(frNave1);
		navegrande[i]->addFrame(frNave2);
		navegrande[i]->sombra->addFrame(frSombra);
		navegrande[i]->fuego0->addFrame(frFuego00);
		navegrande[i]->fuego0->addFrame(frFuego01);
		navegrande[i]->fuego1->addFrame(frFuego10);
		navegrande[i]->fuego1->addFrame(frFuego11);
		navegrande[i]->setTipoElemento(NAVEGRANDE);
		navegrande[i]->selFrame(0);
	}
	
	// cargar nave zepelin
	
	frNave0.loadFromRAR (tmpch, "zepelin_0.timp");	
	frNave1.loadFromRAR(tmpch, "zepelin_1.timp");
	frNave2.loadFromRAR(tmpch, "zepelin_2.timp");
	
	frSombra.loadFromRAR(tmpch, "zepelin_sombra.timp");
	
	frFuego00.loadFromRAR(tmpch, "fuego0_0.timp");
	frFuego01.loadFromRAR(tmpch, "fuego0_1.timp");

	frFuego10.loadFromRAR(tmpch, "fuego1_0.timp");
	frFuego11.loadFromRAR(tmpch, "fuego1_1.timp");
	
	for (i=0; i < MAXENE_GEN3; i++) {
		navezepelin[i] = new GeneralNivel3(3);
		navezepelin[i]->addFrame(frNave0);
		navezepelin[i]->addFrame(frNave1);
		navezepelin[i]->addFrame(frNave2);
		navezepelin[i]->sombra->addFrame(frSombra);
		navezepelin[i]->fuego0->addFrame(frFuego00);
		navezepelin[i]->fuego0->addFrame(frFuego01);
		navezepelin[i]->fuego1->addFrame(frFuego10);
		navezepelin[i]->fuego1->addFrame(frFuego11);
		navezepelin[i]->setTipoElemento(NAVEZEPELIN);
		navezepelin[i]->selFrame(0);
	}
	
	// cargar nave rascacio
	
	frNave0.loadFromRAR (tmpch, "rascasio_0.timp");	
	frNave1.loadFromRAR(tmpch, "rascasio_1.timp");
	frNave2.loadFromRAR(tmpch, "rascasio_2.timp");
	
	frSombra.loadFromRAR(tmpch, "rascasio_sombra.timp");
	
	frFuego00.loadFromRAR(tmpch, "fuego0_0.timp");
	frFuego01.loadFromRAR(tmpch, "fuego0_1.timp");

	frFuego10.loadFromRAR(tmpch, "fuego1_0.timp");
	frFuego11.loadFromRAR(tmpch, "fuego1_1.timp");
	
	for (i=0; i < MAXENE_GEN3; i++) {
		naverascasio[i] = new GeneralNivel3(3);
		naverascasio[i]->addFrame(frNave0);
		naverascasio[i]->addFrame(frNave1);
		naverascasio[i]->addFrame(frNave2);
		naverascasio[i]->sombra->addFrame(frSombra);
		naverascasio[i]->fuego0->addFrame(frFuego00);
		naverascasio[i]->fuego0->addFrame(frFuego01);
		naverascasio[i]->fuego1->addFrame(frFuego10);
		naverascasio[i]->fuego1->addFrame(frFuego11);
		naverascasio[i]->setTipoElemento(NAVERASCASIO);
		naverascasio[i]->selFrame(0);
	}
	
	cargando->unLoad();
	
	printf("Cargados elementos comunes\n");
}

void Pantalla::initNivelComoJugar () {
	printf("Cargando elementos del nivel como jugar\n");

	char tmpch[127];
		
	barradecarga->setTotalCarga(2);
	barradecarga->setPosicion((pantalla_w/2), 400);

	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando mapa", 255, 230, 23, 0,0,0, 320, screen_h-40);
	printf("Creando mapa\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	mapa->CargarNivel (1, screen);
	
	movJugadorComoJugar.resize(0);
	
	ControlMovJugadorComoJugar auxControl;
	
	auxControl.derecha = true;
	auxControl.izquierda = false;
	auxControl.arriba = true;
	auxControl.abajo = false;
	auxControl.ciclo_in = 160;
	auxControl.ciclo_out = 180;
	
	movJugadorComoJugar.push_back(auxControl);
	
	auxControl.derecha = false;
	auxControl.izquierda = true;
	auxControl.arriba = false;
	auxControl.abajo = false;
	auxControl.ciclo_in = 180;
	auxControl.ciclo_out = 200;
	
	movJugadorComoJugar.push_back(auxControl);
	
	auxControl.derecha = false;
	auxControl.izquierda = false;
	auxControl.arriba = false;
	auxControl.abajo = true;
	auxControl.ciclo_in = 210;
	auxControl.ciclo_out = 230;
	
	movJugadorComoJugar.push_back(auxControl);
	
	auxControl.derecha = true;
	auxControl.izquierda = false;
	auxControl.arriba = false;
	auxControl.abajo = false;
	auxControl.ciclo_in = 260;
	auxControl.ciclo_out = 290;
	
	movJugadorComoJugar.push_back(auxControl);
	
	auxControl.derecha = false;
	auxControl.izquierda = true;
	auxControl.arriba = false;
	auxControl.abajo = false;
	auxControl.ciclo_in = 295;
	auxControl.ciclo_out = 325;
	movJugadorComoJugar.push_back(auxControl);
	
	auxControl.derecha = true;
	auxControl.izquierda = false;
	auxControl.arriba = true;
	auxControl.abajo = false;
	auxControl.ciclo_in = 470;
	auxControl.ciclo_out = 480;
	
	movJugadorComoJugar.push_back(auxControl);
	
	auxControl.derecha = false;
	auxControl.izquierda = false;
	auxControl.arriba = true;
	auxControl.abajo = false;
	auxControl.ciclo_in = 480;
	auxControl.ciclo_out = 495;
	
	movJugadorComoJugar.push_back(auxControl);
	
	auxControl.derecha = false;
	auxControl.izquierda = true;
	auxControl.arriba = false;
	auxControl.abajo = false;
	auxControl.ciclo_in = 560;
	auxControl.ciclo_out = 570;
	
	movJugadorComoJugar.push_back(auxControl);
	
	auxControl.derecha = false;
	auxControl.izquierda = false;
	auxControl.arriba = false;
	auxControl.abajo = true;
	auxControl.ciclo_in = 570;
	auxControl.ciclo_out = 595;
	
	movJugadorComoJugar.push_back(auxControl);
	
	sprintf (tmpch, "%s/comojugar.tim", DATA_DIR);
	
	Frame frPulsa;
	
	frPulsa.loadFromRAR(tmpch, "pulsa.timp");
	
	pulsaComoJugar = new Elemento();
	pulsaComoJugar->addFrame(frPulsa);
	pulsaComoJugar->setX(260);
	pulsaComoJugar->setY(420);
	pulsaComoJugar->setAlign(ALIGN_CENTER);
	pulsaComoJugar->setVAlign(VALIGN_CENTER);
	pulsaComoJugar->selFrame(0);
	
	Frame frFlechas0, frFlechas1;
	
	frFlechas0.loadFromRAR(tmpch, "flechas_poderes.timp");
	frFlechas1.loadFromRAR(tmpch, "flecha_intercom.timp");
	
	flechasComoJugar = new Elemento(2);
	flechasComoJugar->addFrame(frFlechas0);
	flechasComoJugar->addFrame(frFlechas1);
	flechasComoJugar->selFrame(0);

	
	// cargar cartel
	Frame frCartel0, frCartel1, frCartel2, frCartel3, frCartel4, frCartel5, frCartel6;
	Frame frCartel7, frCartel8, frCartel9, frCartel10, frCartel11;
	frCartel0.loadFromRAR(tmpch, "cartel_cursores.timp");
	frCartel1.loadFromRAR(tmpch, "cartel_disparo.timp");
	frCartel2.loadFromRAR(tmpch, "caja_poder_escudo.timp");
	frCartel3.loadFromRAR(tmpch, "caja_poder_bomba.timp");
	frCartel4.loadFromRAR(tmpch, "caja_poder_clonacion.timp");
	frCartel5.loadFromRAR(tmpch, "caja_poder_amarillo.timp");
	frCartel6.loadFromRAR(tmpch, "cartel_seleccionarpoder.timp");
	frCartel7.loadFromRAR(tmpch, "cartel_agregadores.timp");
	frCartel8.loadFromRAR(tmpch, "cartel_sobrepoderes.timp");
	frCartel9.loadFromRAR(tmpch, "cartel_usarpoder.timp");
	frCartel10.loadFromRAR(tmpch, "cartel_intercom.timp");
	frCartel11.loadFromRAR(tmpch, "cartel_final.timp");

	cartelComoJugar = new Elemento(12);
	cartelComoJugar->addFrame(frCartel0);
	cartelComoJugar->addFrame(frCartel1);
	cartelComoJugar->addFrame(frCartel2);
	cartelComoJugar->addFrame(frCartel3);
	cartelComoJugar->addFrame(frCartel4);
	cartelComoJugar->addFrame(frCartel5);
	cartelComoJugar->addFrame(frCartel6);
	cartelComoJugar->addFrame(frCartel7);
	cartelComoJugar->addFrame(frCartel8);
	cartelComoJugar->addFrame(frCartel9);
	cartelComoJugar->addFrame(frCartel10);
	cartelComoJugar->addFrame(frCartel11);
	cartelComoJugar->setX(270);
	cartelComoJugar->setY(220);
	cartelComoJugar->setAlign(ALIGN_CENTER);
	cartelComoJugar->setVAlign(VALIGN_CENTER);
	cartelComoJugar->selFrame(0);
	
	frameCartelMostrar = -1;
	
	printf("Cargado nivel como jugar\n");
	
}


void Pantalla::initNivel1 () {
	printf("Cargando elementos del nivel 1\n");
	int i;
	char tmpch[127];
		
	barradecarga->setTotalCarga(5);
	barradecarga->setPosicion((pantalla_w/2), 400);
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando enemigos marinos", 255, 230, 23, 0,0,0, 320, screen_h-40);
	printf("Creando enemigos marinos\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);

	initMarinos();
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando construcciones", 255, 230, 23, 0,0,0, 320, screen_h-40);
	printf("Creando construcciones\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	sprintf (tmpch, "%s/ene_fase.tim", DATA_DIR);
	
	// cargar casetas
	Frame frCaseta0, frCaseta1, frCaseta2;
	frCaseta0.loadFromRAR(tmpch, "caseta_0.timp");
	frCaseta1.loadFromRAR(tmpch, "caseta_1.timp");
	frCaseta2.loadFromRAR(tmpch, "caseta_2.timp");

	for (i=0; i < MAXENE_CONSTRUCCIONES; i++) {
		caseta[i] = new Construcciones(3);
		caseta[i]->addFrame(frCaseta0);
		caseta[i]->addFrame(frCaseta1);
		caseta[i]->addFrame(frCaseta2);
		caseta[i]->setTipoElemento(CASETA);
		caseta[i]->setImpactosParaMorir(IMPACTOS_CASETA);
		caseta[i]->selFrame(0);
	}
	
	char tmp[15];
	sprintf (tmp, "mina");
	Frame frMina0, frMina1, frMina2, frMina3, frMina4, frMina5, frMina6, frMina7, frMina8, frMina9;
	frMina0.loadFromRAR(tmpch, "mina0.timp");	
	frMina1.loadFromRAR(tmpch, "mina1.timp");
	frMina2.loadFromRAR(tmpch, "mina2.timp");
	frMina3.loadFromRAR(tmpch, "mina3.timp");
	frMina4.loadFromRAR(tmpch, "mina4.timp");	
	frMina5.loadFromRAR(tmpch, "mina5.timp");
	frMina6.loadFromRAR(tmpch, "mina6.timp");
	frMina7.loadFromRAR(tmpch, "mina7.timp");
	frMina8.loadFromRAR(tmpch, "mina8.timp");
	frMina9.loadFromRAR(tmpch, "mina9.timp");

	// cargar minas
	for (i=0; i < MAXENE_MINA; i++) {
		mina[i] = new Mina(10);
		mina[i]->setTipoElemento(MINA);
		mina[i]->setImpactosParaMorir(IMPACTOS_MINA);;

		mina[i]->addFrame(frMina0);
		mina[i]->addFrame(frMina1);
		mina[i]->addFrame(frMina2);
		mina[i]->addFrame(frMina3);
		mina[i]->addFrame(frMina4);
		mina[i]->addFrame(frMina5);
		mina[i]->addFrame(frMina6);
		mina[i]->addFrame(frMina7);
		mina[i]->addFrame(frMina8);
		mina[i]->addFrame(frMina9);
		mina[i]->selFrame(0);
	}

	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando mapa", 255, 230, 23, 0,0,0, 320, screen_h-40);
	printf("Creando mapa\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	mapa->CargarNivel (juego->getNivel(), screen);
	
	tiempo->CargarNiebla();
	tiempo->CargarNubes();
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando escenario y enemigo final", 255, 230, 23, 0,0,0, 320, screen_h-40);
	printf("Creando escenario y enemigo final\n");
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	jefe1 = new JefeFase1(screen);
	
	
	sprintf (tmpch, "%s/final1.tim", DATA_DIR);
	
	torrebal_der = new TorreBalneario(8);
	torrebal_izq = new TorreBalneario(8);
	
	Frame frTorre0, frTorre1, frTorre2, frTorre3, frTorre4;
	Frame frTorre5, frTorre6, frTorre7;
	
	frTorre0.loadFromRAR(tmpch, "torre0.timp");	
	frTorre1.loadFromRAR(tmpch, "torre1.timp");	
	frTorre2.loadFromRAR(tmpch, "torre2.timp");	
	frTorre3.loadFromRAR(tmpch, "torre3.timp");	
	frTorre4.loadFromRAR(tmpch, "torre4.timp");	
	frTorre5.loadFromRAR(tmpch, "torre5.timp");	
	frTorre6.loadFromRAR(tmpch, "torre6.timp");	
	frTorre7.loadFromRAR(tmpch, "torre7.timp");	
	
	torrebal_der->addFrame(frTorre0);
	torrebal_der->addFrame(frTorre1);
	torrebal_der->addFrame(frTorre2);
	torrebal_der->addFrame(frTorre3);
	torrebal_der->addFrame(frTorre4);
	torrebal_der->addFrame(frTorre5);
	torrebal_der->addFrame(frTorre6);
	torrebal_der->addFrame(frTorre7);
	torrebal_der->setX(470);
	torrebal_der->setY(100);
	
	torrebal_izq->addFrame(frTorre0);
	torrebal_izq->addFrame(frTorre1);
	torrebal_izq->addFrame(frTorre2);
	torrebal_izq->addFrame(frTorre3);
	torrebal_izq->addFrame(frTorre4);
	torrebal_izq->addFrame(frTorre5);
	torrebal_izq->addFrame(frTorre6);
	torrebal_izq->addFrame(frTorre7);
	torrebal_izq->setX(-8);
	torrebal_izq->setY(100);
	
	printf("Cargado nivel 1\n");
	
}

void Pantalla::initFinalNivel1 () {
	printf("Cargando elementos del final del nivel 1\n");
	// iniciamos elementos
	torrebal_izq->iniciar();
	torrebal_izq->setActivo(1);
	torrebal_der->iniciar();
	torrebal_der->setActivo(1);
	
	jugador->getDisparoJugador()->iniciar();
	
	// colocamos al jugador en su sitio
	jugador->setX(260-jugador->getAncho()/2);
	jugador->setY(380);
	
	// termina la musica
	sonido->terminarMusica();
	setFinal(juego->getCiclos());
	juego->setZonaSobrepasada(2);
	
	mitadLogoAbajo->setY(480);
	mitadLogoAbajo->setDY(-20);
	mitadLogoArriba->setY(-240);
	mitadLogoArriba->setDY(20);
	
	sonido->playSonido(SND_COMP_CERRAR);
	
	juego->setMapaParado(true);
}

void Pantalla::initFinalNivel3 () {
	printf("Cargando elementos del final del nivel 3\n");

	int i;	
	jugador->getDisparoJugador()->iniciar();
	
	for (i=0; i < 3; i++) {
		jefe3[i]->iniciar();
	}
	
	biopic->iniciar();
	
	// colocamos al jugador en su sitio
	jugador->setX(260-jugador->getAncho()/2);
	jugador->setY(380);
	
	sonido->terminarMusica();
	setFinal(juego->getCiclos());
	
	juego->setZonaSobrepasada(2);
	
	crearFiestaFinal3 = false;
	
	mitadLogoAbajo->setY(480);
	mitadLogoAbajo->setDY(-20);
	mitadLogoArriba->setY(-240);
	mitadLogoArriba->setDY(20);
	
	sonido->playSonido(SND_COMP_CERRAR);
	
	juego->setMapaParado(true);
	
}

void Pantalla::initFinalNivel2 () {
	printf("Cargando elementos del final del nivel 2\n");

	jugador->getDisparoJugador()->iniciar();
	
	jefe2->iniciar();
	
	mapaagua->Cargar(screen);
	
	// colocamos al jugador en su sitio
	jugador->setX(260-jugador->getAncho()/2);
	jugador->setY(380);
	
	sonido->terminarMusica();
	setFinal(juego->getCiclos());
	
	juego->setZonaSobrepasada(2);
	
	mitadLogoAbajo->setY(480);
	mitadLogoAbajo->setDY(-20);
	mitadLogoArriba->setY(-240);
	mitadLogoArriba->setDY(20);

	sonido->playSonido(SND_COMP_CERRAR);
	
	juego->setMapaParado(true);
		
}


void Pantalla::initMarinos () {
	
	int i;
	char tmpch[127];
	
	// cargar cangrejos
	
	Frame frMarino0, frMarino1, frMarino2, frMarino3, frMarino4, frMarino5, frMarino6;
	
	sprintf (tmpch, "%s/ene_fase.tim", DATA_DIR);
	frMarino0.loadFromRAR(tmpch, "cangrebot_0.timp");
	frMarino1.loadFromRAR(tmpch, "cangrebot_1.timp");
	frMarino2.loadFromRAR(tmpch, "cangrebot_2.timp");
	frMarino3.loadFromRAR(tmpch, "cangrebot_3.timp");
	frMarino4.loadFromRAR(tmpch, "cangrebot_4.timp");
	frMarino5.loadFromRAR(tmpch, "cangrebot_5.timp");
	frMarino6.loadFromRAR(tmpch, "cangrebot_6.timp");
	
	for (i=0; i < MAXENE_MARINOS; i++) {
		cangrejo[i] = new Marinos(7);
		cangrejo[i]->addFrame(frMarino0);
		cangrejo[i]->addFrame(frMarino1);
		cangrejo[i]->addFrame(frMarino2);
		cangrejo[i]->addFrame(frMarino3);
		cangrejo[i]->addFrame(frMarino4);
		cangrejo[i]->addFrame(frMarino5);
		cangrejo[i]->addFrame(frMarino6);
		cangrejo[i]->setTipoElemento(CANGREBOT);
		cangrejo[i]->setImpactosParaMorir(IMPACTOS_CANGREBOT);
		cangrejo[i]->selFrame(0);
	}
	
	frMarino0.loadFromRAR(tmpch, "purpito_0.timp");
	frMarino1.loadFromRAR(tmpch, "purpito_1.timp");
	frMarino2.loadFromRAR(tmpch, "purpito_2.timp");
	frMarino3.loadFromRAR(tmpch, "purpito_3.timp");
	frMarino4.loadFromRAR(tmpch, "purpito_4.timp");
	frMarino5.loadFromRAR(tmpch, "purpito_5.timp");
	frMarino6.loadFromRAR(tmpch, "purpito_6.timp");
	
	for (i=0; i < MAXENE_MARINOS; i++) {
		pulpo[i] = new Marinos(7);
		pulpo[i]->addFrame(frMarino0);
		pulpo[i]->addFrame(frMarino1);
		pulpo[i]->addFrame(frMarino2);
		pulpo[i]->addFrame(frMarino3);
		pulpo[i]->addFrame(frMarino4);
		pulpo[i]->addFrame(frMarino5);
		pulpo[i]->addFrame(frMarino6);
		pulpo[i]->setTipoElemento(PULPO);
		pulpo[i]->setImpactosParaMorir(IMPACTOS_PULPO);
		pulpo[i]->selFrame(0);
	}

	// cargar lanchas
	Frame frLancha0, frLancha1, frLancha2, frLancha3, frLancha4, frLancha5; 
	Frame frLancha6, frLancha7, frLancha8, frLancha9, frLancha10, frLancha11;
	Frame frLancha12, frLancha13, frLancha14, frLancha15, frLancha16, frLancha17;
	Frame frLancha18, frLancha19, frLancha20, frLancha21, frLancha22, frLancha23;
	Frame frLancha24, frLancha25, frLancha26, frLancha27, frLancha28, frLancha29;
	Frame frLancha30, frLancha31;
	
	frLancha0.loadFromRAR(tmpch, "lancha_0.timp");
	frLancha1.loadFromRAR(tmpch, "lancha_1.timp");
	frLancha2.loadFromRAR(tmpch, "lancha_2.timp");
	frLancha3.loadFromRAR(tmpch, "lancha_3.timp");
	frLancha4.loadFromRAR(tmpch, "lancha_4.timp");
	frLancha5.loadFromRAR(tmpch, "lancha_5.timp");
	frLancha6.loadFromRAR(tmpch, "lancha_6.timp");
	frLancha7.loadFromRAR(tmpch, "lancha_7.timp");
	frLancha8.loadFromRAR(tmpch, "lancha_8.timp");
	frLancha9.loadFromRAR(tmpch, "lancha_9.timp");
	frLancha10.loadFromRAR(tmpch, "lancha_10.timp");
	frLancha11.loadFromRAR(tmpch, "lancha_11.timp");
	frLancha12.loadFromRAR(tmpch, "lancha_12.timp");
	frLancha13.loadFromRAR(tmpch, "lancha_13.timp");
	frLancha14.loadFromRAR(tmpch, "lancha_14.timp");
	frLancha15.loadFromRAR(tmpch, "lancha_15.timp");
	
	frLancha16.loadFromRAR(tmpch, "lancha_0b.timp");
	frLancha17.loadFromRAR(tmpch, "lancha_1b.timp");
	frLancha18.loadFromRAR(tmpch, "lancha_2b.timp");
	frLancha19.loadFromRAR(tmpch, "lancha_3b.timp");
	frLancha20.loadFromRAR(tmpch, "lancha_4b.timp");
	frLancha21.loadFromRAR(tmpch, "lancha_5b.timp");
	frLancha22.loadFromRAR(tmpch, "lancha_6b.timp");
	frLancha23.loadFromRAR(tmpch, "lancha_7b.timp");
	frLancha24.loadFromRAR(tmpch, "lancha_8b.timp");
	frLancha25.loadFromRAR(tmpch, "lancha_9b.timp");
	frLancha26.loadFromRAR(tmpch, "lancha_10b.timp");
	frLancha27.loadFromRAR(tmpch, "lancha_11b.timp");
	frLancha28.loadFromRAR(tmpch, "lancha_12b.timp");
	frLancha29.loadFromRAR(tmpch, "lancha_13b.timp");
	frLancha30.loadFromRAR(tmpch, "lancha_14b.timp");
	frLancha31.loadFromRAR(tmpch, "lancha_15b.timp");
	
	for (i=0; i < MAXENE_AUTOMARINO; i++) {
		lancha[i] = new AutoMarino(32);
		lancha[i]->addFrame(frLancha0);
		lancha[i]->addFrame(frLancha1);
		lancha[i]->addFrame(frLancha2);
		lancha[i]->addFrame(frLancha3);
		lancha[i]->addFrame(frLancha4);
		lancha[i]->addFrame(frLancha5);
		lancha[i]->addFrame(frLancha6);
		lancha[i]->addFrame(frLancha7);
		lancha[i]->addFrame(frLancha8);
		lancha[i]->addFrame(frLancha9);
		lancha[i]->addFrame(frLancha10);
		lancha[i]->addFrame(frLancha11);
		lancha[i]->addFrame(frLancha12);
		lancha[i]->addFrame(frLancha13);
		lancha[i]->addFrame(frLancha14);
		lancha[i]->addFrame(frLancha15);
		lancha[i]->addFrame(frLancha16);
		lancha[i]->addFrame(frLancha17);
		lancha[i]->addFrame(frLancha18);
		lancha[i]->addFrame(frLancha19);
		lancha[i]->addFrame(frLancha20);
		lancha[i]->addFrame(frLancha21);
		lancha[i]->addFrame(frLancha22);
		lancha[i]->addFrame(frLancha23);
		lancha[i]->addFrame(frLancha24);
		lancha[i]->addFrame(frLancha25);
		lancha[i]->addFrame(frLancha26);
		lancha[i]->addFrame(frLancha27);
		lancha[i]->addFrame(frLancha28);
		lancha[i]->addFrame(frLancha29);
		lancha[i]->addFrame(frLancha30);
		lancha[i]->addFrame(frLancha31);
		lancha[i]->setTipoElemento(LANCHA);
		lancha[i]->selFrame(0);
	}
	
	// yate
	
	Frame frYate0, frYate1, frYate2, frYate3, frYate4, frYate5; 
	Frame frYate6, frYate7, frYate8, frYate9, frYate10, frYate11;
	Frame frYate12, frYate13, frYate14, frYate15, frYate16, frYate17;
	Frame frYate18, frYate19, frYate20, frYate21, frYate22, frYate23;
	
	frYate0.loadFromRAR(tmpch, "barkito_0.timp");
	frYate1.loadFromRAR(tmpch, "barkito_1.timp");
	frYate2.loadFromRAR(tmpch, "barkito_2.timp");
	frYate3.loadFromRAR(tmpch, "barkito_3.timp");
	frYate4.loadFromRAR(tmpch, "barkito_4.timp");
	frYate5.loadFromRAR(tmpch, "barkito_5.timp");
	frYate6.loadFromRAR(tmpch, "barkito_6.timp");
	frYate7.loadFromRAR(tmpch, "barkito_7.timp");
	frYate8.loadFromRAR(tmpch, "barkito_8.timp");
	frYate9.loadFromRAR(tmpch, "barkito_9.timp");
	frYate10.loadFromRAR(tmpch, "barkito_10.timp");
	frYate11.loadFromRAR(tmpch, "barkito_11.timp");
	frYate12.loadFromRAR(tmpch, "barkito_12.timp");
	frYate13.loadFromRAR(tmpch, "barkito_13.timp");
	frYate14.loadFromRAR(tmpch, "barkito_14.timp");
	frYate15.loadFromRAR(tmpch, "barkito_15.timp");
	
	frYate16.loadFromRAR(tmpch, "barkito_torre0.timp");
	frYate17.loadFromRAR(tmpch, "barkito_torre1.timp");
	frYate18.loadFromRAR(tmpch, "barkito_torre2.timp");
	frYate19.loadFromRAR(tmpch, "barkito_torre3.timp");
	frYate20.loadFromRAR(tmpch, "barkito_torre4.timp");
	frYate21.loadFromRAR(tmpch, "barkito_torre5.timp");
	frYate22.loadFromRAR(tmpch, "barkito_torre6.timp");
	frYate23.loadFromRAR(tmpch, "barkito_torre7.timp");
	
	
	for (i=0; i < MAXENE_TANQUE; i++) {
		yate[i] = new Yate(24);
		yate[i]->addFrame(frYate0);
		yate[i]->addFrame(frYate1);
		yate[i]->addFrame(frYate2);
		yate[i]->addFrame(frYate3);
		yate[i]->addFrame(frYate4);
		yate[i]->addFrame(frYate5);
		yate[i]->addFrame(frYate6);
		yate[i]->addFrame(frYate7);
		yate[i]->addFrame(frYate8);
		yate[i]->addFrame(frYate9);
		yate[i]->addFrame(frYate10);
		yate[i]->addFrame(frYate11);
		yate[i]->addFrame(frYate12);
		yate[i]->addFrame(frYate13);
		yate[i]->addFrame(frYate14);
		yate[i]->addFrame(frYate15);
		yate[i]->addFrame(frYate16);
		yate[i]->addFrame(frYate17);
		yate[i]->addFrame(frYate18);
		yate[i]->addFrame(frYate19);
		yate[i]->addFrame(frYate20);
		yate[i]->addFrame(frYate21);
		yate[i]->addFrame(frYate22);
		yate[i]->addFrame(frYate23);
		yate[i]->setTipoElemento(YATE);
		yate[i]->selFrame(0);
	}
	
}

void Pantalla::initAutomoviles () {
	int i;
	char tmpch[127];
	
	// cargar coche policia
	Frame frCPolicia0, frCPolicia1, frCPolicia2, frCPolicia3, frCPolicia4, frCPolicia5; 
	Frame frCPolicia6, frCPolicia7, frCPolicia8, frCPolicia9, frCPolicia10, frCPolicia11;
	Frame frCPolicia12, frCPolicia13, frCPolicia14, frCPolicia15, frCPolicia16, frCPolicia17;
	Frame frCPolicia18, frCPolicia19, frCPolicia20, frCPolicia21, frCPolicia22, frCPolicia23;
	Frame frCPolicia24, frCPolicia25, frCPolicia26, frCPolicia27, frCPolicia28, frCPolicia29;
	Frame frCPolicia30, frCPolicia31;
	
	sprintf (tmpch, "%s/ene_fase.tim", DATA_DIR);
	
	frCPolicia0.loadFromRAR(tmpch, "cpolicia_0.timp");
	frCPolicia1.loadFromRAR(tmpch, "cpolicia_1.timp");
	frCPolicia2.loadFromRAR(tmpch, "cpolicia_2.timp");
	frCPolicia3.loadFromRAR(tmpch, "cpolicia_3.timp");
	frCPolicia4.loadFromRAR(tmpch, "cpolicia_4.timp");
	frCPolicia5.loadFromRAR(tmpch, "cpolicia_5.timp");
	frCPolicia6.loadFromRAR(tmpch, "cpolicia_6.timp");
	frCPolicia7.loadFromRAR(tmpch, "cpolicia_7.timp");
	frCPolicia8.loadFromRAR(tmpch, "cpolicia_8.timp");
	frCPolicia9.loadFromRAR(tmpch, "cpolicia_9.timp");
	frCPolicia10.loadFromRAR(tmpch, "cpolicia_10.timp");
	frCPolicia11.loadFromRAR(tmpch, "cpolicia_11.timp");
	frCPolicia12.loadFromRAR(tmpch, "cpolicia_12.timp");
	frCPolicia13.loadFromRAR(tmpch, "cpolicia_13.timp");
	frCPolicia14.loadFromRAR(tmpch, "cpolicia_14.timp");
	frCPolicia15.loadFromRAR(tmpch, "cpolicia_15.timp");
	
	frCPolicia16.loadFromRAR(tmpch, "cpolicia_0b.timp");
	frCPolicia17.loadFromRAR(tmpch, "cpolicia_1b.timp");
	frCPolicia18.loadFromRAR(tmpch, "cpolicia_2b.timp");
	frCPolicia19.loadFromRAR(tmpch, "cpolicia_3b.timp");
	frCPolicia20.loadFromRAR(tmpch, "cpolicia_4b.timp");
	frCPolicia21.loadFromRAR(tmpch, "cpolicia_5b.timp");
	frCPolicia22.loadFromRAR(tmpch, "cpolicia_6b.timp");
	frCPolicia23.loadFromRAR(tmpch, "cpolicia_7b.timp");
	frCPolicia24.loadFromRAR(tmpch, "cpolicia_8b.timp");
	frCPolicia25.loadFromRAR(tmpch, "cpolicia_9b.timp");
	frCPolicia26.loadFromRAR(tmpch, "cpolicia_10b.timp");
	frCPolicia27.loadFromRAR(tmpch, "cpolicia_11b.timp");
	frCPolicia28.loadFromRAR(tmpch, "cpolicia_12b.timp");
	frCPolicia29.loadFromRAR(tmpch, "cpolicia_13b.timp");
	frCPolicia30.loadFromRAR(tmpch, "cpolicia_14b.timp");
	frCPolicia31.loadFromRAR(tmpch, "cpolicia_15b.timp");
	
	for (i=0; i < MAXENE_CPOLICIA; i++) {
		cpolicia[i] = new CochePolicia(32);
		cpolicia[i]->addFrame(frCPolicia0);
		cpolicia[i]->addFrame(frCPolicia1);
		cpolicia[i]->addFrame(frCPolicia2);
		cpolicia[i]->addFrame(frCPolicia3);
		cpolicia[i]->addFrame(frCPolicia4);
		cpolicia[i]->addFrame(frCPolicia5);
		cpolicia[i]->addFrame(frCPolicia6);
		cpolicia[i]->addFrame(frCPolicia7);
		cpolicia[i]->addFrame(frCPolicia8);
		cpolicia[i]->addFrame(frCPolicia9);
		cpolicia[i]->addFrame(frCPolicia10);
		cpolicia[i]->addFrame(frCPolicia11);
		cpolicia[i]->addFrame(frCPolicia12);
		cpolicia[i]->addFrame(frCPolicia13);
		cpolicia[i]->addFrame(frCPolicia14);
		cpolicia[i]->addFrame(frCPolicia15);
		cpolicia[i]->addFrame(frCPolicia16);
		cpolicia[i]->addFrame(frCPolicia17);
		cpolicia[i]->addFrame(frCPolicia18);
		cpolicia[i]->addFrame(frCPolicia19);
		cpolicia[i]->addFrame(frCPolicia20);
		cpolicia[i]->addFrame(frCPolicia21);
		cpolicia[i]->addFrame(frCPolicia22);
		cpolicia[i]->addFrame(frCPolicia23);
		cpolicia[i]->addFrame(frCPolicia24);
		cpolicia[i]->addFrame(frCPolicia25);
		cpolicia[i]->addFrame(frCPolicia26);
		cpolicia[i]->addFrame(frCPolicia27);
		cpolicia[i]->addFrame(frCPolicia28);
		cpolicia[i]->addFrame(frCPolicia29);
		cpolicia[i]->addFrame(frCPolicia30);
		cpolicia[i]->addFrame(frCPolicia31);
		cpolicia[i]->setTipoElemento(COCHE_POLICIA);
		cpolicia[i]->selFrame(0);
	}
	
	// tanque
	
	Frame frTanque0, frTanque1, frTanque2, frTanque3, frTanque4, frTanque5; 
	Frame frTanque6, frTanque7, frTanque8, frTanque9, frTanque10, frTanque11;
	Frame frTanque12, frTanque13, frTanque14, frTanque15, frTanque16, frTanque17;
	Frame frTanque18, frTanque19, frTanque20, frTanque21, frTanque22, frTanque23;
	
	frTanque0.loadFromRAR(tmpch, "tanquecuerpo_0.timp");
	frTanque1.loadFromRAR(tmpch, "tanquecuerpo_1.timp");
	frTanque2.loadFromRAR(tmpch, "tanquecuerpo_2.timp");
	frTanque3.loadFromRAR(tmpch, "tanquecuerpo_3.timp");
	frTanque4.loadFromRAR(tmpch, "tanquecuerpo_4.timp");
	frTanque5.loadFromRAR(tmpch, "tanquecuerpo_5.timp");
	frTanque6.loadFromRAR(tmpch, "tanquecuerpo_6.timp");
	frTanque7.loadFromRAR(tmpch, "tanquecuerpo_7.timp");
	frTanque8.loadFromRAR(tmpch, "tanquecuerpo_8.timp");
	frTanque9.loadFromRAR(tmpch, "tanquecuerpo_9.timp");
	frTanque10.loadFromRAR(tmpch, "tanquecuerpo_10.timp");
	frTanque11.loadFromRAR(tmpch, "tanquecuerpo_11.timp");
	frTanque12.loadFromRAR(tmpch, "tanquecuerpo_12.timp");
	frTanque13.loadFromRAR(tmpch, "tanquecuerpo_13.timp");
	frTanque14.loadFromRAR(tmpch, "tanquecuerpo_14.timp");
	frTanque15.loadFromRAR(tmpch, "tanquecuerpo_15.timp");
	
	frTanque16.loadFromRAR(tmpch, "tanquetorreta_0.timp");
	frTanque17.loadFromRAR(tmpch, "tanquetorreta_1.timp");
	frTanque18.loadFromRAR(tmpch, "tanquetorreta_2.timp");
	frTanque19.loadFromRAR(tmpch, "tanquetorreta_3.timp");
	frTanque20.loadFromRAR(tmpch, "tanquetorreta_4.timp");
	frTanque21.loadFromRAR(tmpch, "tanquetorreta_5.timp");
	frTanque22.loadFromRAR(tmpch, "tanquetorreta_6.timp");
	frTanque23.loadFromRAR(tmpch, "tanquetorreta_7.timp");
	
	
	for (i=0; i < MAXENE_TANQUE; i++) {
		tanque[i] = new Tanque(24);
		tanque[i]->addFrame(frTanque0);
		tanque[i]->addFrame(frTanque1);
		tanque[i]->addFrame(frTanque2);
		tanque[i]->addFrame(frTanque3);
		tanque[i]->addFrame(frTanque4);
		tanque[i]->addFrame(frTanque5);
		tanque[i]->addFrame(frTanque6);
		tanque[i]->addFrame(frTanque7);
		tanque[i]->addFrame(frTanque8);
		tanque[i]->addFrame(frTanque9);
		tanque[i]->addFrame(frTanque10);
		tanque[i]->addFrame(frTanque11);
		tanque[i]->addFrame(frTanque12);
		tanque[i]->addFrame(frTanque13);
		tanque[i]->addFrame(frTanque14);
		tanque[i]->addFrame(frTanque15);
		tanque[i]->addFrame(frTanque16);
		tanque[i]->addFrame(frTanque17);
		tanque[i]->addFrame(frTanque18);
		tanque[i]->addFrame(frTanque19);
		tanque[i]->addFrame(frTanque20);
		tanque[i]->addFrame(frTanque21);
		tanque[i]->addFrame(frTanque22);
		tanque[i]->addFrame(frTanque23);
		tanque[i]->setTipoElemento(TANQUE);
		tanque[i]->selFrame(0);
	}
	

	// taxi
	
	Frame frTaxi0, frTaxi1, frTaxi2, frTaxi3, frTaxi4, frTaxi5; 
	Frame frTaxi6, frTaxi7, frTaxi8, frTaxi9, frTaxi10, frTaxi11;
	Frame frTaxi12, frTaxi13, frTaxi14, frTaxi15;
	
	frTaxi0.loadFromRAR(tmpch, "taxi_0.timp");
	frTaxi1.loadFromRAR(tmpch, "taxi_1.timp");
	frTaxi2.loadFromRAR(tmpch, "taxi_2.timp");
	frTaxi3.loadFromRAR(tmpch, "taxi_3.timp");
	frTaxi4.loadFromRAR(tmpch, "taxi_4.timp");
	frTaxi5.loadFromRAR(tmpch, "taxi_5.timp");
	frTaxi6.loadFromRAR(tmpch, "taxi_6.timp");
	frTaxi7.loadFromRAR(tmpch, "taxi_7.timp");
	frTaxi8.loadFromRAR(tmpch, "taxi_8.timp");
	frTaxi9.loadFromRAR(tmpch, "taxi_9.timp");
	frTaxi10.loadFromRAR(tmpch, "taxi_10.timp");
	frTaxi11.loadFromRAR(tmpch, "taxi_11.timp");
	frTaxi12.loadFromRAR(tmpch, "taxi_12.timp");
	frTaxi13.loadFromRAR(tmpch, "taxi_13.timp");
	frTaxi14.loadFromRAR(tmpch, "taxi_14.timp");
	frTaxi15.loadFromRAR(tmpch, "taxi_15.timp");
	
	for (i=0; i < MAXENE_TAXI; i++) {
		taxi[i] = new Taxi(16);
		taxi[i]->addFrame(frTaxi0);
		taxi[i]->addFrame(frTaxi1);
		taxi[i]->addFrame(frTaxi2);
		taxi[i]->addFrame(frTaxi3);
		taxi[i]->addFrame(frTaxi4);
		taxi[i]->addFrame(frTaxi5);
		taxi[i]->addFrame(frTaxi6);
		taxi[i]->addFrame(frTaxi7);
		taxi[i]->addFrame(frTaxi8);
		taxi[i]->addFrame(frTaxi9);
		taxi[i]->addFrame(frTaxi10);
		taxi[i]->addFrame(frTaxi11);
		taxi[i]->addFrame(frTaxi12);
		taxi[i]->addFrame(frTaxi13);
		taxi[i]->addFrame(frTaxi14);
		taxi[i]->addFrame(frTaxi15);
		taxi[i]->setTipoElemento(TAXI);
		taxi[i]->selFrame(0);
	}


	// coche simple
	
	Frame frCS0, frCS1, frCS2, frCS3, frCS4, frCS5, frCS6, frCS7; 
	Frame frCS8, frCS9, frCS10, frCS11, frCS12, frCS13;
	Frame frCS14, frCS15, frCS16, frCS17, frCS18, frCS19;
	Frame frCS20, frCS21, frCS22, frCS23, frCS24, frCS25, frCS26, frCS27;
	
	frCS0.loadFromRAR(tmpch, "cmercedes_cr0.timp");
	frCS1.loadFromRAR(tmpch, "cmercedes_cr1.timp");
	frCS2.loadFromRAR(tmpch, "cmercedes_gr0.timp");
	frCS3.loadFromRAR(tmpch, "cmercedes_gr1.timp");
	frCS4.loadFromRAR(tmpch, "cmercedes_rj0.timp");
	frCS5.loadFromRAR(tmpch, "cmercedes_rj1.timp");
	frCS6.loadFromRAR(tmpch, "cautobus_0.timp");
	frCS7.loadFromRAR(tmpch, "cautobus_1.timp");
	frCS8.loadFromRAR(tmpch, "ckadett_az0.timp");
	frCS9.loadFromRAR(tmpch, "ckadett_az1.timp");
	frCS10.loadFromRAR(tmpch, "ckadett_rj0.timp");
	frCS11.loadFromRAR(tmpch, "ckadett_rj1.timp");
	frCS12.loadFromRAR(tmpch, "ckadett_vd0.timp");
	frCS13.loadFromRAR(tmpch, "ckadett_vd1.timp");
	frCS14.loadFromRAR(tmpch, "cpicasso_az0.timp");
	frCS15.loadFromRAR(tmpch, "cpicasso_az1.timp");
	frCS16.loadFromRAR(tmpch, "cpicasso_gr0.timp");
	frCS17.loadFromRAR(tmpch, "cpicasso_gr1.timp");
	frCS18.loadFromRAR(tmpch, "cpicasso_vi0.timp");
	frCS19.loadFromRAR(tmpch, "cpicasso_vi1.timp");
	frCS20.loadFromRAR(tmpch, "cseicento_gr0.timp");
	frCS21.loadFromRAR(tmpch, "cseicento_gr1.timp");
	frCS22.loadFromRAR(tmpch, "csmart_am0.timp");
	frCS23.loadFromRAR(tmpch, "csmart_am1.timp");
	frCS24.loadFromRAR(tmpch, "csmart_az0.timp");
	frCS25.loadFromRAR(tmpch, "csmart_az1.timp");
	frCS26.loadFromRAR(tmpch, "csmart_ve0.timp");
	frCS27.loadFromRAR(tmpch, "csmart_ve1.timp");
	
	
	for (i=0; i < MAXENE_CSIMPLE; i++) {
		csimple[i] = new CocheSimple(28);
		csimple[i]->addFrame(frCS0);
		csimple[i]->addFrame(frCS1);
		csimple[i]->addFrame(frCS2);
		csimple[i]->addFrame(frCS3);
		csimple[i]->addFrame(frCS4);
		csimple[i]->addFrame(frCS5);
		csimple[i]->addFrame(frCS6);
		csimple[i]->addFrame(frCS7);
		csimple[i]->addFrame(frCS8);
		csimple[i]->addFrame(frCS9);
		csimple[i]->addFrame(frCS10);
		csimple[i]->addFrame(frCS11);
		csimple[i]->addFrame(frCS12);
		csimple[i]->addFrame(frCS13);
		csimple[i]->addFrame(frCS14);
		csimple[i]->addFrame(frCS15);
		csimple[i]->addFrame(frCS16);
		csimple[i]->addFrame(frCS17);
		csimple[i]->addFrame(frCS18);
		csimple[i]->addFrame(frCS19);
		csimple[i]->addFrame(frCS20);
		csimple[i]->addFrame(frCS21);
		csimple[i]->addFrame(frCS22);
		csimple[i]->addFrame(frCS23);
		csimple[i]->addFrame(frCS24);
		csimple[i]->addFrame(frCS25);
		csimple[i]->addFrame(frCS26);
		csimple[i]->addFrame(frCS27);
		csimple[i]->setTipoElemento(COCHESIMPLE);
	}
	
	
	Frame frValla0, frValla1;
	
	frValla0.loadFromRAR(tmpch, "barrera0_0.timp");
	frValla1.loadFromRAR(tmpch, "barrera0_1.timp");
	
	for (i=0; i < MAXENE_BARRERAS; i++) {
		valla_izq[i] = new Construcciones(2);
		valla_izq[i]->addFrame(frValla0);
		valla_izq[i]->addFrame(frValla1);
		valla_izq[i]->setTipoElemento(VALLA_IZQ);
		valla_izq[i]->setImpactosParaMorir(IMPACTOS_BARRERA);
	}
	
	frValla0.loadFromRAR(tmpch, "barrera1_0.timp");
	frValla1.loadFromRAR(tmpch, "barrera1_1.timp");
	
	for (i=0; i < MAXENE_BARRERAS; i++) {
		valla_der[i] = new Construcciones(2);
		valla_der[i]->addFrame(frValla0);
		valla_der[i]->addFrame(frValla1);
		valla_der[i]->setTipoElemento(VALLA_DER);
		valla_der[i]->setImpactosParaMorir(IMPACTOS_BARRERA);
	}
	
	frValla0.loadFromRAR(tmpch, "barrera2_0.timp");
	frValla1.loadFromRAR(tmpch, "barrera2_1.timp");
	
	for (i=0; i < MAXENE_BARRERAS; i++) {
		barrera_izq[i] = new Construcciones(2);
		barrera_izq[i]->addFrame(frValla0);
		barrera_izq[i]->addFrame(frValla1);
		barrera_izq[i]->setTipoElemento(BARRERA_IZQ);
		barrera_izq[i]->setImpactosParaMorir(IMPACTOS_BARRERA);
	}
	
	frValla0.loadFromRAR(tmpch, "barrera3_0.timp");
	frValla1.loadFromRAR(tmpch, "barrera3_1.timp");
	
	for (i=0; i < MAXENE_BARRERAS; i++) {
		barrera_der[i] = new Construcciones(2);
		barrera_der[i]->addFrame(frValla0);
		barrera_der[i]->addFrame(frValla1);
		barrera_der[i]->setTipoElemento(BARRERA_DER);
		barrera_der[i]->setImpactosParaMorir(IMPACTOS_BARRERA);
	}
}

void Pantalla::initNivel3 () {
	printf("Cargando elementos del nivel 3\n");
	
	int i;
	char tmpch[127];
	
	barradecarga->setTotalCarga(6);
	barradecarga->setPosicion((pantalla_w/2), 400);
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando coches", 255, 230, 23, 0,0,0, 320, screen_h-40);
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	initAutomoviles();
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando carrozas", 255, 230, 23, 0,0,0, 320, screen_h-40);
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// carrozas
	
	sprintf (tmpch, "%s/carrozas.tim", DATA_DIR);
	
	Frame frCarroza0, frCarroza1, frCarroza2, frCarroza3; 
	Frame frCarroza4, frCarroza5, frCarroza6, frCarroza7; 
	Frame frCarroza8, frCarroza9, frCarroza10, frCarroza11; 
	Frame frCarroza12, frCarroza13, frCarroza14, frCarroza15; 
	
	frCarroza0.loadFromRAR(tmpch, "c_castillo0.timp");
	frCarroza1.loadFromRAR(tmpch, "c_castillo1.timp");
	frCarroza2.loadFromRAR(tmpch, "c_castillo2.timp");
	frCarroza3.loadFromRAR(tmpch, "c_castillo3.timp");
	frCarroza4.loadFromRAR(tmpch, "c_demonio0.timp");
	frCarroza5.loadFromRAR(tmpch, "c_demonio1.timp");
	frCarroza6.loadFromRAR(tmpch, "c_demonio2.timp");
	frCarroza7.loadFromRAR(tmpch, "c_demonio3.timp");
	frCarroza8.loadFromRAR(tmpch, "c_mar0.timp");
	frCarroza9.loadFromRAR(tmpch, "c_mar1.timp");
	frCarroza10.loadFromRAR(tmpch, "c_mar2.timp");
	frCarroza11.loadFromRAR(tmpch, "c_mar3.timp");
	frCarroza12.loadFromRAR(tmpch, "c_barco0.timp");
	frCarroza13.loadFromRAR(tmpch, "c_barco1.timp");
	frCarroza14.loadFromRAR(tmpch, "c_barco2.timp");
	frCarroza15.loadFromRAR(tmpch, "c_barco3.timp");
	
	Frame frFuego00, frFuego01, frFuego02, frFuego10, frFuego11, frFuego12;
	Frame frHumo0, frHumo1, frHumo2;
	
	frFuego00.loadFromRAR(tmpch, "fuego0_0.timp");
	frFuego01.loadFromRAR(tmpch, "fuego0_1.timp");
	frFuego02.loadFromRAR(tmpch, "fuego0_2.timp");

	frFuego10.loadFromRAR(tmpch, "fuego1_0.timp");
	frFuego11.loadFromRAR(tmpch, "fuego1_1.timp");
	frFuego12.loadFromRAR(tmpch, "fuego1_2.timp");
	
	frHumo0.loadFromRAR(tmpch, "humo0.timp");
	frHumo1.loadFromRAR(tmpch, "humo1.timp");
	frHumo2.loadFromRAR(tmpch, "humo2.timp");
	
	for (i=0; i < MAXENE_CARROZAS; i++) {
		carroza[i] = new Carroza(16);
		carroza[i]->addFrame(frCarroza0);
		carroza[i]->addFrame(frCarroza1);
		carroza[i]->addFrame(frCarroza2);
		carroza[i]->addFrame(frCarroza3);
		carroza[i]->addFrame(frCarroza4);
		carroza[i]->addFrame(frCarroza5);
		carroza[i]->addFrame(frCarroza6);
		carroza[i]->addFrame(frCarroza7);
		carroza[i]->addFrame(frCarroza8);
		carroza[i]->addFrame(frCarroza9);
		carroza[i]->addFrame(frCarroza10);
		carroza[i]->addFrame(frCarroza11);
		carroza[i]->addFrame(frCarroza12);
		carroza[i]->addFrame(frCarroza13);
		carroza[i]->addFrame(frCarroza14);
		carroza[i]->addFrame(frCarroza15);
		carroza[i]->fuego0->addFrame(frFuego00);
		carroza[i]->fuego0->addFrame(frFuego01);
		carroza[i]->fuego0->addFrame(frFuego02);
		carroza[i]->fuego1->addFrame(frFuego10);
		carroza[i]->fuego1->addFrame(frFuego11);
		carroza[i]->fuego1->addFrame(frFuego12);
		carroza[i]->humo->addFrame(frHumo0);
		carroza[i]->humo->addFrame(frHumo1);
		carroza[i]->humo->addFrame(frHumo2);
		carroza[i]->setTipoElemento(CARROZA);
	}
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando dioses", 255, 230, 23, 0,0,0, 320, screen_h-40);
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// dios baco
	
	Frame frDios;
	
	sprintf (tmpch, "%s/jefe3.tim", DATA_DIR);
	
	char tmp[32];
	
	
	jefe3[DIOS_BACO] = new JefeFase3(48);
	
	for (i=1; i<48; i++) {
		if (i<10) {
			sprintf (tmp, "baco_000%d.timp", i);
		} else {
			sprintf (tmp, "baco_00%d.timp", i);
		}
		frDios.loadFromRAR(tmpch, tmp);
		jefe3[DIOS_BACO]->addFrame(frDios);
	}
	// frames explotado
	frDios.loadFromRAR(tmpch, "baco_exp.timp");
	jefe3[DIOS_BACO]->addFrame(frDios);
	jefe3[DIOS_BACO]->setFrameExplotado(47);
	jefe3[DIOS_BACO]->setDios(DIOS_BACO);
	jefe3[DIOS_BACO]->crearBarraVida(screen, "Baco", IMPACTOS_JEFE2, 460, 15);
	jefe3[DIOS_BACO]->setAtaque1(0,14);
	jefe3[DIOS_BACO]->setAtaque2(15,23);
	jefe3[DIOS_BACO]->setAtaque3(24,38);
	jefe3[DIOS_BACO]->setMovimientoFiesta(39,46);
	jefe3[DIOS_BACO]->setNumFramesMovimientoFiesta(5);
	jefe3[DIOS_BACO]->setMovimientoPrincipal(0, 0);
	jefe3[DIOS_BACO]->setMovimientoPrincipal(1, 14);
	jefe3[DIOS_BACO]->setMovimientoPrincipal(2, 0);
	jefe3[DIOS_BACO]->setMovimientoPrincipal(3, 36);
	jefe3[DIOS_BACO]->setX(290);
	jefe3[DIOS_BACO]->setY(50);
	jefe3[DIOS_BACO]->setCiclosRealizarAtaque(120);
	jefe3[DIOS_BACO]->fuego0->addFrame(frFuego00);
	jefe3[DIOS_BACO]->fuego0->addFrame(frFuego01);
	jefe3[DIOS_BACO]->fuego0->addFrame(frFuego02);
	jefe3[DIOS_BACO]->humo->addFrame(frHumo0);
	jefe3[DIOS_BACO]->humo->addFrame(frHumo1);
	jefe3[DIOS_BACO]->humo->addFrame(frHumo2);
	
	// dios hercules
	
	jefe3[DIOS_HERCULES] = new JefeFase3(52);
	
	for (i=1; i<52; i++) {
		if (i<10) {
			sprintf (tmp, "hercules_0000%d.timp", i);
		} else {
			sprintf (tmp, "hercules_000%d.timp", i);
		}
		frDios.loadFromRAR(tmpch, tmp);
		jefe3[DIOS_HERCULES]->addFrame(frDios);
	}
	// frames explotado
	frDios.loadFromRAR(tmpch, "hercules_exp.timp");
	jefe3[DIOS_HERCULES]->addFrame(frDios);
	jefe3[DIOS_HERCULES]->setFrameExplotado(51);
	jefe3[DIOS_HERCULES]->setDios(DIOS_HERCULES);
	jefe3[DIOS_HERCULES]->crearBarraVida(screen, "Hercules", IMPACTOS_JEFE2, 310, 15);
	jefe3[DIOS_HERCULES]->setAtaque1(0,14);
	jefe3[DIOS_HERCULES]->setAtaque2(15,34);
	jefe3[DIOS_HERCULES]->setAtaque3(35,44);
	jefe3[DIOS_HERCULES]->setMovimientoFiesta(45,51);
	jefe3[DIOS_HERCULES]->setNumFramesMovimientoFiesta(1);
	jefe3[DIOS_HERCULES]->setMovimientoPrincipal(0, 0);
	jefe3[DIOS_HERCULES]->setMovimientoPrincipal(1, 15);
	jefe3[DIOS_HERCULES]->setMovimientoPrincipal(2, 34);
	jefe3[DIOS_HERCULES]->setMovimientoPrincipal(3, 26);
	jefe3[DIOS_HERCULES]->setX(153);
	jefe3[DIOS_HERCULES]->setY(-25);
	jefe3[DIOS_HERCULES]->fuego0->addFrame(frFuego00);
	jefe3[DIOS_HERCULES]->fuego0->addFrame(frFuego01);
	jefe3[DIOS_HERCULES]->fuego0->addFrame(frFuego02);
	jefe3[DIOS_HERCULES]->humo->addFrame(frHumo0);
	jefe3[DIOS_HERCULES]->humo->addFrame(frHumo1);
	jefe3[DIOS_HERCULES]->humo->addFrame(frHumo2);
	
	jefe3[DIOS_NEPTUNO] = new JefeFase3(71);
	
	for (i=1; i<71; i++) {
		if (i<10) {
			sprintf (tmp, "neptuno_000%d.timp", i);
		} else {
			sprintf (tmp, "neptuno_00%d.timp", i);
		}
		frDios.loadFromRAR(tmpch, tmp);
		jefe3[DIOS_NEPTUNO]->addFrame(frDios);
	}
	// frames explotado
	frDios.loadFromRAR(tmpch, "neptuno_exp.timp");
	jefe3[DIOS_NEPTUNO]->addFrame(frDios);
	jefe3[DIOS_NEPTUNO]->setFrameExplotado(70);
	jefe3[DIOS_NEPTUNO]->setDios(DIOS_NEPTUNO);
	jefe3[DIOS_NEPTUNO]->crearBarraVida(screen, "Neptuno", IMPACTOS_JEFE2, 160, 15);
	jefe3[DIOS_NEPTUNO]->setAtaque1(0,17);
	jefe3[DIOS_NEPTUNO]->setAtaque2(18,42);
	jefe3[DIOS_NEPTUNO]->setAtaque3(43,54);
	jefe3[DIOS_NEPTUNO]->setMovimientoFiesta(55,70);
	jefe3[DIOS_NEPTUNO]->setNumFramesMovimientoFiesta(15);
	jefe3[DIOS_NEPTUNO]->setMovimientoPrincipal(0, 0);
	jefe3[DIOS_NEPTUNO]->setMovimientoPrincipal(1, 28);
	jefe3[DIOS_NEPTUNO]->setMovimientoPrincipal(2, 16);
	jefe3[DIOS_NEPTUNO]->setMovimientoPrincipal(3, 17);
	jefe3[DIOS_NEPTUNO]->setX(-60);
	jefe3[DIOS_NEPTUNO]->setY(-15);
	jefe3[DIOS_NEPTUNO]->setCiclosRealizarAtaque(150);
	jefe3[DIOS_NEPTUNO]->fuego0->addFrame(frFuego00);
	jefe3[DIOS_NEPTUNO]->fuego0->addFrame(frFuego01);
	jefe3[DIOS_NEPTUNO]->fuego0->addFrame(frFuego02);
	jefe3[DIOS_NEPTUNO]->humo->addFrame(frHumo0);
	jefe3[DIOS_NEPTUNO]->humo->addFrame(frHumo1);
	jefe3[DIOS_NEPTUNO]->humo->addFrame(frHumo2);
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando biopic", 255, 230, 23, 0,0,0, 320, screen_h-40);
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	// biopic
	
	biopic = new BioPic(20);
	
	for (i=1; i<5; i++) {
		sprintf (tmp, "inout000%d.timp", i);
		frDios.loadFromRAR(tmpch, tmp);
		biopic->addFrame(frDios);
	}
	
	for (i=5; i<20; i++) {
		if ((i-4)<10) {
			sprintf (tmp, "pico00%d.timp", (i-4));
		} else {
			sprintf (tmp, "pico0%d.timp", (i-4));
		}
		frDios.loadFromRAR(tmpch, tmp);
		biopic->addFrame(frDios);
	}
	
	biopic->setX(175);
	biopic->setY(190);
	//biopic->setY(172);
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando fondo final", 255, 230, 23, 0,0,0, 320, screen_h-40);
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	
	sprintf (tmpch, "%s/final3.tim", DATA_DIR);
	
	ptierra = new Elemento();
	
	frDios.loadFromRAR(tmpch, "ptierra.timp");
	ptierra->addFrame(frDios);
	ptierra->setX(0);
	ptierra->setY(17);
		
	mapa->unLoad();
	mapa->CargarNivel (juego->getNivel(), screen);
	
	printf("Cargado nivel 3\n");
}

void Pantalla::initNivel2 () {
	printf("Cargando elementos del nivel 2\n");
	int i;
	char tmpch[127];
		
	barradecarga->setTotalCarga(5);
	barradecarga->setPosicion((pantalla_w/2), 400);
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando enemigos marinos", 255, 230, 23, 0,0,0, 320, screen_h-40);
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);

	initMarinos();
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando automoviles", 255, 230, 23, 0,0,0, 320, screen_h-40);
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	initAutomoviles();

	// cargar conchas
	
	Frame frConcha0, frConcha1, frConcha2, frConcha3, frConcha4;
	
	sprintf (tmpch, "%s/ene_fase.tim", DATA_DIR);
	frConcha0.loadFromRAR(tmpch, "konsha_0.timp");
	frConcha1.loadFromRAR(tmpch, "konsha_1.timp");
	frConcha2.loadFromRAR(tmpch, "konsha_2.timp");
	frConcha3.loadFromRAR(tmpch, "konsha_3.timp");
	frConcha4.loadFromRAR(tmpch, "konsha_4.timp");
	
	for (i=0; i < MAXENE_CONCHA; i++) {
		concha[i] = new Concha(5);
		concha[i]->addFrame(frConcha0);
		concha[i]->addFrame(frConcha1);
		concha[i]->addFrame(frConcha2);
		concha[i]->addFrame(frConcha3);
		concha[i]->addFrame(frConcha4);

		concha[i]->setTipoElemento(CONCHA);
		concha[i]->setImpactosParaMorir(IMPACTOS_CONCHA);
		concha[i]->selFrame(0);
	}


	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando mapa", 255, 230, 23, 0,0,0, 320, screen_h-40);
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);
	
	mapa->unLoad();
	mapa->CargarNivel (juego->getNivel(), screen);
	
	sprintf (tmpch, "%s/final2.tim", DATA_DIR);
	
	Frame frPuente;
	
	puente = new Elemento();
	
	frPuente.loadFromRAR(tmpch, "puente.timp");
	puente->addFrame(frPuente);
	puente->setX(0);
	puente->setY(0);
	
	Frame frEspuma0, frEspuma1, frEspuma2;
	espumaPuente = new Elemento(3);
	frEspuma0.loadFromRAR(tmpch, "espuma0.timp");
	frEspuma1.loadFromRAR(tmpch, "espuma1.timp");
	frEspuma2.loadFromRAR(tmpch, "espuma2.timp");
	espumaPuente->addFrame(frEspuma0);
	espumaPuente->addFrame(frEspuma1);
	espumaPuente->addFrame(frEspuma2);
	espumaPuente->setX(0);
	espumaPuente->setY(0);
	
	tiempo->CargarNiebla();
	
	presentacionFase->dibujar(screen);
	fuente->escribirTexto(screen, 0, ALIGN_CENTER, VALIGN_CENTER, 11, "Creando jefes", 255, 230, 23, 0,0,0, 320, screen_h-40);
	barradecarga->actualizarCarga();
	barradecarga->dibujar(screen);
	SDL_Flip (screen);

	jefe2 = new JefeFase2(screen);
	
	cano = new ElCano();
	cano->cargarSprites();
	cano->iniciar();
	
	printf("Cargado nivel 2\n");
	
}

void Pantalla::presentacion() {
	
	int r = intro->DrawAnimation();
	SDL_SetClipRect (screen, NULL);
	SDL_Flip (screen);
	SDL_Delay(timeLeft());
	nextTime();

	if (r==0) {
		presentacion();
	}
}

char* Pantalla::BufferFromRar(char *fileRar, char *file)
{
  char *data_ptr;
  unsigned long data_size;

  if(urarlib_get(&data_ptr, &data_size, file, fileRar, "password")) 
  {
	return data_ptr;
    //if(data_ptr != NULL) free(data_ptr);
  } else 
  { 
    printf("Error al descomprimir (pantalla)!: %s - %s\n", fileRar, file); 
  }
  return data_ptr;
}

void Pantalla::cargarIntro() {
	
	char cadena[127], archivo[27];

	intro = new SDL_Animation(screen, 640, 480);
	sprintf (cadena, "%s/verabd.tttf", DATA_DIR);
	intro->inVariable("fuente", cadena);
	intro->inVariable("conf_ruta", config->getDirectorio());
	sprintf (cadena, "%s/intro_fase%d.tin", DATA_DIR, juego->getNivel());
	
	sprintf (archivo, "intro_fase%d.tin", juego->getNivel());

	intro->loadBuffer(BufferFromRar(cadena, "intro.txml"), archivo);

}

void Pantalla::cargarVS() {
	
	char cadena[127], archivo[27];
	

	intro = new SDL_Animation(screen, 520, 480);
	sprintf (cadena, "%s/verabd.tttf", DATA_DIR);
	intro->inVariable("fuente", cadena);
	intro->inVariable("conf_ruta", config->getDirectorio());

	sprintf (cadena, "%s/vs_fase%d.tvs", DATA_DIR, juego->getNivel());
	
	sprintf (archivo, "vs_fase%d.tvs", juego->getNivel());
	
	intro->loadBuffer(BufferFromRar(cadena, "vs.txml"), archivo);
	
}

void Pantalla::cargarDiario() {
	
	char cadena[127], archivo[27];
	
	if (juego->getNivel()==3) {
		diario = new SDL_Animation(screen, 640, 480);
	} else {
		diario = new SDL_Animation(screen, 520, 480);
	}
	sprintf (cadena, "%s/verabd.tttf", DATA_DIR);
	diario->inVariable("fuente", cadena);
	diario->inVariable("conf_ruta", config->getDirectorio());

	sprintf (cadena, "%s/diario_fase%d.tvs", DATA_DIR, juego->getNivel());
	
	sprintf (archivo, "diario_fase%d.tvs", juego->getNivel());
	
	diario->loadBuffer(BufferFromRar(cadena, "diario.txml"), archivo);
	
}

void Pantalla::initSpriteNivel(int l) {
	SDL_Surface *surface;
	int oldNivel;
	// comprobar si el nivel a cargar es diferente al nivel actual
	if (l != juego->getNivel()) {
		oldNivel = juego->getNivel();
		juego->setNivel(l);
		surface = fuente->escribirTexto(0, 16, juego->getTituloNumeroFase(), 255, 230, 23, 0, 0, 0);
		txtNivel->sprite[0].img = surface;
		surface = fuente->escribirTexto(0, 16, juego->getTituloNombreFase(), 255, 255, 255, 0, 0, 0);
		txtFase->sprite[0].img = surface;
		// descargamos nivel
		if (oldNivel>=0) 
			unLoadSpriteNivel(oldNivel);
		// Cargamos el nivel
		switch (juego->getNivel()) {
			case 0:
				initNivelComoJugar();
			break;
			case 1:
				initNivel1();
			break;
			case 2:
				initNivel2();
			break;
			case 3:
				initNivel3();
			break;
		}
	}
	cargarIntro();
	presentacion();
}

void Pantalla::unLoadSpriteNivel(int l) {
	switch (l) {
		/*
		case 0:
			cartelComoJugar->unLoad();
			pulsaComoJugar->unLoad();
			flechasComoJugar->unLoad();
		break;*/
		case 1:
			cangrejo[0]->unLoad();
			lancha[0]->unLoad();
			caseta[0]->unLoad();
			mina[0]->unLoad();
			jefe1->unLoad();
		break;
		case 2:
			cangrejo[0]->unLoad();
			lancha[0]->unLoad();
			pulpo[0]->unLoad();
			yate[0]->unLoad();
			puente->unLoad();
			jefe2->unLoad();
		break;
		case 3:
			cpolicia[0]->unLoad();
			tanque[0]->unLoad();
			taxi[0]->unLoad();
			csimple[0]->unLoad();
			carroza[0]->unLoad();
			valla_izq[0]->unLoad();
			valla_der[0]->unLoad();
			barrera_izq[0]->unLoad();
			barrera_der[0]->unLoad();
			jefe3[0]->unLoad();
			jefe3[1]->unLoad();
			jefe3[2]->unLoad();
			ptierra->unLoad();
		break;
	}
	tiempo->unLoad();
}


void Pantalla::cargarSiguienteFase() {
	Mix_HaltChannel(-1);
	iniciarPantalla();
	SDL_SetClipRect (screen, NULL);
	sonido->empezarMusica(MUS_OPCIONES);// musica de opciones
	initSpriteNivel(juego->getNivel()+1);
	empezarMusica(juego->getNivel());// musica de la fase
}

void Pantalla::cargarMitadVersus() {
	Uint32 rmask, gmask, bmask, amask;
    SDL_Surface *srf_ar, *srf_ab;
	
	rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;

	srf_ar = SDL_CreateRGBSurface(SDL_SWSURFACE | SDL_SRCALPHA, 520, 240, 16, rmask, gmask, bmask, amask);
	srf_ab = SDL_CreateRGBSurface(SDL_SWSURFACE | SDL_SRCALPHA, 520, 240, 16, rmask, gmask, bmask, amask);
	
	SDL_Rect ar, ab, dest;
	ar.x = 0;
	ar.y = 0;
	ar.h = 240;
	ar.w = 520;
	ab.x = 0;
	ab.y = 240;
	ab.h = 240;
	ab.w = 520;
	dest.x = 0;
	dest.y = 0;
	dest.h = 240;
	dest.w = 520;
	
	srf_ar = SDL_ConvertSurface ( srf_ar, screen->format, SDL_SWSURFACE);
	
	srf_ab = SDL_ConvertSurface ( srf_ab, screen->format, SDL_SWSURFACE);
	
	SDL_BlitSurface (screen, &ar, srf_ar, &dest);
	mitadVersusArriba->sprite[0].img = srf_ar;
	SDL_BlitSurface (screen, &ab, srf_ab, &dest);
	mitadVersusAbajo->sprite[0].img = srf_ab;
	
	mitadVersusArriba->setY(0);
	
	mitadVersusAbajo->setY(240);
	
}
