/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */

#ifndef DISPAROJUGADOR_H_
#define DISPAROJUGADOR_H_

#include <SDL.h>
#include "defines.h"
#include "elementos.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


class Elemento;
class Jugador;
class Frame;
class Juego;
class Audio;
class Balon;

class DisparoJugador {
	
private:
	Elemento *disparos[MAXBALAS];
	int numDisparo2;
public:
	DisparoJugador();
	Balon *balon[MAX_BALON];
	void crear (Audio *sonido, Jugador *j, Juego *juego);
	void mover (SDL_Surface *screen);
	Elemento* getDisparo(int n) { return disparos[n]; };
	Balon* getBalon(int n) { return balon[n]; };
	int elementoLibre ();
	void iniciar ();
};


#endif /* INSTANCIAS_H_ */
