/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */

#ifndef INTERCOM_H_
#define INTERCOM_H_

#include <SDL.h>
#include "defines.h"
#include "SDL_Animation.h"
#include "configuracion.h"
#include "unrarlib.h"
#include "sonido.h"
#include <string>
#include <vector>

using namespace std;

typedef struct
{
	int id;
	int fase; // fase 0 son las conversaciones aleatorias
	int personaje;
} tConversacion;

class Audio;

class Intercom {
	
private:
	SDL_Animation *anim;
	SDL_Surface *screen;
	Configuracion *config;
	vector<tConversacion> conversaciones;
	bool intercomAbierto;
	int idConversacionActual; // identificador de la conversacion actual
	int idFaseActual; // identificador de la fase actual
	int idNConversacion; // identificador de la conversacion (0, 1 o 2)
	int personajeIntercom;
	int numeroAleatorias; // numero de conversaciones aleatorias
	int arAleatorias[5];

public:
	Intercom (Configuracion * conf);
	char* BufferFromRar(char *fileRar, char *file);
	void cargarAnimacion ();
	void cargarAnimacionComoJugar ();
	int dibujarAnimacion ();
	int obtenerAleatoria ();
	char* getNombrePersonajeIntercom(int p);
	char* getNombrePersonajeIntercom();
	void abrirIntercom(int f, int id, Audio *son);
	void abrirIntercomComoJugar(Audio *son);
	void cerrarIntercom(Audio *son);
	void setIntercomAbierto(int i) { intercomAbierto = i; }
	bool getIntercomAbierto() { return intercomAbierto; }
	int getPersonajeIntercom () { return personajeIntercom; }
	void setScreen (SDL_Surface *s) { screen = s; }
};

#endif /* INTERCOM_H_ */
