/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
 /*****************************
**
** CLASE JUEGO
**
******************************/

#include "juego.h"

 Juego::Juego() {
	 
	iniciar();
	 
}

void Juego::iniciar() {
	puntos = 0;
	vidas = 3;
	nivel = -1;
	ciclos = 0;
	gameover = 0;
	nPoderes = 2;
	estadoBarraPoder = 0;
	tipoDisparo = 0;
	poderSeleccionado = 1;
	tiempoPoder = 0;
	poderActivo = 0;
	enFinal = false;
	nContinues = NUMEROCONTINUES;
	zonaSobrepasada = 0;
	conversacionParaAbrirEnFase = 1;
	mapaParado = false;
}

char* Juego::getTituloNombreFase() {
	 
	 switch(nivel) {
		 case 0:
			 return "Aprendiendo a ser superhéroe";
		 break;
		 case 1:
			 return "Rumbo a la Caleta";
		 break;
		 case 2:
			 return "Astilleros no se cierra";
		 break;
		 case 3:
			 return "Pánico en la avenida";
		 break;
	 }
	 return "Nombre";
}

char* Juego::getTituloNombreCortoFase() {
	 
	 switch(nivel) {
		 case 0:
			 return "Aprendizaje";
		 break;
		 case 1:
			 return "Rumbo a la Caleta";
		 break;
		 case 2:
			 return "No se cierra";
		 break;
		 case 3:
			 return "Pánico en avenida";
		 break;
	 }
	 return "Nombre";
}

char* Juego::getTituloNumeroFase() {
	 switch(nivel) {
		 case 0:
			 return "\"Como jugar\"";
		 break;
		 case 1:
			 return "\"Misión 1\"";
		 break;
		 case 2:
			 return "\"Misión 2\"";
		 break;
		 case 3:
			 return "\"Misión 3\"";
		 break;
		 case 4:
			 return "\"Misión 4\"";
		 break;
	 }
	 return "Mision";
}


void Juego::setCicloConversarionAleatoria () {
	
	int c = rand()%5;
	
	if (zonaSobrepasada>0) {
		c++;
	}
	
	if (c == 0) {
		cicloConversacionAleatoria = 1000;
	} else if (c==1) {
		cicloConversacionAleatoria = 1300;
	} else if (c==2) {
		cicloConversacionAleatoria = 1700;
	} else if (c==3) {
		cicloConversacionAleatoria = 3000;
	} else {
		cicloConversacionAleatoria = 3400;
	}
	
}

void Juego::setConversacionParaAbrirEnFase() {
	
	conversacionParaAbrirEnFase = 1;//(rand()%2)+1;
	
}
