/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */

#ifndef AUDIO_H_
#define AUDIO_H_

#include <SDL.h>
#include <SDL_mixer.h>
#include "defines.h"
#include "configuracion.h"
#include "unrarlib.h"

class Audio {
	
private:

public:
	Mix_Chunk *musica1, *musica2, *musica3;
	Mix_Chunk *final1, *final2, *final3;
	Mix_Chunk *opciones;
	Mix_Chunk *cano;
	Mix_Chunk *bomba, *exp_pajaros;
	Mix_Chunk *gaditana, *cabargata;
	Mix_Chunk *comp_cerrar, *comp_abrir;
	Mix_Chunk *silbido;
	Mix_Chunk *desact_poder0, *desact_poder1, *desact_poder2;
	Mix_Chunk *ag_vida, *ag_poder, *ag_disparo_laser, *ag_disparo_triple;
	Mix_Chunk *act_bomba0, *act_bomba1, *act_clonacion, *act_escudo, *act_amarillo;
	Mix_Chunk *exp_jefes, *exp_grande;
	Mix_Chunk *castanuelas, *intercom;
	Mix_Chunk *muerte0, *muerte1, *muerte2, *muerte3, *muerte4, *muerte5;
	Mix_Chunk *muerte6, *muerte7, *muerte8, *muerte9, *muerte10, *muerte11;
	Mix_Chunk *explosion, *disparo, *click, *beep, *beep1, *explosionagua, *explosioncaseta, *pop;
	Mix_Chunk *agregador;
	Mix_Chunk *sirenas;
	Mix_Chunk *frase_invisibilidad, *frase_escudo, *frase_clonacion0, *frase_clonacion1;
	Mix_Chunk *ese_cadi;
	Mix_Chunk *energia_tope0, *energia_tope1, *energia_tope2;
	Configuracion *conf;
	int salir;
	Audio (Configuracion *config);
	SDL_RWops* RWFromRar(char *fileRar, char *file);
	void initSonido ();
	void cargarSonido();
	void establecerVolumenes ();
	void empezarMusica (int mus);
	void terminarMusica ();
	void empezarMusicaSecundaria (int mus);
	void terminarMusicaSecundaria ();
	void empezarIntercom();
	void terminarIntercom();
	void playSonido (int son);
	void unLoadSonido ();
};

#endif /* AUDIO_H_ */
