/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
 #include "pantalla.h"
 
void Pantalla::crearElementoNivel1 () {
	int numLibre;
	comprobarConversacionAleatoria();
	
	switch (juego->getCiclos()) {
		case 110:
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX( gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,1)) ); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, 80 ,0);
			}
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, -80 ,0);
			}
		break;
		case 150:
			if (juego->getConversacionParaAbrirEnFase() == 1)
				intercom->abrirIntercom(juego->getNivel(), 1, sonido);
		break;
		case 180:
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(-gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA1, 0 ,0);
			}
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(screen_h+gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  -VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA1, 0 ,0);
			}
		break;
		case 230:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 240:
			numLibre = elementoLibre (CASETA);
			if (numLibre != -1) {
				caseta[numLibre]->setX(xEnPantalla(6,5));
				caseta[numLibre]->setY(-caseta[numLibre]->getAlto());
				caseta[numLibre]->setActivo(1);
				caseta[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_ALJUGADOR, 1, 60);
			}
		break;
		case 350:
			juego->setHacerClip(0);
			intercom->cerrarIntercom(sonido);
		break;
		case 360:
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(250); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, 30,  0, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  -VEL_NORMAL-1, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  0, -VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, -VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA2, 0 ,0);
			}
		break;
		case 380:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(-navemed[numLibre]->getAncho()); 
				navemed[numLibre]->setY(120);
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, 0, -1);
				navemed[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 4, 15);
			}
		break;
		case 460:
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(-gaviotas[numLibre]->getAncho()); 
				gaviotas[numLibre]->setY(yEnPantalla(4,2));
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 35,  VEL_RAPIDO, 0, -1);
				gaviotas[numLibre]->addMovimiento(0, 20,  0, -VEL_RAPIDO, -1);	
				gaviotas[numLibre]->addMovimiento(0, 20,  -VEL_RAPIDO, 0, -1);	
				gaviotas[numLibre]->addMovimiento(0, 20,  0, VEL_RAPIDO, -1);	
				gaviotas[numLibre]->addMovimiento(0, 20,  VEL_RAPIDO, 0, -1);
				gaviotas[numLibre]->addMovimiento(0, 20,  0, -VEL_RAPIDO, -1);	
				gaviotas[numLibre]->addMovimiento(0, 20,  -VEL_RAPIDO, 0, -1);	
				gaviotas[numLibre]->addMovimiento(0, 20,  0, VEL_RAPIDO, -1);	
				gaviotas[numLibre]->addMovimiento(0, -1,  VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 6, 10, GAVIOTA1, 0 ,0);
			}
		break;
		case 520:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 15,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 50,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_5ABAJO, 2, 20);
			}
		break;
		case 560:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_DISPARO);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 580:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(6,1))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 15,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 50,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_5ABAJO, 2, 20);
			}
		break;
		case 620:
			numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(xEnPantalla(5,1)); 
				navepeq[numLibre]->setY(-navepeq[numLibre]->getAlto());
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(1, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				crearFormacionEnFila(navepeq[numLibre], 2, 20, NAVEPEQUENYA, 180 ,0);
			}
		break;
		case 670:
			numLibre = elementoLibre (NAVEGRANDE);
			if (numLibre != -1) {
				navegrande[numLibre]->setTipoRegalo(AG_PODER); 
				navegrande[numLibre]->setX(navegrande[numLibre]->getCentrarXen(screen_w/2)); 
				navegrande[numLibre]->setY(-navegrande[numLibre]->getAlto() - 30);
				navegrande[numLibre]->setActivo(1);
				navegrande[numLibre]->addMovimiento(0, 30,  0, VEL_NORMAL, -1);
				navegrande[numLibre]->addMovimiento(2, 220,  0, VEL_NORMAL, -1);
				navegrande[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navegrande[numLibre]->addDisparo (50, DISPARO_GR,  DISP_8CIRCULAR, 2, 40);
				navegrande[numLibre]->addDisparo (120, DISPARO_PEQ, DISP_6LATERALES, 3, 20);
				navegrande[numLibre]->addDisparo (160, DISPARO_GR, DISP_2ABAJO, 6, 10);
			}
		break;
		case 730:
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(-gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(yEnPantalla(3,2));
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 30,  VEL_NORMAL, -VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_RAPIDO, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 2, 10, GAVIOTA2, 0 ,0);
			}
		break;
		case 780:
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(screen_w); 
				gaviotas2[numLibre]->setY(yEnPantalla(6,5));
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 15,  -VEL_NORMAL, -VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, 35,  -VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_RAPIDO, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 2, 10, GAVIOTA2, 0 ,0);
			}
		break;
		case 800:
			numLibre = elementoLibre (CANGREBOT);
			if (numLibre != -1) {
				cangrejo[numLibre]->setX(xEnPantalla(6,1)); 
				cangrejo[numLibre]->setY(yEnPantalla(6,1));
				cangrejo[numLibre]->setActivo(1);
				cangrejo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 840:
		numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 90,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_4CRUZ, 4, 40);
				gavibot[numLibre]->addDisparo(60, DISPARO_PEQ, DISP_4OBLICUO, 4, 40);
			}
		numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 90,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_4CRUZ, 4, 40);
				gavibot[numLibre]->addDisparo(60, DISPARO_PEQ, DISP_4OBLICUO, 4, 40);
			}
		break;
		case 850:
			numLibre = elementoLibre (CASETA);
			if (numLibre != -1) {
				caseta[numLibre]->setX(xEnPantalla(5,4)); 
				caseta[numLibre]->setY(-caseta[numLibre]->getAlto());
				caseta[numLibre]->setActivo(1);
				caseta[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 1, 70);
			}
		break;
		case 900:
		numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(xEnPantalla(5,1)); 
				navepeq[numLibre]->setY(-navepeq[numLibre]->getAlto());
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(0, 30,  0, VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  0, -VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  -VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  0, VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 30,  VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  VEL_RAPIDO, -VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				crearFormacionEnFila(navepeq[numLibre], 6, 10, NAVEPEQUENYA, 0 ,0);
			}
		break;
		case 920:
			numLibre = elementoLibre (LANCHA);
			if (numLibre != -1) {
				lancha[numLibre]->setX(xEnPantalla(5,2)); 
				lancha[numLibre]->setY(screen_h);
				lancha[numLibre]->setActivo(1);
				lancha[numLibre]->addMovimiento(0, 20, 0, -VEL_NORMAL, -1);
				lancha[numLibre]->addMovimiento(0, 40, 0, -1, -1);
				lancha[numLibre]->addDisparo (30, DISPARO_PEQ, DISP_ALJUGADOR, 2, 50);
				//lancha[numLibre]->addMovimiento(0, 5, 0, -VEL_NORMAL, -1);
				lancha[numLibre]->addMovimiento(0, 35, -VEL_LENTO, -VEL_LENTO, -1);
				lancha[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
			}
		break;
		case 1090:
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(-gaviotas[numLibre]->getAncho()); 
				gaviotas[numLibre]->setY(yEnPantalla(3,1));
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 25, VEL_RAPIDO, 0, -1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 15,  0, -VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 15,  -VEL_RAPIDO, 0, -1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 30,  0, VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1,  -VEL_NORMAL, VEL_RAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 7, 12, GAVIOTA1, 0 ,0);
			}
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(screen_w);
				gaviotas[numLibre]->setY(yEnPantalla(3,1));
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 25, -VEL_RAPIDO, 0, -1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 15,  0, -VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 15,  VEL_RAPIDO, 0, -1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 30,  0, VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1,  VEL_NORMAL, VEL_RAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 7, 12, GAVIOTA1, 0 ,0);
			}
		break;
		case 1150:
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setTipoRegalo(AG_DISPARO); 
				navezepelin[numLibre]->setX(navezepelin[numLibre]->getCentrarXen(screen_w/2));
				navezepelin[numLibre]->setY(- navezepelin[numLibre]->getAlto() - 30);
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 30, 0, VEL_NORMAL, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 30, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 60, -VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 25, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addDisparo (80, DISPARO_GR, DISP_RAFAGA, 5, 30);
				navezepelin[numLibre]->addDisparo (240, DISPARO_PEQ, DISP_5ABAJO, 4, 40);
				navezepelin[numLibre]->addDisparo (250, DISPARO_GR, DISP_5ABAJO, 3, 30);
				navezepelin[numLibre]->addMovimiento(2, 180, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
			}
		break;
		case 1100:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 1200:
			numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(6,1))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 25,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 40,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_5ABAJO, 2,  40);
			}
			numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 25,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 40,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_5ABAJO, 2,  40);
			}
		break;
		case 1350:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gaviotas[numLibre]->setY(screen_h + gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 40, 0, -VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, -1,  -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				gaviotas[numLibre]->setY(screen_h + gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 30, 0, -VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, -1,  VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 1400:
			numLibre = elementoLibre (LANCHA);
			if (numLibre != -1) {
				lancha[numLibre]->setX(xEnPantalla(4,1)); 
				lancha[numLibre]->setY(-lancha[numLibre]->getAncho());
				lancha[numLibre]->setActivo(1);
				lancha[numLibre]->addMovimiento(0, 65, 0, VEL_NORMAL, -1);
				lancha[numLibre]->addMovimiento(0, -1, -VEL_NORMAL, 0, -1);
				lancha[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 50);
			}
		break;
		case 1450:
			numLibre = elementoLibre (CASETA);
			if (numLibre != -1) {
				caseta[numLibre]->setX(xEnPantalla(6,5)); 
				caseta[numLibre]->setY(-caseta[numLibre]->getAlto());
				caseta[numLibre]->setActivo(1);
				caseta[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 2, 70);
			}
		break;
		case 1520:
			if (juego->getConversacionParaAbrirEnFase() == 2)
				intercom->abrirIntercom(juego->getNivel(), 2, sonido);
		break;
		case 1550:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(7,1))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 25,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 40,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_2ABAJO, 4,  15);
			}
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(7,6))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 25,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 40,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_2ABAJO, 4, 15);
			}
		break;
		case 1565:
			numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(3,1))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 40,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_2ABAJO, 4,  15);
			}
			numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(3,2))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 40,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_2ABAJO, 4, 15);
			}
		break;
		case 1590:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 1600:
			numLibre = elementoLibre (CANGREBOT);
			if (numLibre != -1) {
				cangrejo[numLibre]->setX(xEnPantalla(6,1)); 
				cangrejo[numLibre]->setY(yEnPantalla(6,1));
				cangrejo[numLibre]->setActivo(1);
				cangrejo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 1700:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(screen_w); 
				gaviotas[numLibre]->setY(yEnPantalla(3,2));
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 25, -VEL_NORMAL, -VEL_NORMAL, -1);
				gaviotas[numLibre]->addMovimiento(0, 15,  -VEL_RAPIDO, 0, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 5, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 1710:
			juego->setHacerClip(0);
			intercom->cerrarIntercom(sonido);
		break;
		case 1720:
			numLibre = elementoLibre (LANCHA);
			if (numLibre != -1) {
				lancha[numLibre]->setX(xEnPantalla(6,1)); 
				lancha[numLibre]->setY(-lancha[numLibre]->getAlto());
				lancha[numLibre]->setActivo(1);
				lancha[numLibre]->addMovimiento(0, -1, 0, VEL_LENTO, -1);
				lancha[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 50);
			}
		break;
		case 1800:
			numLibre = elementoLibre (CASETA);
			if (numLibre != -1) {
				caseta[numLibre]->setX(xEnPantalla(6,5)); 
				caseta[numLibre]->setY(-caseta[numLibre]->getAlto());
				caseta[numLibre]->setActivo(1);
				caseta[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 2, 70);
			}
		break;
		case 1840:
			numLibre = elementoLibre (LANCHA);
			if (numLibre != -1) {
				lancha[numLibre]->setX(xEnPantalla(5,2)); 
				lancha[numLibre]->setY(-lancha[numLibre]->getAlto());
				lancha[numLibre]->setActivo(1);
				lancha[numLibre]->addMovimiento(0, 20, 0, VEL_NORMAL, -1);
				lancha[numLibre]->addMovimiento(0, 25, -VEL_NORMAL, -VEL_NORMAL, -1);
				lancha[numLibre]->addMovimiento(0, -1, -VEL_NORMAL, 0, -1);
				lancha[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 50);
			}
		break;
		case 1670:
			numLibre = elementoLibre (CANGREBOT);
			if (numLibre != -1) {
				cangrejo[numLibre]->setX(xEnPantalla(10,6)); 
				cangrejo[numLibre]->setY(50);
				cangrejo[numLibre]->setActivo(1);
				cangrejo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 1900:
			numLibre = elementoLibre (CANGREBOT);
			if (numLibre != -1) {
				cangrejo[numLibre]->setX(xEnPantalla(7,1)); 
				cangrejo[numLibre]->setActivo(1);
				cangrejo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 1950:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_DISPARO);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 2000:
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setTipoRegalo(AG_PODER); 
				navezepelin[numLibre]->setX(navezepelin[numLibre]->getCentrarXen(screen_w/2));
				navezepelin[numLibre]->setY(- navezepelin[numLibre]->getAlto() - 30);
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 30, 0, VEL_NORMAL, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 25, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 50, -VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 25, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addDisparo (80, DISPARO_GR, DISP_2ABAJO, 5, 30);
				navezepelin[numLibre]->addDisparo (240, DISPARO_PEQ, DISP_8CIRCULAR, 3, 40);
				navezepelin[numLibre]->addMovimiento(2, 140, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
			}
		break;
		case 2080:
			juego->setZonaSobrepasada(1);
		break;
		case 2100:
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX( gaviotas[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, 100 ,0);
			}
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, -100 ,0);
			}
		break;
		case 2160:
			numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(6,1))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 25,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 40,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_2ABAJO, 4,  15);
			}
			numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 25,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 40,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_2ABAJO, 4, 15);
			}
		break;
		case 2180:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 2140:
			numLibre = elementoLibre (CASETA);
			if (numLibre != -1) {
				caseta[numLibre]->setX(xEnPantalla(5,4)); 
				caseta[numLibre]->setY(-caseta[numLibre]->getAlto());
				caseta[numLibre]->setActivo(1);
				caseta[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 2, 70);
			}
		break;
		case 2200:
			numLibre = elementoLibre (LANCHA);
			if (numLibre != -1) {
				lancha[numLibre]->setX(xEnPantalla(5,1)); 
				lancha[numLibre]->setY(-lancha[numLibre]->getAlto());
				lancha[numLibre]->setActivo(1);
				lancha[numLibre]->addMovimiento(0, 50, 0, VEL_NORMAL, -1);
				lancha[numLibre]->addMovimiento(0, -1, -VEL_NORMAL, VEL_NORMAL, -1);
				lancha[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 60);
			}
		break;
		case 2220:
			numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(navepeq[numLibre]->getCentrarXen(xEnPantalla(4,1))); 
				navepeq[numLibre]->setY(-navepeq[numLibre]->getAlto());
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(1, -1,  0, VEL_RAPIDO, -1);
				crearFormacionEnFila(navepeq[numLibre], 1, 50, NAVEPEQUENYA, 130 ,0);
			}
		break;
		case 2250:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(screen_w); 
				navemed[numLibre]->setY(yEnPantalla(6,1));
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(2, 5,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, 20,  -VEL_NORMAL, 0, -1);
				navemed[numLibre]->addMovimiento(2, 30,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_2ABAJO, 4,  15);
			}
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(-navemed[numLibre]->getAncho()); 
				navemed[numLibre]->setY(yEnPantalla(6,1));
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(2, 5,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, 20,  VEL_NORMAL, 0, -1);
				navemed[numLibre]->addMovimiento(2, 30,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_2ABAJO, 4, 15);
			}
		break;
		/*
			AQUI EMPIEZAS LAS NUBES MACIZAS
			*/
		case 2400:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(3,1)); 
				mina[numLibre]->setY(yEnPantalla(3,1));
				mina[numLibre]->direccion(DIR_RIGHT); 
				mina[numLibre]->setActivo(1);
			}
		break;
		case 2420:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(3,2)); 
				mina[numLibre]->setY(screen_h/2);
				mina[numLibre]->direccion(DIR_LEFT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 2440:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,1)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1,  0, VEL_MUYRAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 3, 12, GAVIOTA1, 120 ,0);
			}
		break;
		case 2500:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(5,2)); 
				mina[numLibre]->setY(yEnPantalla(5,3));
				mina[numLibre]->direccion(DIR_RIGHT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 2540:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,1)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 25,  0, VEL_MUYRAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_MUYRAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 3, 12, GAVIOTA1, 120 ,0);
			}
		break;
		case 2570:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(screen_w/2); 
				mina[numLibre]->setY(yEnPantalla(6,1));
				mina[numLibre]->direccion(DIR_LEFT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 2600:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,1)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_MUYRAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 3, 12, GAVIOTA1, 120 ,0);
			}
		break;
		case 2640:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(8,1)); 
				mina[numLibre]->setY(yEnPantalla(8,1));
				mina[numLibre]->direccion(DIR_RIGHT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 2720:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,1)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 30,  0, VEL_MUYRAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_MUYRAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 3, 12, GAVIOTA1, 120 ,0);
			}
		break;
		case 2790:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(5,2)); 
				mina[numLibre]->setY(yEnPantalla(5,2));
				mina[numLibre]->direccion(DIR_RIGHT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 2810:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,1)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_MUYRAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 3, 12, GAVIOTA1, 150 ,0);
			}
		break;
		case 2850:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(6,4)); 
				mina[numLibre]->setY(yEnPantalla(6,1));
				mina[numLibre]->direccion(DIR_LEFT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 2860:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,1)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 20,  -VEL_NORMAL, VEL_MUYRAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  -VEL_MUYRAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 8, GAVIOTA1, 110 ,0);
			}
		break;
		case 2870:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(5,3)); 
				mina[numLibre]->setY(yEnPantalla(6,5));
				mina[numLibre]->direccion(DIR_LEFT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 2880:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,5)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1,  0, VEL_MUYRAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 12, GAVIOTA1, -300 ,0);
			}
		break;
		case 2900:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(6,2)); 
				mina[numLibre]->setY(yEnPantalla(5,2));
				mina[numLibre]->direccion(DIR_LEFT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 2940:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,5)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1,  0, VEL_MUYRAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 2, 12, GAVIOTA1, -200 ,0);
			}
		break;
		case 2980:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(6,5)); 
				mina[numLibre]->setY(yEnPantalla(6,1));
				mina[numLibre]->direccion(DIR_LEFT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 3000:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(5,2)); 
				mina[numLibre]->setY(yEnPantalla(5,3));
				mina[numLibre]->direccion(DIR_RIGHT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 3020:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,1)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 30,  -VEL_NORMAL, VEL_MUYRAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  -VEL_MUYRAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 8, GAVIOTA1, 110 ,0);
			}
		break;
		case 3050:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,1)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(MOV_NORMAL, 20,  0, VEL_MUYRAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1,  -VEL_MUYRAPIDO, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 2, 10, GAVIOTA1, 150 ,0);
			}
		break;
		case 3080:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(6,1)); 
				mina[numLibre]->setY(yEnPantalla(6,5));
				mina[numLibre]->direccion(DIR_RIGHT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 3100:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,1)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_MUYRAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 8, GAVIOTA1, 110 ,0);
			}
		break;
		case 3110:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(5,2)); 
				mina[numLibre]->setY(screen_h/2);
				mina[numLibre]->direccion(DIR_RIGHT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 3120:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(6,5)); 
				mina[numLibre]->setY(yEnPantalla(6,4));
				mina[numLibre]->direccion(DIR_LEFT);
				mina[numLibre]->setActivo(1);
			}
		break;
		case 3150:
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(6,1)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_MUYRAPIDO, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 8, GAVIOTA1, 130 ,0);
			}
		break;
			/*
		case 3200:
			numLibre = elementoLibre (MINA);
			if (numLibre != -1) {
				mina[numLibre]->setX(xEnPantalla(7,3)); 
				mina[numLibre]->setY(screen_h/2);
				mina[numLibre]->direccion(DIR_RIGHT);
				mina[numLibre]->setActivo(1);
			}
		break;
			*/
		case 3250://2610
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 35, 0, VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(0, -1, -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 7, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 3360://2620
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX( gaviotas2[numLibre]->getCentrarXen(xEnPantalla(6,1)) ); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, 30, VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, 20, 0, -VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, 15, -VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, 15, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1, VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 5, 12, GAVIOTA1, 0 ,0);
			}
		break;
		case 3480://2740
			numLibre = elementoLibre (CASETA);
			if (numLibre != -1) {
				caseta[numLibre]->setX(xEnPantalla(7,5)); 
				caseta[numLibre]->setY(-caseta[numLibre]->getAlto());
				caseta[numLibre]->setActivo(1);
				caseta[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 2, 70);
			}
		break;
		case 3485://2745
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_DISPARO);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 3490://2750
			numLibre = elementoLibre (CANGREBOT);
			if (numLibre != -1) {
				cangrejo[numLibre]->setX(xEnPantalla(7,2)); 
				cangrejo[numLibre]->setY(60);
				cangrejo[numLibre]->setActivo(1);
				cangrejo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 3580://2840
			numLibre = elementoLibre (LANCHA);
			if (numLibre != -1) {
				lancha[numLibre]->setX(-lancha[numLibre]->getAncho()); 
				lancha[numLibre]->setY(yEnPantalla(6,4));
				lancha[numLibre]->setActivo(1);
				lancha[numLibre]->addMovimiento(0, 70, VEL_LENTO, -VEL_LENTO, -1);
				lancha[numLibre]->addMovimiento(0, -1, 0, -VEL_NORMAL, -1);
				lancha[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_ALJUGADOR, 1, 40);
			}
		break;
		case 3630://2890
			numLibre = elementoLibre (LANCHA);
			if (numLibre != -1) {
				lancha[numLibre]->setX(xEnPantalla(7,1)); 
				lancha[numLibre]->setY(-lancha[numLibre]->getAncho());
				lancha[numLibre]->setActivo(1);
				lancha[numLibre]->addMovimiento(0, 90, 0, VEL_LENTO, -1);
				lancha[numLibre]->addMovimiento(0, 40, VEL_LENTO, 0, -1);
				lancha[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
				lancha[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_ALJUGADOR, 1, 40);
			}
		break;
		case 3640://2900
			numLibre = elementoLibre (NAVEGRANDE);
			if (numLibre != -1) {
				navegrande[numLibre]->setX(screen_w);
				navegrande[numLibre]->setY(yEnPantalla(6,5));
				navegrande[numLibre]->setActivo(1);
				navegrande[numLibre]->addMovimiento(0, 80, -2, -4, -1);
				navegrande[numLibre]->addDisparo (120, DISPARO_PEQ, DISP_2ABAJO, 5, 10);
				navegrande[numLibre]->addDisparo (130, DISPARO_GR, DISP_5ABAJO, 3, 24);
				navegrande[numLibre]->addMovimiento(2, 100, 1, 1, -1);
				navegrande[numLibre]->addMovimiento(0, -1,  0, 4, -1);
			}
		break;
		case 3730://2990
			numLibre = elementoLibre (CANGREBOT);
			if (numLibre != -1) {
				cangrejo[numLibre]->setX(xEnPantalla(6,2)); 
				cangrejo[numLibre]->setY(yEnPantalla(7,1));
				cangrejo[numLibre]->setActivo(1);
				cangrejo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 3740://3000
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setTipoRegalo(AG_VIDA); 
				navezepelin[numLibre]->setX(-navezepelin[numLibre]->getAncho() + 5);
				navezepelin[numLibre]->setY(yEnPantalla(6,5));
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 80, 2, -4, -1);
				navezepelin[numLibre]->addDisparo (120, DISPARO_PEQ, DISP_2ABAJO, 5, 10);
				navezepelin[numLibre]->addDisparo (130, DISPARO_GR, DISP_5ABAJO, 6, 23);
				navezepelin[numLibre]->addMovimiento(2, 100, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, -4, -1);
			}
		break;
		case 3750://3010
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(-gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 15,  VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA1, 0 ,0);
			}
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(screen_h+gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  -VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA1, 0 ,0);
			}
		break;
		case 3820://3080
			numLibre = elementoLibre (CANGREBOT);
			if (numLibre != -1) {
				cangrejo[numLibre]->setX(xEnPantalla(6,2)); 
				cangrejo[numLibre]->setY(yEnPantalla(7,1));
				cangrejo[numLibre]->setActivo(1);
				cangrejo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 3840://3100
			numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 25,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 40,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo (40, DISPARO_GR, DISP_2ABAJO, 4, 15);
			}
		break;
		case 3990://3250
		numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(xEnPantalla(6,1)); 
				navepeq[numLibre]->setY(-navepeq[numLibre]->getAlto());
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(0, 30,  0, VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  0, -VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  -VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  0, VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 30,  VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  VEL_RAPIDO, -VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				crearFormacionEnFila(navepeq[numLibre], 6, 10, NAVEPEQUENYA, 0 ,0);
			}
		break;
		case 4100:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 4200://3360
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 60,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_3ABAJO, 2, 40);
			}
		break;
		case 4220://3380
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(6,1))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 60,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_3ABAJO, 2, 40);
			}
		break;
		case 4175://3445
			numLibre = elementoLibre (CANGREBOT);
			if (numLibre != -1) {
				cangrejo[numLibre]->setX(xEnPantalla(6,3)); 
				cangrejo[numLibre]->setY(yEnPantalla(7,1));
				cangrejo[numLibre]->setActivo(1);
				cangrejo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 4180://3450
			numLibre = elementoLibre (CASETA);
			if (numLibre != -1) {
				caseta[numLibre]->setX(xEnPantalla(7,6)); 
				caseta[numLibre]->setY(-caseta[numLibre]->getAlto());
				caseta[numLibre]->setActivo(1);
				caseta[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 2, 70);
			}
		break;
		case 4190://3460
			numLibre = elementoLibre (LANCHA);
			if (numLibre != -1) {
				lancha[numLibre]->setX(-lancha[numLibre]->getAncho()); 
				lancha[numLibre]->setY(yEnPantalla(6,2));
				lancha[numLibre]->setActivo(1);
				lancha[numLibre]->addMovimiento(0, 70, VEL_LENTO, -VEL_LENTO, -1);
				lancha[numLibre]->addMovimiento(0, -1, 0, -VEL_NORMAL, -1);
			}
		break;
		case 4210://3480
			numLibre = elementoLibre (LANCHA);
			if (numLibre != -1) {
				lancha[numLibre]->setX(xEnPantalla(6,1)); 
				lancha[numLibre]->setY(-lancha[numLibre]->getAncho());
				lancha[numLibre]->setActivo(1);
				lancha[numLibre]->addMovimiento(0, 90, 0, VEL_NORMAL, -1);
				lancha[numLibre]->addMovimiento(0, -1, -VEL_NORMAL, 0, -1);
			}
		break;
		case 4230://3500
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(screen_w); 
				gaviotas2[numLibre]->setY(screen_h/2);
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 25,  -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA2, 0 ,0);
			}
		break;
		case 4280://3550
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(xEnPantalla(7,2)); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(1, -1,  0, VEL_NORMAL, -1);
			}
			crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, 350 ,0);
		break;
		case 4310://3580
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(7,2))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_5ABAJO, 2, 10);
				navemed[numLibre]->addMovimiento(2, 60,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(7,5))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_5ABAJO, 2, 10);
				navemed[numLibre]->addMovimiento(2, 60,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_RAPIDO, -1);
			}
		break;
		case 4420://3690
			numLibre = elementoLibre (NAVEGRANDE);
			if (numLibre != -1) {
				navegrande[numLibre]->setX(navegrande[numLibre]->getCentrarXen(screen_w/2)); 
				navegrande[numLibre]->setY(-navegrande[numLibre]->getAlto() - 30);
				navegrande[numLibre]->setActivo(1);
				navegrande[numLibre]->addMovimiento(0, 35,  0, VEL_NORMAL, -1);
				navegrande[numLibre]->addMovimiento(2, 180,  0, VEL_NORMAL, -1);
				navegrande[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navegrande[numLibre]->addDisparo (50, DISPARO_GR,  DISP_3ABAJO_CERRADO, 2, 40);
				navegrande[numLibre]->addDisparo (100, DISPARO_PEQ, DISP_6LATERALES, 2, 40);
				navegrande[numLibre]->addDisparo (130, DISPARO_GR, DISP_2ABAJO, 6, 10);
			}
		break;
		case 4530://3800
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				gaviotas[numLibre]->setY(screen_h + gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 50, 0, -VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,1))); 
				gaviotas[numLibre]->setY(screen_h + gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 40, 0, -VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 4580://3850
			numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(8,2))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 30,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo (40, DISPARO_GR, DISP_4CRUZ, 6, 10);
				gavibot[numLibre]->addDisparo (50, DISPARO_PEQ, DISP_3ABAJO, 3, 23);
				gavibot[numLibre]->addMovimiento(2, 70,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(8,6))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 30,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo (40, DISPARO_GR, DISP_4CRUZ, 6, 10);
				gavibot[numLibre]->addDisparo (50, DISPARO_PEQ, DISP_3ABAJO, 3, 23);
				gavibot[numLibre]->addMovimiento(2, 70,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_RAPIDO, -1);
			}
		break;
		case 4780:
			initFinalNivel1();
		break;
	}

}

void Pantalla::dibujarFinal () {
	
	switch(juego->getNivel()) {
		case 1:
			dibujarFinal1();
		break;
		case 2:
			dibujarFinal2();
		break;
		case 3:
			dibujarFinal3();
		break;
	}
	
	// dibujamos el versus saliendo
	
	if (mitadVersusAbajo->getY()<480) {
		mitadVersusAbajo->mover();
		mitadVersusAbajo->dibujar(screen);
	}
	if (mitadVersusArriba->getY()>-240) {
		mitadVersusArriba->mover();			
		mitadVersusArriba->dibujar(screen);
	}

}
	
void Pantalla::dibujarFinal1 () {

	int j, numLibre, x;
	// mostrar mapa
	mapa->dibujarFinal(screen, juego);

	if (torrebal_der->getActivo() == 1) {
		torrebal_der->dibujar(screen);
	}
	if (torrebal_izq->getActivo() == 1) {
		torrebal_izq->dibujar(screen);
	}
	
	explosiones->dibujarExplosionTierra(screen);
	moverEnemigoTierra();
	explosiones->dibujarExplosionAire(screen);
	//moverEnemigoAire();
	dibujarAgregadores();
	
	crearDisparoEnemigo();
	disp_ene->moverDisparo(screen);
	
	// mostrar jefe y torres

	if (jefe1->getActivo() == 1) {
		jefe1->mover();
		jefe1->crearDisparo(disp_ene, sonido);
		jefe1->dibujar(screen);
	}

	// abrir torres y crear cangrejos al fin de la llamada
	if (jefe1->getFinLLamada() == 1) {
		sonido->playSonido(SND_SIRENAS);
		torrebal_der->resetearCiclos ();
		torrebal_izq->resetearCiclos ();
		torrebal_der->abrirTorre();
		torrebal_izq->abrirTorre();
		torrebal_der->addDisparo (40, DISPARO_PEQ, DISP_ALJUGADOR, 4, 90);
		torrebal_izq->addDisparo (60, DISPARO_PEQ, DISP_ALJUGADOR, 4, 60);
		
		numLibre = elementoLibre (CANGREBOT);
		if (numLibre != -1) {
			x = rand();
			if ( x > 150 ) {
				x = (int) x % 150;
			}
			cangrejo[numLibre]->setX(x); 
			cangrejo[numLibre]->setY(yEnPantalla(7,4));
			cangrejo[numLibre]->setActivo(1);
			cangrejo[numLibre]->setMoverY(0);
			cangrejo[numLibre]->setTiempoEsconderse(180);
			cangrejo[numLibre]->addDisparo (70, DISPARO_PEQ, DISP_ALJUGADOR, 6, 80);
		}

		numLibre = elementoLibre (CANGREBOT);
		if (numLibre != -1) {
			x = rand();
			if ( x > 480 ) {
				x = (int) x % 480;
			}
			if ( x < 220 ) {
				x = 220;
			}
			cangrejo[numLibre]->setX(x); 
			cangrejo[numLibre]->setY(yEnPantalla(2,1));
			cangrejo[numLibre]->setActivo(1);
			cangrejo[numLibre]->setMoverY(0);
			cangrejo[numLibre]->setTiempoEsconderse(180);
			cangrejo[numLibre]->addDisparo (90, DISPARO_PEQ, DISP_ALJUGADOR, 6, 90);
		}	
	}
	DisparoJugador* disp_jugador = jugador->getDisparoJugador();
	disp_jugador->mover(screen);
	
	comprobarColisiones();
	
	dibujarChispas();
	
	// comprobar colision de balas con jefe
	for (j=0; j < MAXBALAS; j++) {
		if ( disp_jugador->getDisparo(j)->getActivo())  {
			if (jefe1->getActivo()==1 && ( jefe1->colision(disp_jugador->getDisparo(j)) == TRUE ) ){
				// restar impactos para morir y eliminar bala de pantalla
				jefe1->addImpactosParaMorir(sonido, juego, explosiones);
				disp_jugador->getDisparo(j)->setActivo(0);
				crearChispa(disp_jugador->getDisparo(j)->getX(), disp_jugador->getDisparo(j)->getY());
				if (jefe1->getImpactosParaMorir() <= 0) {
					setSalirFase(juego->getCiclos());
				}
			}
		}
	}
	if (EnPoderCadista) {
		for ( j=0; j < MAX_BALON; j++) {
			if ( (disp_jugador->getBalon(j)->getActivo())  && ( jefe1->colision(disp_jugador->getBalon(j)) == TRUE ) ) {
				// restar impactos para morir y eliminar bala de pantalla
				jefe1->addImpactosParaMorir(sonido, juego, explosiones);
				crearChispa(disp_jugador->getDisparo(j)->getX(), disp_jugador->getDisparo(j)->getY());
				disp_jugador->getBalon(j)->setActivo(0);
				if (jefe1->getImpactosParaMorir() <= 0) {
					setSalirFase(juego->getCiclos());
				}
			}
		}
	}
	
	// comprobar colision de jugador con cangrejo
	if ( (jefe1->getActivo()==1) && (jugador->getFantasma()==0) && ( jefe1->colisionConJugador(jugador) == TRUE ) && (jugador->getEstado() == 2) ){
		jugador->setEstado(0); // estado de muerte de jugador			
	}
	
	
	dibujarJugador ();
	comprobarEstelaBomba();
	comprobarBalones();

	barra->dibujarBarra(screen, juego, intercom);
		
}

void Pantalla::crearElementoNivel3 () {
	int numLibre;
	comprobarConversacionAleatoria();
	
	switch (juego->getCiclos()) {
		case 100:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_ROJO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 110:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_MUYRAPIDO, -1);
			}
		break;
		case 140:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_VIOLETA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 20, 0, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, VEL_LENTO, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_MUYRAPIDO, -1);
			}
		break;
		case 160:
			if (juego->getConversacionParaAbrirEnFase() == 1)
				intercom->abrirIntercom(juego->getNivel(), 1, sonido);
		break;
		case 180:
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX( gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,1)) ); 
				gaviotas2[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA2, 80 ,0);
			}
		break;
		case 220:
		numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 80,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 15);
				gavibot[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 80,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 15);
				gavibot[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		break;
		case 300:
		numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(navepeq[numLibre]->getCentrarXen(screen_w/2)); 
				navepeq[numLibre]->setY(-navepeq[numLibre]->getAlto());
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(0, 30,  0, VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(navepeq[numLibre], 4, 20, NAVEPEQUENYA, 0 ,0);
			}
		break;
		case 310:
		numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(navepeq[numLibre]->getCentrarXen(screen_w/2)); 
				navepeq[numLibre]->setY(-navepeq[numLibre]->getAlto());
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(0, 30,  0, VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(navepeq[numLibre], 4, 20, NAVEPEQUENYA, 0 ,0);
			}
		break;
		case 350:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 360:
			juego->setHacerClip(0);
			intercom->cerrarIntercom(sonido);
		break;
		case 380:
			numLibre = elementoLibre (VALLA_IZQ);
			if (numLibre != -1) {
				valla_izq[numLibre]->setX( valla_izq[numLibre]->getCentrarXen(xEnPantalla(8,1)) ); 
				valla_izq[numLibre]->setY(-valla_izq[numLibre]->getAlto());
				valla_izq[numLibre]->setActivo(1);
			}
		break;
		case 390:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 410:
			numLibre = elementoLibre (VALLA_IZQ);
			if (numLibre != -1) {
				valla_izq[numLibre]->setX( valla_izq[numLibre]->getCentrarXen(xEnPantalla(8,1)) ); 
				valla_izq[numLibre]->setY(-valla_izq[numLibre]->getAlto());
				valla_izq[numLibre]->setActivo(1);
			}
		break;
		case 430:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(screen_w); 
				navemed[numLibre]->setY(120);
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, 0, -1);
				navemed[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 4, 15);
			}
		break;
		case 440:
			numLibre = elementoLibre (VALLA_IZQ);
			if (numLibre != -1) {
				valla_izq[numLibre]->setX( valla_izq[numLibre]->getCentrarXen(xEnPantalla(8,1)) ); 
				valla_izq[numLibre]->setY(-valla_izq[numLibre]->getAlto());
				valla_izq[numLibre]->setActivo(1);
			}
		break;
		case 480:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_AMARILLO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
		break;
		case 490:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 500:
			numLibre = elementoLibre (NAVEGRANDE);
			if (numLibre != -1) {
				navegrande[numLibre]->setTipoRegalo(AG_PODER); 
				navegrande[numLibre]->setX(navegrande[numLibre]->getCentrarXen(screen_w/2)); 
				navegrande[numLibre]->setY(-navegrande[numLibre]->getAlto() - 30);
				navegrande[numLibre]->setActivo(1);
				navegrande[numLibre]->addMovimiento(0, 30,  0, VEL_NORMAL, -1);
				navegrande[numLibre]->addMovimiento(2, 220,  0, VEL_NORMAL, -1);
				navegrande[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navegrande[numLibre]->addDisparo (50, DISPARO_GR_AZUL,  DISP_5ABAJO, 3, 20);
				navegrande[numLibre]->addDisparo (120, DISPARO_PEQ, DISP_6LATERALES, 3, 20);
				navegrande[numLibre]->addDisparo (160, DISPARO_GR, DISP_2ABAJO, 6, 10);
			}
		break;
		case 520:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0, -1, VEL_NORMAL, 0, -1);
			}
		break;
		case 560:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_VIOLETA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_NORMAL, -1);
			}
		break;
		case 590:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 15,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 50,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_2ABAJO, 3, 20);
			}
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(6,1))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 15,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 50,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_2ABAJO, 3, 20);
			}
		break;
		case 670:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_NORMAL, -VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_NORMAL, -VEL_RAPIDO, -1);
			}
		break;
		case 680:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,4)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 10, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, -VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_NORMAL, -VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_NORMAL, -VEL_RAPIDO, -1);
			}
		break;
		case 690:
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(gaviotas2[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gaviotas2[numLibre]->setY(screen_h + gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 40, 0, -VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(gaviotas2[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				gaviotas2[numLibre]->setY(screen_h + gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 30, 0, -VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 750:
		numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(-navepeq[numLibre]->getAncho()); 
				navepeq[numLibre]->setY(screen_h/2);
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(0, 30,  VEL_NORMAL, 0, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  0, -VEL_NORMAL, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, -VEL_NORMAL, -1);
				crearFormacionEnFila(navepeq[numLibre], 4, 15, NAVEPEQUENYA, 0 ,0);
			}
		break;
		case 790:
			numLibre = elementoLibre (TAXI);
			if (numLibre != -1) {
				taxi[numLibre]->setX(taxi[numLibre]->getCentrarXen(xEnPantalla(9,2))); 
				taxi[numLibre]->setY(-taxi[numLibre]->getAlto());
				taxi[numLibre]->setActivo(1);
				taxi[numLibre]->addMovimiento(0, 130, 0, VEL_MAPA, -1);
				taxi[numLibre]->addMovimiento(0, 10, VEL_NORMAL, VEL_NORMAL, -1);
				taxi[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 800:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 810:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_AMARILLO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_NORMAL, -1);
			}
		break;
		case 840:
			numLibre = elementoLibre (TAXI);
			if (numLibre != -1) {
				taxi[numLibre]->setX(taxi[numLibre]->getCentrarXen(xEnPantalla(9,2))); 
				taxi[numLibre]->setY(-taxi[numLibre]->getAlto());
				taxi[numLibre]->setActivo(1);
				taxi[numLibre]->addMovimiento(0, 100, 0, VEL_MAPA, -1);
				taxi[numLibre]->addMovimiento(0, 10, VEL_NORMAL, VEL_NORMAL, -1);
				taxi[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 860:
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(-gaviotas[numLibre]->getAncho()); 
				gaviotas[numLibre]->setY(yEnPantalla(4,2));
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 35,  VEL_RAPIDO, 0, -1);
				gaviotas[numLibre]->addMovimiento(0, 20,  0, -VEL_RAPIDO, -1);	
				gaviotas[numLibre]->addMovimiento(0, 20,  -VEL_RAPIDO, 0, -1);	
				gaviotas[numLibre]->addMovimiento(0, 20,  0, VEL_RAPIDO, -1);	
				gaviotas[numLibre]->addMovimiento(0, 20,  VEL_RAPIDO, 0, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);	
				crearFormacionEnFila(gaviotas[numLibre], 6, 10, GAVIOTA1, 0 ,0);
			}
		break;
		case 890:
			numLibre = elementoLibre (TAXI);
			if (numLibre != -1) {
				taxi[numLibre]->setX(taxi[numLibre]->getCentrarXen(xEnPantalla(9,2))); 
				taxi[numLibre]->setY(-taxi[numLibre]->getAlto());
				taxi[numLibre]->setActivo(1);
				taxi[numLibre]->addMovimiento(0, 70, 0, VEL_MAPA, -1);
				taxi[numLibre]->addMovimiento(0, 10, VEL_NORMAL, VEL_NORMAL, -1);
				taxi[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 900:
			numLibre = elementoLibre (NAVEGRANDE);
			if (numLibre != -1) {
				navegrande[numLibre]->setX(screen_w);
				navegrande[numLibre]->setY(yEnPantalla(6,5));
				navegrande[numLibre]->setActivo(1);
				navegrande[numLibre]->addMovimiento(0, 80, -2, -4, -1);
				navegrande[numLibre]->addDisparo (120, DISPARO_PEQ, DISP_2ABAJO, 5, 10);
				navegrande[numLibre]->addDisparo (130, DISPARO_GR, DISP_5ABAJO, 3, 24);
				navegrande[numLibre]->addMovimiento(2, 100, 1, 1, -1);
				navegrande[numLibre]->addMovimiento(0, -1,  0, 4, -1);
			}
		break;
		case 920:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(8,6)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 930:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_NORMAL, -1);
			}
		break;
		case 950:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(KADETT_ROJO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 20, 0, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, VEL_NORMAL, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 1000:
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setX(-navezepelin[numLibre]->getAncho() + 5);
				navezepelin[numLibre]->setY(yEnPantalla(6,5));
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 80, 2, -4, -1);
				navezepelin[numLibre]->addDisparo (120, DISPARO_PEQ, DISP_2ABAJO, 5, 10);
				navezepelin[numLibre]->addDisparo (130, DISPARO_GR, DISP_5ABAJO, 6, 23);
				navezepelin[numLibre]->addMovimiento(2, 100, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, -4, -1);
			}
		break;
		case 1030:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_CREMA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(9,6)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, VEL_LENTO, -VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, 0, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_LENTO, -VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_MUYRAPIDO, -1);
			}
		break;
		case 1040:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(KADETT_AZUL);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(9,6)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, VEL_LENTO, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 20, 0, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 20, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_MUYRAPIDO, -1);
			}
		break;
		case 1050:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_VIOLETA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(9,5)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, 0, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_MUYRAPIDO, -1);
			}
		break;
		case 1060:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 20, 0, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 20, VEL_LENTO, VEL_MUYRAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_MUYRAPIDO, -1);
			}
		break;
		case 1100:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 1140:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(6,2)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 20, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_RAPIDO, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(6,4)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 20, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_RAPIDO, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( -helicoptero[numLibre]->getAncho() ); 
				helicoptero[numLibre]->setY( helicoptero[numLibre]->getCentrarYen(yEnPantalla(5,4)) );
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, VEL_NORMAL, -VEL_LENTO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 30, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, 0, -VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, 0, -VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( screen_w ); 
				helicoptero[numLibre]->setY( helicoptero[numLibre]->getCentrarYen(yEnPantalla(5,4)) );
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, -VEL_NORMAL, -VEL_LENTO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 30, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, 0, -VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
			/*
		case 1140:
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(gaviotas2[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAncho());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 40, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 12, GAVIOTA1, 0 ,0);
			}
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(gaviotas2[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAncho());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 12, GAVIOTA1, 0 ,0);
			}
		break;
		*/
		case 1150:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_CREMA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, 0, VEL_NORMAL, -1);
				csimple[numLibre]->addMovimiento(0, 10, VEL_LENTO, VEL_NORMAL, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 1160:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 1180:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(KADETT_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 1200:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(9,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 1210:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(9,7)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_MUYRAPIDO, -1);
			}
		break;
		case 1230:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( -cpolicia[numLibre]->getAncho() ); 
				cpolicia[numLibre]->setY(yEnPantalla(7,2));
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, 20, VEL_RAPIDO, 0, -1);
				cpolicia[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( screen_w ); 
				cpolicia[numLibre]->setY(yEnPantalla(7,2));
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, 20, -VEL_RAPIDO, 0, -1);
				cpolicia[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 1250:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( tanque[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				tanque[numLibre]->setY(-tanque[numLibre]->getAlto());
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, 40, 0, VEL_MAPA, -1);
				tanque[numLibre]->addMovimiento(0, 50, VEL_LENTO, VEL_MAPA, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( tanque[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				tanque[numLibre]->setY(-tanque[numLibre]->getAlto());
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, 30, 0, VEL_MAPA, -1);
				tanque[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, 50, -VEL_LENTO, VEL_MAPA, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
		break;
		case 1260:
		numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(-navepeq[numLibre]->getAncho()); 
				navepeq[numLibre]->setY(screen_h/2);
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(0, 20,  VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);
				crearFormacionEnFila(navepeq[numLibre], 4, 15, NAVEPEQUENYA, 0 ,0);
			}
		break;
		case 1280:
		numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(screen_w); 
				navepeq[numLibre]->setY(screen_h/2);
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(0, 20,  -VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  0, VEL_RAPIDO, -1);
				crearFormacionEnFila(navepeq[numLibre], 4, 15, NAVEPEQUENYA, 0 ,0);
			}
		break;
		case 1320:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(-navemed[numLibre]->getAncho()); 
				navemed[numLibre]->setY(yEnPantalla(7,2));
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 1,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, 20,  VEL_NORMAL, 0, -1);
				navemed[numLibre]->addMovimiento(2, 50,  VEL_NORMAL, 0, -1);
				navemed[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_3ABAJO, 3, 30);
			}
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(screen_w); 
				navemed[numLibre]->setY(yEnPantalla(7,2));
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 1,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, 20,  -VEL_NORMAL, 0, -1);
				navemed[numLibre]->addMovimiento(2, 50,  -VEL_NORMAL, 0, -1);
				navemed[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_3ABAJO, 3, 30);
			}
		break;
		case 1390:
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setX(navezepelin[numLibre]->getCentrarXen(screen_w/2));
				navezepelin[numLibre]->setY(-navezepelin[numLibre]->getAlto());
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 40, 0, VEL_LENTO, -1);
				navezepelin[numLibre]->addMovimiento(2, 100, 0, VEL_LENTO, -1);
				navezepelin[numLibre]->addMovimiento(0, -1, 0, VEL_LENTO, -1);
				navezepelin[numLibre]->addDisparo (70, DISPARO_PEQ, DISP_2ABAJO, 2, 30);
				navezepelin[numLibre]->addDisparo (120, DISPARO_ROT, DISP_8CIRCULAR, 2, 40);
			}
		break;
		case 1400:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_CREMA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 1430:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(KADETT_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_NORMAL, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
		break;
		case 1450:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(KADETT_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 1480:
		numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 80,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 15);
				gavibot[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 80,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 15);
				gavibot[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		break;
		case 1550:
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(9,2))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
			numLibre = elementoLibre (BARRERA_IZQ);
			if (numLibre != -1) {
				barrera_izq[numLibre]->setX(barrera_izq[numLibre]->getCentrarXen(xEnPantalla(9,5))); 
				barrera_izq[numLibre]->setY(-barrera_izq[numLibre]->getAlto());
				barrera_izq[numLibre]->setActivo(1);
			}
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(9,6))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
		break;
		case 1560:
			numLibre = elementoLibre (BARRERA_IZQ);
			if (numLibre != -1) {
				barrera_izq[numLibre]->setX(barrera_izq[numLibre]->getCentrarXen(xEnPantalla(9,3))); 
				barrera_izq[numLibre]->setY(-barrera_izq[numLibre]->getAlto());
				barrera_izq[numLibre]->setActivo(1);
			}
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(9,4))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
			numLibre = elementoLibre (BARRERA_IZQ);
			if (numLibre != -1) {
				barrera_izq[numLibre]->setX(barrera_izq[numLibre]->getCentrarXen(xEnPantalla(9,7))); 
				barrera_izq[numLibre]->setY(-barrera_izq[numLibre]->getAlto());
				barrera_izq[numLibre]->setActivo(1);
			}
		break;
		case 1620:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(9,2)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0,10, VEL_RAPIDO, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0,-1, 0, VEL_MAPA, -1);
			}
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(9,6)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0,10, 0, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0,-1, 0, VEL_MAPA, -1);
			}
		break;
		case 1640:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(9,4)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0,10, -VEL_RAPIDO, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0,-1, 0, VEL_MAPA, -1);
			}
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(9,7)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0,10, 0, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0,-1, 0, VEL_MAPA, -1);
			}
		break;
		case 1690:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( tanque[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				tanque[numLibre]->setY(-tanque[numLibre]->getAlto());
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, VEL_MAPA, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 50);
			}
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( tanque[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				tanque[numLibre]->setY(-tanque[numLibre]->getAlto());
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, VEL_MAPA, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 50);
			}
		break;
		case 1720:
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(screen_w); 
				gaviotas2[numLibre]->setY(yEnPantalla(6,4));
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 15,  -VEL_NORMAL, -VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, 35,  -VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_RAPIDO, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 2, 10, GAVIOTA2, 0 ,0);
			}
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(-gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(yEnPantalla(6,1));
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 15,  VEL_NORMAL, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, 35,  VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, -VEL_RAPIDO, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 2, 10, GAVIOTA2, 0 ,0);
			}
		break;
		case 1770:
			numLibre = elementoLibre (NAVEGRANDE);
			if (numLibre != -1) {
				navegrande[numLibre]->setTipoRegalo(AG_DISPARO); 
				navegrande[numLibre]->setX(navegrande[numLibre]->getCentrarXen(screen_w/2)); 
				navegrande[numLibre]->setY(-navegrande[numLibre]->getAlto() - 30);
				navegrande[numLibre]->setActivo(1);
				navegrande[numLibre]->addMovimiento(0, 30,  0, VEL_NORMAL, -1);
				navegrande[numLibre]->addMovimiento(2, 220,  0, VEL_NORMAL, -1);
				navegrande[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navegrande[numLibre]->addDisparo (50, DISPARO_GR,  DISP_3ABAJO, 3, 20);
				navegrande[numLibre]->addDisparo (120, DISPARO_PEQ, DISP_6LATERALES, 3, 20);
				navegrande[numLibre]->addDisparo (160, DISPARO_GR, DISP_2ABAJO, 6, 40);
			}
		break;
		case 1790:
			numLibre = elementoLibre (VALLA_IZQ);
			if (numLibre != -1) {
				valla_izq[numLibre]->setX( valla_izq[numLibre]->getCentrarXen(xEnPantalla(8,7)) ); 
				valla_izq[numLibre]->setY(-valla_izq[numLibre]->getAlto());
				valla_izq[numLibre]->setActivo(1);
			}
		break;
		case 1820:
			numLibre = elementoLibre (VALLA_IZQ);
			if (numLibre != -1) {
				valla_izq[numLibre]->setX( valla_izq[numLibre]->getCentrarXen(xEnPantalla(8,7)) ); 
				valla_izq[numLibre]->setY(-valla_izq[numLibre]->getAlto());
				valla_izq[numLibre]->setActivo(1);
			}
		break;
		case 1920:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_VIOLETA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 1930:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 1940:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(KADETT_AZUL);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, 0, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, VEL_NORMAL, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 1980:
			numLibre = elementoLibre (TAXI);
			if (numLibre != -1) {
				taxi[numLibre]->setX(taxi[numLibre]->getCentrarXen(xEnPantalla(9,7))); 
				taxi[numLibre]->setY(-taxi[numLibre]->getAlto());
				taxi[numLibre]->setActivo(1);
				taxi[numLibre]->addMovimiento(0, 80, 0, VEL_MAPA, -1);
				taxi[numLibre]->addMovimiento(0, 10, -VEL_NORMAL, VEL_NORMAL, -1);
				taxi[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 2000:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( -cpolicia[numLibre]->getAncho() ); 
				cpolicia[numLibre]->setY(cpolicia[numLibre]->getCentrarYen(yEnPantalla(9,4)));
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0,30, VEL_RAPIDO, 0, -1);
				cpolicia[numLibre]->addMovimiento(0,25, 0, -VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0,-1, VEL_RAPIDO, 0, -1);
			}
		break;
		case 2010:
			if (juego->getConversacionParaAbrirEnFase() == 2)
				intercom->abrirIntercom(juego->getNivel(), 2, sonido);
		break;
		case 2030:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_ROJO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 2050:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 20, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_RAPIDO, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 20, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_RAPIDO, 0, -1);
			}
		break;
		case 2060:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, 0, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, VEL_NORMAL, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 2070:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(screen_w); 
				navemed[numLibre]->setY(120);
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, 0, -1);
				navemed[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 2, 35);
			}
		break;
		case 2080:
			juego->setZonaSobrepasada(1);
		break;
		case 2100:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(6,2)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 20, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_RAPIDO, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(6,4)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 20, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_RAPIDO, 0, -1);
			}
		break;
		case 2110:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_AZUL);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, 0, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_NORMAL, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 2120:
		numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(xEnPantalla(5,1)); 
				navepeq[numLibre]->setY(-navepeq[numLibre]->getAlto());
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(0, 30,  0, VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  0, -VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  -VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  0, VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 30,  VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  VEL_RAPIDO, -VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				crearFormacionEnFila(navepeq[numLibre], 6, 10, NAVEPEQUENYA, 0 ,0);
			}
		break;
		case 2140:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_DISPARO);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 2150:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( screen_w ); 
				tanque[numLibre]->setY(tanque[numLibre]->getCentrarYen(yEnPantalla(7,3)));
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 15, -VEL_NORMAL, VEL_MAPA, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, VEL_MAPA, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 50);
			}
		break;
		case 2160:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, 0, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_NORMAL, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 2190:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 2200:
			juego->setHacerClip(0);
			intercom->cerrarIntercom(sonido);
		break;
		case 2220:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_AZUL);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(KADETT_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 15, VEL_LENTO, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 2250:
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setX(navezepelin[numLibre]->getCentrarXen(screen_w/2));
				navezepelin[numLibre]->setY(- navezepelin[numLibre]->getAlto() - 30);
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 30, 0, VEL_NORMAL, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 20, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 40, -VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 15, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addDisparo (80, DISPARO_GR, DISP_2ABAJO, 5, 30);
				navezepelin[numLibre]->addDisparo (240, DISPARO_PEQ, DISP_3ABAJO, 4, 40);
				navezepelin[numLibre]->addDisparo (250, DISPARO_GR, DISP_5ABAJO, 3, 30);
				navezepelin[numLibre]->addMovimiento(2, 70, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);
			}
		break;
		case 2260:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_CREMA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 2270:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 10, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_RAPIDO, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 10, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_RAPIDO, 0, -1);
			}
		break;
		case 2300:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_AMARILLO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 15, VEL_LENTO, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 2330:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, 0, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_NORMAL, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 2350:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_AZUL);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 15, VEL_LENTO, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 2380:
			sonido->empezarMusicaSecundaria(MUS_CABARGATA);
		break;
		case 2480:
			numLibre = elementoLibre (CARROZA);
			if (numLibre != -1) {
				carroza[numLibre]->selCarroza(PIRATA);
				carroza[numLibre]->setX( carroza[numLibre]->getCentrarXen(xEnPantalla(8,5)) ); 
				carroza[numLibre]->setY(-carroza[numLibre]->getAlto()-85);
				carroza[numLibre]->setActivo(1);
				carroza[numLibre]->addDisparo (30, DISPARO_ROT, DISP_5ABAJO, 5, 40);
				carroza[numLibre]->addDisparo (50, DISPARO_ROT, DISP_ALJUGADOR, 5, 40);
			}
		break;
		case 2540:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_AMARILLO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 2560:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_NORMAL, VEL_LENTO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(-navepeq[numLibre]->getAncho()); 
				navepeq[numLibre]->setY(screen_h/2);
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(0, 20,  VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);
				crearFormacionEnFila(navepeq[numLibre], 4, 15, NAVEPEQUENYA, 0 ,0);
			}
		break;
		case 2650:
			numLibre = elementoLibre (CARROZA);
			if (numLibre != -1) {
				carroza[numLibre]->selCarroza(DEMONIO);
				carroza[numLibre]->setX( carroza[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				carroza[numLibre]->setY(-carroza[numLibre]->getAlto()-85);
				carroza[numLibre]->setActivo(1);
				carroza[numLibre]->addDisparo (30, DISPARO_GR, DISP_2ABAJO, 8, 40);
				carroza[numLibre]->addDisparo (50, DISPARO_PEQ, DISP_4OBLICUO, 8, 40);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(9,2)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 20, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_RAPIDO, 0, -1);
			}
		break;
		case 2670:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( -helicoptero[numLibre]->getAncho() ); 
				helicoptero[numLibre]->setY( helicoptero[numLibre]->getCentrarYen(yEnPantalla(7,4)) );
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 30, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, 0, -VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 2680:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX(-cpolicia[numLibre]->getAncho() ); 
				cpolicia[numLibre]->setY(cpolicia[numLibre]->getCentrarYen(yEnPantalla(7,4)));
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, 20, VEL_RAPIDO, 0, -1);
				cpolicia[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 2690:
		numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(screen_w/2); 
				navepeq[numLibre]->setY(-navepeq[numLibre]->getAlto());
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(1, -1,  0, VEL_NORMAL, -1);
				crearFormacionEnFila(navepeq[numLibre], 2, 15, NAVEPEQUENYA, 100 ,0);
			}
		break;
		case 2820:
			numLibre = elementoLibre (CARROZA);
			if (numLibre != -1) {
				carroza[numLibre]->setTipoRegalo(AG_VIDA);
				carroza[numLibre]->selCarroza(MAR);
				carroza[numLibre]->setX( carroza[numLibre]->getCentrarXen(xEnPantalla(8,3)) ); 
				carroza[numLibre]->setY(-carroza[numLibre]->getAlto()-85);
				carroza[numLibre]->setActivo(1);
				carroza[numLibre]->addDisparo (50, DISPARO_GR, DISP_ALJUGADOR, 5, 40);
				carroza[numLibre]->addDisparo (30, DISPARO_ROT, DISP_6LATERALES, 8, 40);
			}
		break;
		case 2900:
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(gaviotas2[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAncho());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 2950:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_VIOLETA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 2960:
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(gaviotas2[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAncho());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1, VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 2970:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 3000:
			numLibre = elementoLibre (CARROZA);
			if (numLibre != -1) {
				carroza[numLibre]->selCarroza(CASTILLO);
				carroza[numLibre]->setX( carroza[numLibre]->getCentrarXen(xEnPantalla(8,5)) ); 
				carroza[numLibre]->setY(-carroza[numLibre]->getAlto()-85);
				carroza[numLibre]->setActivo(1);
				carroza[numLibre]->addDisparo (30, DISPARO_ROT, DISP_4OBLICUO, 8, 30);
				carroza[numLibre]->addDisparo (50, DISPARO_PEQ, DISP_ALJUGADOR, 8, 80);
			}
		break;
		case 3070:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(KADETT_ROJO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 3090:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 3100:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(9,2)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 20, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 20, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_RAPIDO, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_RAPIDO, 0, -1);
			}
		break;
		case 3230:
			sonido->terminarMusicaSecundaria();
		break;
		case 3250:
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(9,2))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
			numLibre = elementoLibre (BARRERA_IZQ);
			if (numLibre != -1) {
				barrera_izq[numLibre]->setX(barrera_izq[numLibre]->getCentrarXen(xEnPantalla(9,5))); 
				barrera_izq[numLibre]->setY(-barrera_izq[numLibre]->getAlto());
				barrera_izq[numLibre]->setActivo(1);
			}
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(9,6))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
		break;
		case 3260:
			numLibre = elementoLibre (BARRERA_IZQ);
			if (numLibre != -1) {
				barrera_izq[numLibre]->setX(barrera_izq[numLibre]->getCentrarXen(xEnPantalla(9,3))); 
				barrera_izq[numLibre]->setY(-barrera_izq[numLibre]->getAlto());
				barrera_izq[numLibre]->setActivo(1);
			}
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(9,4))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
			numLibre = elementoLibre (BARRERA_IZQ);
			if (numLibre != -1) {
				barrera_izq[numLibre]->setX(barrera_izq[numLibre]->getCentrarXen(xEnPantalla(9,7))); 
				barrera_izq[numLibre]->setY(-barrera_izq[numLibre]->getAlto());
				barrera_izq[numLibre]->setActivo(1);
			}
		break;
		case 3330:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(9,1)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0,10, VEL_RAPIDO, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0,-1, 0, VEL_MAPA, -1);
			}
		break;
		case 3350:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(9,7)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0,10, 0, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0,-1, 0, VEL_MAPA, -1);
			}
		break;
		case 3370:
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(gaviotas2[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAncho());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 3400:
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setX(navezepelin[numLibre]->getCentrarXen(screen_w/2));
				navezepelin[numLibre]->setY(- navezepelin[numLibre]->getAlto() - 30);
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 30, 0, VEL_NORMAL, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 30, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 60, -VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addMovimiento(0, 25, VEL_LENTO, 0, -1);
				navezepelin[numLibre]->addDisparo (80, DISPARO_GR, DISP_2ABAJO, 5, 30);
				navezepelin[numLibre]->addDisparo (240, DISPARO_PEQ, DISP_3ABAJO_CERRADO, 4, 40);
				navezepelin[numLibre]->addDisparo (250, DISPARO_GR, DISP_3ABAJO, 3, 30);
				navezepelin[numLibre]->addMovimiento(2, 180, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
			}
		break;
		case 3450:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( screen_w ); 
				tanque[numLibre]->setY(tanque[numLibre]->getCentrarYen(yEnPantalla(7,1)));
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 15, -VEL_NORMAL, VEL_MAPA, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, VEL_MAPA, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
		break;
		case 3480:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( -tanque[numLibre]->getAncho() ); 
				tanque[numLibre]->setY(tanque[numLibre]->getCentrarYen(yEnPantalla(7,1)));
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 15, VEL_NORMAL, VEL_MAPA, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, VEL_MAPA, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
		break;
		case 3500:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_CREMA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 3550:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_AMARILLO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 15, VEL_LENTO, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 3560:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_DISPARO);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 3600:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, 0, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_NORMAL, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 3630:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_AZUL);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 15, VEL_LENTO, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 3700:
			numLibre = elementoLibre (TAXI);
			if (numLibre != -1) {
				taxi[numLibre]->setX(screen_w); 
				taxi[numLibre]->setY(taxi[numLibre]->getCentrarYen(yEnPantalla(7,3)));
				taxi[numLibre]->setActivo(1);
				taxi[numLibre]->addMovimiento(0, 20, -VEL_RAPIDO, 0, -1);
				taxi[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 3740:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_CREMA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 15, VEL_LENTO, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 3750:
		numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 80,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo(50, DISPARO_PEQ, DISP_2ABAJO, 2, 30);
			}
		numLibre = elementoLibre (GAVIBOTS);
			if (numLibre != -1) {
				gavibot[numLibre]->setX(gavibot[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gavibot[numLibre]->setY(-gavibot[numLibre]->getAlto());
				gavibot[numLibre]->setActivo(1);
				gavibot[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(2, 80,  0, VEL_NORMAL, -1);
				gavibot[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				gavibot[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_2ABAJO, 2, 30);
			}
		break;
		case 3800:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 3850:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_VIOLETA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 3900:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, VEL_LENTO, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, VEL_LENTO, VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_AMARILLO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(9,7)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 30, 0, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, -VEL_LENTO, -VEL_RAPIDO, -1);
			}
		break;
		case 3950:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(screen_w); 
				navemed[numLibre]->setY(120);
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, 0, -1);
				navemed[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 2, 45);
			}
		break;
		case 3980:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 3990:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 10, -VEL_NORMAL, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 4000:
			numLibre = elementoLibre (TAXI);
			if (numLibre != -1) {
				taxi[numLibre]->setX(taxi[numLibre]->getCentrarXen(xEnPantalla(9,2))); 
				taxi[numLibre]->setY(-taxi[numLibre]->getAlto());
				taxi[numLibre]->setActivo(1);
				taxi[numLibre]->addMovimiento(0, 130, 0, VEL_MAPA, -1);
				taxi[numLibre]->addMovimiento(0, 10, VEL_NORMAL, VEL_NORMAL, -1);
				taxi[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 4030:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,5)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 4060:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_AMARILLO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_NORMAL, -1);
			}
		break;
		case 4090:
			numLibre = elementoLibre (TAXI);
			if (numLibre != -1) {
				taxi[numLibre]->setX(taxi[numLibre]->getCentrarXen(xEnPantalla(9,2))); 
				taxi[numLibre]->setY(-taxi[numLibre]->getAlto());
				taxi[numLibre]->setActivo(1);
				taxi[numLibre]->addMovimiento(0, 100, 0, VEL_MAPA, -1);
				taxi[numLibre]->addMovimiento(0, 10, VEL_NORMAL, VEL_NORMAL, -1);
				taxi[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 4100:
			numLibre = elementoLibre (NAVEGRANDE);
			if (numLibre != -1) {
				navegrande[numLibre]->setX(screen_w);
				navegrande[numLibre]->setY(yEnPantalla(6,5));
				navegrande[numLibre]->setActivo(1);
				navegrande[numLibre]->addMovimiento(0, 80, -2, -4, -1);
				navegrande[numLibre]->addDisparo (100, DISPARO_PEQ, DISP_8CIRCULAR, 2, 20);
				navegrande[numLibre]->addDisparo (160, DISPARO_GR, DISP_2ABAJO, 3, 40);
				navegrande[numLibre]->addMovimiento(2, 100, 1, 1, -1);
				navegrande[numLibre]->addMovimiento(0, -1,  0, 4, -1);
			}
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setX(-navezepelin[numLibre]->getAncho() + 5);
				navezepelin[numLibre]->setY(yEnPantalla(6,5));
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 80, 2, -4, -1);
				navezepelin[numLibre]->addDisparo (120, DISPARO_PEQ, DISP_2ABAJO, 2, 20);
				navezepelin[numLibre]->addDisparo (160, DISPARO_GR_AZUL, DISP_3ABAJO_CERRADO, 6, 23);
				navezepelin[numLibre]->addMovimiento(2, 100, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, -4, -1);
			}
		break;
		case 4130:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0, 10, VEL_RAPIDO, 0, -1);
				cpolicia[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 4150:
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX( gaviotas[numLibre]->getCentrarXen(xEnPantalla(7,2)) ); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, 80 ,0);
			}
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(7,5))); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, -80 ,0);
			}
		break;
		case 4200:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(7,4)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 4250:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_AZUL);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,3)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, 10, VEL_LENTO, VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, VEL_LENTO, VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(9,7)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 30, 0, -VEL_RAPIDO, -1);
				csimple[numLibre]->addMovimiento(0, -1, -VEL_LENTO, -VEL_RAPIDO, -1);
			}
		break;
		case 4550:
			initFinalNivel3();
		break;
		}
}

void Pantalla::dibujarFinal3 () {
	
	// mostrar mapa
	mapa->dibujarFinal(screen, juego);

	explosiones->dibujarExplosionTierra(screen);
	moverEnemigoTierra();
		
	// creamos coches
	
	if (juego->getCiclos()%120==0) {
		int numLibre = elementoLibre (COCHESIMPLE);
		if (numLibre != -1) {
			csimple[numLibre]->selCoche((rand()%13)+1);
			if (rand()%2==0) { // derecha
				if (rand()%2==0) { // arriba
					csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(13,11)) ); 
					csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
					csimple[numLibre]->setActivo(1);
					csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
				} else { // abajo
					csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(13,11)) ); 
					csimple[numLibre]->setY(screen_h);
					csimple[numLibre]->setActivo(1);
					csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
				}					
			} else { // izquierda
				if (rand()%2==0) { // arriba
					csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(11,2)) ); 
					csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
					csimple[numLibre]->setActivo(1);
					csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
				} else { // abajo
					csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(11,2)) ); 
					csimple[numLibre]->setY(screen_h);
					csimple[numLibre]->setActivo(1);
					csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);

				}
			}
			//csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(11,2)) ); 

		}
	}
	

	ptierra->dibujar(screen);
	
	
	if (jefe3[DIOS_BACO]->getActivo()==1) {
		jefe3[DIOS_BACO]->dibujar(screen);
		jefe3[DIOS_BACO]->crearDisparo(disp_ene);
	}
	if (jefe3[DIOS_HERCULES]->getActivo()==1) {
		jefe3[DIOS_HERCULES]->dibujar(screen);
		jefe3[DIOS_HERCULES]->crearDisparo(disp_ene);
	}
	if (jefe3[DIOS_NEPTUNO]->getActivo()==1) {
		jefe3[DIOS_NEPTUNO]->dibujar(screen);
		jefe3[DIOS_NEPTUNO]->crearDisparo(disp_ene);
	}
	
	if ( (juego->getCiclos()%600==0) && ( (jefe3[0]->getFantasma() == 0) || (jefe3[1]->getFantasma() == 0) || (jefe3[2]->getFantasma() == 0) ) ) {
		crearFiestaFinal3 = true;
	}
	
	if ( (crearFiestaFinal3) && (!jefe3[0]->getEnAtaque()) && (!jefe3[1]->getEnAtaque()) && (!jefe3[2]->getEnAtaque()) ) {
		crearFiestaFinal3 = false;
		jefe3[DIOS_NEPTUNO]->setFiesta(true);
		jefe3[DIOS_HERCULES]->setFiesta(true);
		jefe3[DIOS_BACO]->setFiesta(true);
		biopic->mostrarBioPic();
		sonido->empezarMusicaSecundaria(MUS_GADITANA);
	}
	
	if ( (!jefe3[DIOS_BACO]->getFiesta()) && (!jefe3[DIOS_BACO]->getFantasma()) ) {
		sonido->terminarMusicaSecundaria();
	} else {
		if ( (!jefe3[DIOS_HERCULES]->getFiesta()) && (!jefe3[DIOS_HERCULES]->getFantasma()) ) {
			sonido->terminarMusicaSecundaria();
		} else {
			if ( (!jefe3[DIOS_NEPTUNO]->getFiesta()) && (!jefe3[DIOS_NEPTUNO]->getFantasma()) ) {
				sonido->terminarMusicaSecundaria();
			}				
		}
	}
	
	if (biopic->getBiopicFuera()) {
		biopic->crearDisparo(disp_ene);
		biopic->dibujar(screen); 
	}

	explosiones->dibujarExplosionAire(screen);
	
	dibujarAgregadores();
	
	crearDisparoEnemigo();
	disp_ene->moverDisparo(screen);
	
	DisparoJugador* disp_jugador = jugador->getDisparoJugador();
	
	disp_jugador->mover(screen);
	
	comprobarColisiones();
	
	dibujarJugador ();
	
	dibujarChispas();
	
	comprobarEstelaBomba();
	
	comprobarBalones();

	barra->dibujarBarra(screen, juego, intercom);
	
	if ( (jefe3[0]->getFantasma() == 1) && (jefe3[1]->getFantasma() == 1) && (jefe3[2]->getFantasma() == 1) && (getSalirFase() <= 0) ) {
		setSalirFase(juego->getCiclos());
	}
	
}

void Pantalla::crearElementoNivel2 () {
	int numLibre;
	comprobarConversacionAleatoria();
	
	switch (juego->getCiclos()) {
		case 120:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_VIOLETA);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(7,6)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 170:
			if (juego->getConversacionParaAbrirEnFase() == 1)
				intercom->abrirIntercom(juego->getNivel(), 1, sonido);
		break;
		case 180:
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(-gaviotas2[numLibre]->getAncho()); 
				gaviotas[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 20,  VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 10, GAVIOTA2, 0 ,0);
			}
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(screen_h+gaviotas2[numLibre]->getAncho()); 
				gaviotas[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 20,  -VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas[numLibre]->addMovimiento(0, 30,  0, VEL_NORMAL, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 10, GAVIOTA2, 0 ,0);
			}
		break;
		case 190:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,13)) ); 
				csimple[numLibre]->setY(-csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 220:
			numLibre = elementoLibre (PULPO);
			if (numLibre != -1) {
				pulpo[numLibre]->setX(0); 
				pulpo[numLibre]->setY(30);
				pulpo[numLibre]->setActivo(1);
				pulpo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 230:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 300:
		numLibre = elementoLibre (AVISPA);
			if (numLibre != -1) {
				avispa[numLibre]->setX(avispa[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				avispa[numLibre]->setY(-avispa[numLibre]->getAlto());
				avispa[numLibre]->setActivo(1);
				avispa[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				avispa[numLibre]->addMovimiento(2, 80,  0, VEL_NORMAL, -1);
				avispa[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				avispa[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 15);
				avispa[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		numLibre = elementoLibre (AVISPA);
			if (numLibre != -1) {
				avispa[numLibre]->setX(avispa[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				avispa[numLibre]->setY(-avispa[numLibre]->getAlto());
				avispa[numLibre]->setActivo(1);
				avispa[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				avispa[numLibre]->addMovimiento(2, 80,  0, VEL_NORMAL, -1);
				avispa[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				avispa[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 15);
				avispa[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		break;
		case 320:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( concha[numLibre]->getCentrarXen(xEnPantalla(16,9)) ); 
				concha[numLibre]->setY(-concha[numLibre]->getAlto());
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				concha[numLibre]->addMovimiento(2, 50, 0, VEL_LENTO, -1);
				concha[numLibre]->addMovimiento(0, 30, 0, -VEL_MUYLENTO, -1);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, VEL_MAPA, -1);
			}
		break;
		case 350:
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(-gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(yEnPantalla(4,2));
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 35,  VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  0, -VEL_RAPIDO, -1);	
				gaviotas2[numLibre]->addMovimiento(0, 20,  -VEL_RAPIDO, 0, -1);	
				gaviotas2[numLibre]->addMovimiento(0, 20,  0, VEL_RAPIDO, -1);	
				gaviotas2[numLibre]->addMovimiento(0, 20,  VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);	
				crearFormacionEnFila(gaviotas2[numLibre], 6, 10, GAVIOTA2, 0 ,0);
			}
		break;
		case 360:
			juego->setHacerClip(0);
			intercom->cerrarIntercom(sonido);
		break;
		case 380:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(MERCEDES_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,14)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 390:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_DISPARO);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 480:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,13)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 500:
			numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(xEnPantalla(5,1)); 
				navepeq[numLibre]->setY(-navepeq[numLibre]->getAlto());
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(1, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				crearFormacionEnFila(navepeq[numLibre], 2, 20, NAVEPEQUENYA, 180 ,0);
			}
		break;
		case 520:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(-navemed[numLibre]->getAncho()); 
				navemed[numLibre]->setY(120);
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, 0, -1);
				navemed[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 4, 15);
			}
		break;
		case 510:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( concha[numLibre]->getCentrarXen(xEnPantalla(17,15)) ); 
				concha[numLibre]->setY(-concha[numLibre]->getAlto());
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 35, 0, VEL_LENTO, -1);
				concha[numLibre]->addMovimiento(0, 40, -VEL_LENTO, VEL_MAPA, -1);
				concha[numLibre]->addDisparo (70, DISPARO_GR_AZUL, DISP_3ABAJO, 2, 20);
				concha[numLibre]->addMovimiento(2, 30, 0, -VEL_RAPIDO, -1);
				concha[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
			}
		break;
		case 570:
		numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 50,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 50,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		break;
		case 580:
			numLibre = elementoLibre (NAVERASCASIO);
			if (numLibre != -1) {
				naverascasio[numLibre]->setTipoRegalo(AG_PODER); 
				naverascasio[numLibre]->setX(naverascasio[numLibre]->getCentrarXen(screen_w/2));
				naverascasio[numLibre]->setY(- naverascasio[numLibre]->getAlto() - 30);
				naverascasio[numLibre]->setActivo(1);
				naverascasio[numLibre]->addMovimiento(0, 30, 0, VEL_NORMAL, -1);
				naverascasio[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				naverascasio[numLibre]->addMovimiento(0, 25, VEL_LENTO, 0, -1);
				naverascasio[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				naverascasio[numLibre]->addMovimiento(0, 50, -VEL_LENTO, 0, -1);
				naverascasio[numLibre]->addMovimiento(2, 3, VEL_LENTO, 0, -1);
				naverascasio[numLibre]->addMovimiento(0, 25, VEL_LENTO, 0, -1);
				naverascasio[numLibre]->addDisparo (80, DISPARO_GR, DISP_2ABAJO, 5, 30);
				naverascasio[numLibre]->addDisparo (240, DISPARO_PEQ, DISP_8CIRCULAR, 3, 40);
				naverascasio[numLibre]->addMovimiento(2, 80, 1, 1, -1);
				naverascasio[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
			}
		break;
		case 650:
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(15,14))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
		break;
		case 680:
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(15,14))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
		break;
		case 700:
			numLibre = elementoLibre (YATE);
			if (numLibre != -1) {
				yate[numLibre]->setX( -yate[numLibre]->getAncho() ); 
				yate[numLibre]->setY(yate[numLibre]->getCentrarYen(yEnPantalla(7,1)));
				yate[numLibre]->setActivo(1);
				yate[numLibre]->addMovimiento(0, 15, VEL_NORMAL, 0, -1);
				yate[numLibre]->addMovimiento(0, -1, 0, VEL_LENTO, -1);
				yate[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 50);
			}
		break;
		case 710:
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(15,14))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
		break;
		case 800:
			numLibre = elementoLibre (PULPO);
			if (numLibre != -1) {
				pulpo[numLibre]->setX(0); 
				pulpo[numLibre]->setY(30);
				pulpo[numLibre]->setActivo(1);
				pulpo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 850:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(17,16)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, 20, 0, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0, 2, -VEL_NORMAL, VEL_NORMAL, -1);
				cpolicia[numLibre]->addMovimiento(0, -1, 0, VEL_MAPA, -1);
			}
		break;
		case 890:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(17,15)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, 20, 0, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0, 5, VEL_NORMAL, VEL_NORMAL, -1);
				cpolicia[numLibre]->addMovimiento(0, -1, 0, VEL_MAPA, -1);
			}
		break;
		case 940:
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setX(navezepelin[numLibre]->getCentrarXen(screen_w/2));
				navezepelin[numLibre]->setY(-navezepelin[numLibre]->getAlto() );
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 20, 0, VEL_NORMAL, -1);
				navezepelin[numLibre]->addDisparo (50, DISPARO_PEQ, DISP_2ABAJO, 5, 60);
				navezepelin[numLibre]->addDisparo (70, DISPARO_GR, DISP_5ABAJO, 6, 80);
				navezepelin[numLibre]->addMovimiento(2, 140, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);
			}
		break;
		case 980:
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				gaviotas[numLibre]->setY(screen_h + gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 50, 0, -VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,1))); 
				gaviotas[numLibre]->setY(screen_h + gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, 40, 0, -VEL_RAPIDO, -1);
				gaviotas[numLibre]->addMovimiento(0, -1,  VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 930:
			numLibre = elementoLibre (COCHE_POLICIA);
			if (numLibre != -1) {
				cpolicia[numLibre]->setX( cpolicia[numLibre]->getCentrarXen(xEnPantalla(17,16)) ); 
				cpolicia[numLibre]->setY(-cpolicia[numLibre]->getAlto());
				cpolicia[numLibre]->setActivo(1);
				cpolicia[numLibre]->addMovimiento(0, 20, 0, VEL_RAPIDO, -1);
				cpolicia[numLibre]->addMovimiento(0, 2, -VEL_NORMAL, VEL_NORMAL, -1);
				cpolicia[numLibre]->addMovimiento(0, -1, 0, VEL_MAPA, -1);
			}
		break;
		case 990:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 1000:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( tanque[numLibre]->getCentrarXen(xEnPantalla(17,16)) ); 
				tanque[numLibre]->setY(-tanque[numLibre]->getAlto());
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, 60, 0, VEL_MAPA, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
		break;
		case 1100:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,14)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 1180:
			numLibre = elementoLibre (AVISPA);
			if (numLibre != -1) {
				avispa[numLibre]->setX(-avispa[numLibre]->getAncho()); 
				avispa[numLibre]->setY(70);
				avispa[numLibre]->setActivo(1);
				avispa[numLibre]->addMovimiento(0, 30,  VEL_NORMAL, 0, -1);
				avispa[numLibre]->addMovimiento(2, 70,  VEL_NORMAL, 0, -1);
				avispa[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, 0, -1);
				avispa[numLibre]->addDisparo (20, DISPARO_GR_AZUL, DISP_ALJUGADOR, 4, 25);
			}
			numLibre = elementoLibre (AVISPA);
			if (numLibre != -1) {
				avispa[numLibre]->setX(screen_w); 
				avispa[numLibre]->setY(70);
				avispa[numLibre]->setActivo(1);
				avispa[numLibre]->addMovimiento(0, 30,  -VEL_NORMAL, 0, -1);
				avispa[numLibre]->addMovimiento(2, 70,  VEL_NORMAL, 0, -1);
				avispa[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, 0, -1);
				avispa[numLibre]->addDisparo (20, DISPARO_GR_AZUL, DISP_ALJUGADOR, 4, 25);
			}
		break;
		case 1210:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,14)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 1240:
			numLibre = elementoLibre (AVISPA);
			if (numLibre != -1) {
				avispa[numLibre]->setX(-avispa[numLibre]->getAncho()); 
				avispa[numLibre]->setY(180);
				avispa[numLibre]->setActivo(1);
				avispa[numLibre]->addMovimiento(0, 20,  VEL_NORMAL, 0, -1);
				avispa[numLibre]->addMovimiento(2, 70,  VEL_NORMAL, 0, -1);
				avispa[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, 0, -1);
				avispa[numLibre]->addDisparo (20, DISPARO_GR, DISP_ALJUGADOR, 4, 25);
			}
			numLibre = elementoLibre (AVISPA);
			if (numLibre != -1) {
				avispa[numLibre]->setX(screen_w); 
				avispa[numLibre]->setY(180);
				avispa[numLibre]->setActivo(1);
				avispa[numLibre]->addMovimiento(0, 20,  -VEL_NORMAL, 0, -1);
				avispa[numLibre]->addMovimiento(2, 70,  VEL_NORMAL, 0, -1);
				avispa[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, 0, -1);
				avispa[numLibre]->addDisparo (20, DISPARO_GR, DISP_ALJUGADOR, 4, 25);
			}
		break;
		case 1280:
			numLibre = elementoLibre (NAVERASCASIO);
			if (numLibre != -1) {
				naverascasio[numLibre]->setX(naverascasio[numLibre]->getCentrarXen(screen_w/2));
				naverascasio[numLibre]->setY(-naverascasio[numLibre]->getAlto() );
				naverascasio[numLibre]->setActivo(1);
				naverascasio[numLibre]->addMovimiento(0, 20, 0, VEL_NORMAL, -1);
				naverascasio[numLibre]->addDisparo (50, DISPARO_PEQ, DISP_3ABAJO_CERRADO, 3, 70);
				naverascasio[numLibre]->addDisparo (70, DISPARO_ROT, DISP_3ABAJO, 6, 40);
				naverascasio[numLibre]->addMovimiento(2, 140, 1, 1, -1);
				naverascasio[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);
			}
		break;
		case 1400:
			numLibre = elementoLibre (YATE);
			if (numLibre != -1) {
				yate[numLibre]->setX( -yate[numLibre]->getAncho() ); 
				yate[numLibre]->setY(yate[numLibre]->getCentrarYen(yEnPantalla(7,1)));
				yate[numLibre]->setActivo(1);
				yate[numLibre]->addMovimiento(0, 15, VEL_NORMAL, 0, -1);
				yate[numLibre]->addMovimiento(0, -1, 0, VEL_LENTO, -1);
				yate[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 50);
			}
		break;
		case 1440:
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX( gaviotas2[numLibre]->getCentrarXen(xEnPantalla(6,1)) ); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, 30, VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, 20, 0, -VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, 15, -VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, 15, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1, VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 5, 12, GAVIOTA1, 0 ,0);
			}
		break;
		case 1450:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( screen_w ); 
				concha[numLibre]->setY( 0 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 25, -VEL_LENTO, VEL_MAPA, -1);
				concha[numLibre]->addMovimiento(2, 100, 0, VEL_MAPA, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 40);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, VEL_MAPA, -1);
			}
		break;
		case 1470:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( screen_w ); 
				concha[numLibre]->setY( 120 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 25, -VEL_LENTO, VEL_MAPA, -1);
				concha[numLibre]->addMovimiento(2, 80, 0, VEL_MAPA, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 40);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, VEL_MAPA, -1);
			}
		break;
		case 1480:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 40,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  0, -VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo(80, DISPARO_ROT, DISP_ALJUGADOR, 2, 30);
			}
		break;
		case 1490:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( screen_w ); 
				concha[numLibre]->setY( 240 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 25, -VEL_LENTO, VEL_MAPA, -1);
				concha[numLibre]->addMovimiento(2, 60, 0, VEL_MAPA, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 40);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, VEL_MAPA, -1);
			}
		break;
		case 1500:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 1580:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_NORMAL, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,4)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_NORMAL, 0, -1);
			}
		break;
		case 1610:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(screen_w/2) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, 0, VEL_RAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, 0, -VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, 0, -VEL_NORMAL, -1);
			}
		break;
		case 1620:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,14)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 1630:
			numLibre = elementoLibre (PULPO);
			if (numLibre != -1) {
				pulpo[numLibre]->setX(0); 
				pulpo[numLibre]->setY(30);
				pulpo[numLibre]->setActivo(1);
				pulpo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 1690:
			numLibre = elementoLibre (NAVERASCASIO);
			if (numLibre != -1) {
				naverascasio[numLibre]->setX(naverascasio[numLibre]->getCentrarXen(xEnPantalla(5,1)));
				naverascasio[numLibre]->setY(-naverascasio[numLibre]->getAlto() );
				naverascasio[numLibre]->setActivo(1);
				naverascasio[numLibre]->addMovimiento(0, 20, 0, VEL_NORMAL, -1);
				naverascasio[numLibre]->addDisparo (50, DISPARO_PEQ, DISP_3ABAJO_CERRADO, 3, 70);
				naverascasio[numLibre]->addDisparo (70, DISPARO_ROT, DISP_3ABAJO, 6, 40);
				naverascasio[numLibre]->addMovimiento(2, 140, 1, 1, -1);
				naverascasio[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);
			}
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setX(navezepelin[numLibre]->getCentrarXen(xEnPantalla(5,4)));
				navezepelin[numLibre]->setY(-navezepelin[numLibre]->getAlto() );
				navezepelin[numLibre]->setTipoRegalo(AG_DISPARO); 
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 20, 0, VEL_NORMAL, -1);
				navezepelin[numLibre]->addDisparo (50, DISPARO_PEQ, DISP_3ABAJO_CERRADO, 3, 70);
				navezepelin[numLibre]->addDisparo (70, DISPARO_ROT, DISP_3ABAJO, 6, 40);
				navezepelin[numLibre]->addMovimiento(2, 140, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);
			}
		break;
		case 1750:
		numLibre = elementoLibre (NAVEPEQUENYA);
			if (numLibre != -1) {
				navepeq[numLibre]->setX(xEnPantalla(6,1)); 
				navepeq[numLibre]->setY(-navepeq[numLibre]->getAlto());
				navepeq[numLibre]->setActivo(1);
				navepeq[numLibre]->addMovimiento(0, 30,  0, VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  0, -VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  -VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, 20,  0, VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, 30,  VEL_RAPIDO, 0, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  VEL_RAPIDO, -VEL_RAPIDO, -1);
				navepeq[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				crearFormacionEnFila(navepeq[numLibre], 6, 10, NAVEPEQUENYA, 0 ,0);
			}
		break;
		case 1810:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( tanque[numLibre]->getCentrarXen(xEnPantalla(17,16)) ); 
				tanque[numLibre]->setY(-tanque[numLibre]->getAlto());
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, 60, 0, VEL_MAPA, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
		break;
		case 1830:
			if (juego->getConversacionParaAbrirEnFase() == 2)
				intercom->abrirIntercom(juego->getNivel(), 2, sonido);
		break;
		case 1900:
			numLibre = elementoLibre (YATE);
			if (numLibre != -1) {
				yate[numLibre]->setX( -yate[numLibre]->getAncho() ); 
				yate[numLibre]->setY(yate[numLibre]->getCentrarYen(yEnPantalla(7,1)));
				yate[numLibre]->setActivo(1);
				yate[numLibre]->addMovimiento(0, 15, VEL_NORMAL, 0, -1);
				yate[numLibre]->addMovimiento(0, -1, 0, VEL_LENTO, -1);
				yate[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 50);
			}
		break;
		case 1920:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_NORMAL, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,4)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_NORMAL, 0, -1);
			}
		break;
		case 1940:
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(gaviotas2[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAncho());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  -VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 2000:
		numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(gaviotas2[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAncho());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1, VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 12, GAVIOTA2, 0 ,0);
			}
		break;
		case 1960:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( concha[numLibre]->getCentrarXen(xEnPantalla(16,9)) ); 
				concha[numLibre]->setY(-concha[numLibre]->getAlto());
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				concha[numLibre]->addMovimiento(2, 50, 0, VEL_LENTO, -1);
				concha[numLibre]->addMovimiento(0, 30, 0, -VEL_MUYLENTO, -1);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, VEL_MAPA, -1);
			}
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SMART_AMARILLO);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,14)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_MUYRAPIDO, -1);
			}
		break;
		case 2030:
			juego->setHacerClip(0);
			intercom->cerrarIntercom(sonido);
		break;
		case 2100:
			juego->setZonaSobrepasada(1);
		break;
		///////////////////
		// EMPIEZA EL CANO
		///////////////////
		case 2120:
			cano->iniciar();
			cano->setActivo(1);
			sonido->empezarMusicaSecundaria(MUS_CANO);
		break;
		case 2260:
			mapa->setVelocidad(1);
			cano->setVelocidad(2);
		break;
		case 2270:
			cano->setVelocidad(0);
			mapa->setVelocidad(0);
			cano->setRampaAbierta(true);
			juego->setMapaParado(true);
		break;
		case 2310:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( 0 ); 
				concha[numLibre]->setY( 130 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 60, VEL_LENTO, 0, -1);
				concha[numLibre]->addMovimiento(0, 25, 0, -VEL_LENTO, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 70);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, 0, -1);
			}
		break;
		case 2340:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( 0 ); 
				concha[numLibre]->setY( 130 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 60, VEL_LENTO, 0, -1);
				concha[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 70);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, 0, -1);
			}
		break;
		case 2370:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( 0 ); 
				concha[numLibre]->setY( 130 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 60, VEL_LENTO, 0, -1);
				concha[numLibre]->addMovimiento(0, 25, 0, -VEL_LENTO, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 70);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, 0, -1);
			}
		break;
		case 2390:
		numLibre = elementoLibre (AVISPA);
			if (numLibre != -1) {
				avispa[numLibre]->setX(avispa[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				avispa[numLibre]->setY(-avispa[numLibre]->getAlto());
				avispa[numLibre]->setActivo(1);
				avispa[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				avispa[numLibre]->addMovimiento(2, 60,  0, VEL_NORMAL, -1);
				avispa[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				avispa[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 15);
				avispa[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		break;
		case 2400:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( 0 ); 
				concha[numLibre]->setY( 130 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 60, VEL_LENTO, 0, -1);
				concha[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 70);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, 0, -1);
			}
		break;
		case 2410:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_DISPARO);
				agregadores[numLibre]->setActivo(1);
			}
		break;
		case 2430:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( -tanque[numLibre]->getAncho() ); 
				tanque[numLibre]->setY( 90 );
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 85, VEL_LENTO, 0, -1);
				tanque[numLibre]->addMovimiento(0, 30, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(2, 60, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
		break;
		case 2470:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( -tanque[numLibre]->getAncho() ); 
				tanque[numLibre]->setY( 90 );
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 85, VEL_LENTO, 0, -1);
				tanque[numLibre]->addMovimiento(0, 25, 0, VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, 30, VEL_LENTO, 0, -1);
				tanque[numLibre]->addMovimiento(2, 60, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, -1, VEL_LENTO, 0, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
		break;
		case 2490:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_NORMAL, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,4)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_NORMAL, 0, -1);
			}
		break;
		case 2550:
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX( gaviotas2[numLibre]->getCentrarXen(xEnPantalla(6,1)) ); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 30, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, 30, VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, 20, 0, -VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, 15, -VEL_RAPIDO, 0, -1);
				gaviotas2[numLibre]->addMovimiento(0, 15, 0, VEL_RAPIDO, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1, VEL_RAPIDO, 0, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 5, 12, GAVIOTA1, 0 ,0);
			}
		break;
		case 2570:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( 0 ); 
				concha[numLibre]->setY( 130 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 60, VEL_LENTO, 0, -1);
				concha[numLibre]->addMovimiento(0, 25, 0, -VEL_LENTO, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 70);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, 0, -1);
			}
		break;
		case 2600:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( 0 ); 
				concha[numLibre]->setY( 130 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 60, VEL_LENTO, 0, -1);
				concha[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 70);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, 0, -1);
			}
		break;
		case 2660:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,14)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 2670:
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(-gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA1, 0 ,0);
			}
		break;
		case 2690:
			numLibre = elementoLibre (NAVERASCASIO);
			if (numLibre != -1) {
				naverascasio[numLibre]->setTipoRegalo(AG_PODER); 
				naverascasio[numLibre]->setX(naverascasio[numLibre]->getCentrarXen(xEnPantalla(5,4)));
				naverascasio[numLibre]->setY(-naverascasio[numLibre]->getAlto() );
				naverascasio[numLibre]->setActivo(1);
				naverascasio[numLibre]->addMovimiento(0, 20, 0, VEL_NORMAL, -1);
				naverascasio[numLibre]->addDisparo (50, DISPARO_PEQ, DISP_3ABAJO_CERRADO, 3, 70);
				naverascasio[numLibre]->addDisparo (70, DISPARO_ROT, DISP_3ABAJO, 6, 40);
				naverascasio[numLibre]->addMovimiento(2, 140, 1, 1, -1);
				naverascasio[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);
			}
		break;
		case 2700:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( 0 ); 
				concha[numLibre]->setY( 130 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 60, VEL_LENTO, 0, -1);
				concha[numLibre]->addMovimiento(0, 25, 0, -VEL_LENTO, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 70);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, 0, -1);
			}
		break;
		case 2750:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( -tanque[numLibre]->getAncho() ); 
				tanque[numLibre]->setY( 90 );
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 85, VEL_LENTO, 0, -1);
				tanque[numLibre]->addMovimiento(0, 30, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(2, 60, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
		break;
		case 2840:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( 0 ); 
				concha[numLibre]->setY( 130 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 60, VEL_LENTO, 0, -1);
				concha[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 70);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, 0, -1);
			}
		break;
		case 2860:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_NORMAL, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,4)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_NORMAL, 0, -1);
			}
		break;			
		case 2880:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 60,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				navemed[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 15);
				navemed[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		break;
		case 2900:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( -tanque[numLibre]->getAncho() ); 
				tanque[numLibre]->setY( 90 );
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 85, VEL_LENTO, 0, -1);
				tanque[numLibre]->addMovimiento(0, 30, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(2, 60, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
		break;
		case 2920:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(PICASSO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,14)) ); 
				csimple[numLibre]->setY( -csimple[numLibre]->getAlto() );
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 2950:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_NORMAL, -VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_NORMAL, -VEL_NORMAL, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,4)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_NORMAL, -VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_NORMAL, -VEL_NORMAL, -1);
			}
		break;	
		case 2980:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( 0 ); 
				concha[numLibre]->setY( 130 );
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 60, VEL_LENTO, 0, -1);
				concha[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				concha[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 2, 70);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, 0, -1);
			}
		break;
		case 2970:
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setX(navezepelin[numLibre]->getCentrarXen(xEnPantalla(5,4)));
				navezepelin[numLibre]->setY(-navezepelin[numLibre]->getAlto() );
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 20, 0, VEL_NORMAL, -1);
				navezepelin[numLibre]->addDisparo (30, DISPARO_GR_AZUL, DISP_ALJUGADOR, 3, 60);
				navezepelin[numLibre]->addDisparo (60, DISPARO_ROT, DISP_3ABAJO_CERRADO, 6, 40);
				navezepelin[numLibre]->addMovimiento(2, 100, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, -VEL_RAPIDO, -1);
			}
		break;
			
		case 3070:
			cano->setRampaAbierta(false);
			sonido->terminarMusicaSecundaria();
		break;			
		case 3100:
			mapa->setVelocidad(1);
			cano->setVelocidad(2);
		break;
		case 3110:
			cano->setVelocidad(3);
			mapa->setVelocidad(VEL_MAPA);
			juego->setMapaParado(false);
		break;
			
		///////////////////
		// TERMINA EL CANO
		///////////////////
		case 3200:
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX( gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,1)) ); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, 80 ,0);
			}
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, -80 ,0);
			}
		break;
		case 3280:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(-navemed[numLibre]->getAncho()); 
				navemed[numLibre]->setY(120);
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, 0, -1);
				navemed[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 4, 15);
			}
		break;
		case 3290:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( concha[numLibre]->getCentrarXen(xEnPantalla(16,9)) ); 
				concha[numLibre]->setY(-concha[numLibre]->getAlto());
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				concha[numLibre]->addMovimiento(2, 50, 0, VEL_LENTO, -1);
				concha[numLibre]->addMovimiento(0, 25, 0, -VEL_MUYLENTO, -1);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, VEL_MAPA, -1);
			}
		break;
		case 3300:
			numLibre = elementoLibre (YATE);
			if (numLibre != -1) {
				yate[numLibre]->setX( -yate[numLibre]->getAncho() ); 
				yate[numLibre]->setY(yate[numLibre]->getCentrarYen(yEnPantalla(7,1)));
				yate[numLibre]->setActivo(1);
				yate[numLibre]->addMovimiento(0, 15, VEL_NORMAL, 0, -1);
				yate[numLibre]->addMovimiento(0, -1, 0, VEL_LENTO, -1);
				yate[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 50);
			}
		break;
		case 3330:
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(-gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA1, 0 ,0);
			}
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(screen_h+gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  -VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA1, 0 ,0);
			}
		break;
		case 3340:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(SEICENTO_GRIS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,14)) ); 
				csimple[numLibre]->setY(screen_h);
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, -VEL_RAPIDO, -1);
			}
		break;
		case 3380:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_NORMAL, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,4)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_NORMAL, 0, -1);
			}
		break;	
		case 3420:
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(6,1))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 15,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 50,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_LENTO, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_5ABAJO, 2, 20);
			}
			numLibre = elementoLibre (NAVEMEDIANA);
			if (numLibre != -1) {
				navemed[numLibre]->setX(navemed[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				navemed[numLibre]->setY(-navemed[numLibre]->getAlto());
				navemed[numLibre]->setActivo(1);
				navemed[numLibre]->addMovimiento(0, 15,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(2, 50,  0, VEL_NORMAL, -1);
				navemed[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_LENTO, -1);
				navemed[numLibre]->addDisparo (40, DISPARO_PEQ, DISP_5ABAJO, 2, 20);
			}
		break;
		case 3450:
			numLibre = elementoLibre (PULPO);
			if (numLibre != -1) {
				pulpo[numLibre]->setX(0); 
				pulpo[numLibre]->setY(30);
				pulpo[numLibre]->setActivo(1);
				pulpo[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_ALJUGADOR, 6, 70);
			}
		break;
		case 3460:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(KADETT_VERDE);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,14)) ); 
				csimple[numLibre]->setY( -csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, -1, 0, VEL_RAPIDO, -1);
			}
		break;
		case 3540:
			numLibre = elementoLibre (NAVERASCASIO);
			if (numLibre != -1) {
				naverascasio[numLibre]->setX(screen_w);
				naverascasio[numLibre]->setY(yEnPantalla(6,5));
				naverascasio[numLibre]->setActivo(1);
				naverascasio[numLibre]->addMovimiento(0, 80, -2, -4, -1);
				naverascasio[numLibre]->addDisparo (120, DISPARO_PEQ, DISP_2ABAJO, 5, 10);
				naverascasio[numLibre]->addDisparo (130, DISPARO_GR, DISP_5ABAJO, 3, 24);
				naverascasio[numLibre]->addMovimiento(2, 100, 1, 1, -1);
				naverascasio[numLibre]->addMovimiento(0, -1,  0, 4, -1);
			}
		break;
		case 3620:
			numLibre = elementoLibre (NAVEZEPELIN);
			if (numLibre != -1) {
				navezepelin[numLibre]->setTipoRegalo(AG_VIDA); 
				navezepelin[numLibre]->setX(-navezepelin[numLibre]->getAncho() + 5);
				navezepelin[numLibre]->setY(yEnPantalla(6,5));
				navezepelin[numLibre]->setActivo(1);
				navezepelin[numLibre]->addMovimiento(0, 80, 2, -4, -1);
				navezepelin[numLibre]->addDisparo (120, DISPARO_PEQ, DISP_2ABAJO, 5, 10);
				navezepelin[numLibre]->addDisparo (130, DISPARO_GR, DISP_5ABAJO, 6, 23);
				navezepelin[numLibre]->addMovimiento(2, 100, 1, 1, -1);
				navezepelin[numLibre]->addMovimiento(0, -1,  0, -4, -1);
			}
		break;
			
		case 3600:
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(15,14))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
		break;
		case 3640:
			numLibre = elementoLibre (BARRERA_DER);
			if (numLibre != -1) {
				barrera_der[numLibre]->setX(barrera_der[numLibre]->getCentrarXen(xEnPantalla(15,14))); 
				barrera_der[numLibre]->setY(-barrera_der[numLibre]->getAlto());
				barrera_der[numLibre]->setActivo(1);
			}
		break;
		case 3740:
			numLibre = elementoLibre (COCHESIMPLE);
			if (numLibre != -1) {
				csimple[numLibre]->selCoche(AUTOBUS);
				csimple[numLibre]->setX( csimple[numLibre]->getCentrarXen(xEnPantalla(15,14)) ); 
				csimple[numLibre]->setY( -csimple[numLibre]->getAlto());
				csimple[numLibre]->setActivo(1);
				csimple[numLibre]->addMovimiento(0, 30, 0, VEL_NORMAL, -1);
				csimple[numLibre]->addMovimiento(0, -1, VEL_NORMAL, VEL_RAPIDO, -1);
			}
		break;
		case 3760:
			numLibre = elementoLibre (CONCHA);
			if (numLibre != -1) {
				concha[numLibre]->setX( concha[numLibre]->getCentrarXen(xEnPantalla(16,9)) ); 
				concha[numLibre]->setY(-concha[numLibre]->getAlto());
				concha[numLibre]->setActivo(1);
				concha[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				concha[numLibre]->addMovimiento(2, 50, 0, VEL_LENTO, -1);
				concha[numLibre]->addMovimiento(0, 30, 0, -VEL_MUYLENTO, -1);
				concha[numLibre]->addMovimiento(0, -1, VEL_LENTO, VEL_MAPA, -1);
			}
		break;
		case 3780:
			numLibre = elementoLibre (TANQUE);
			if (numLibre != -1) {
				tanque[numLibre]->setX( tanque[numLibre]->getCentrarXen(xEnPantalla(17,16)) ); 
				tanque[numLibre]->setY(-tanque[numLibre]->getAlto());
				tanque[numLibre]->setActivo(1);
				tanque[numLibre]->addMovimiento(0, 30, 0, VEL_LENTO, -1);
				tanque[numLibre]->addMovimiento(0, 60, 0, VEL_MAPA, -1);
				tanque[numLibre]->addMovimiento(0, -1, 0, -VEL_LENTO, -1);
				tanque[numLibre]->addDisparo (20, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 60);
			}
		break;
		case 3800:
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_NORMAL, 0, -1);
			}
			numLibre = elementoLibre (HELICOPTERO);
			if (numLibre != -1) {
				helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,4)) ); 
				helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
				helicoptero[numLibre]->setActivo(1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, -VEL_LENTO, VEL_MUYRAPIDO, -1);
				helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
				helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_NORMAL, 0, -1);
				helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_NORMAL, 0, -1);
			}
		break;	
		case 3850:
		numLibre = elementoLibre (AVISPA);
			if (numLibre != -1) {
				avispa[numLibre]->setX(avispa[numLibre]->getCentrarXen(xEnPantalla(5,1))); 
				avispa[numLibre]->setY(-avispa[numLibre]->getAlto());
				avispa[numLibre]->setActivo(1);
				avispa[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				avispa[numLibre]->addMovimiento(2, 80,  0, VEL_NORMAL, -1);
				avispa[numLibre]->addMovimiento(0, -1,  -VEL_NORMAL, VEL_NORMAL, -1);
				avispa[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 15);
				avispa[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		numLibre = elementoLibre (AVISPA);
			if (numLibre != -1) {
				avispa[numLibre]->setX(avispa[numLibre]->getCentrarXen(xEnPantalla(5,4))); 
				avispa[numLibre]->setY(-avispa[numLibre]->getAlto());
				avispa[numLibre]->setActivo(1);
				avispa[numLibre]->addMovimiento(0, 20,  0, VEL_NORMAL, -1);
				avispa[numLibre]->addMovimiento(2, 80,  0, VEL_NORMAL, -1);
				avispa[numLibre]->addMovimiento(0, -1,  VEL_NORMAL, VEL_NORMAL, -1);
				avispa[numLibre]->addDisparo(40, DISPARO_PEQ, DISP_ALJUGADOR, 2, 15);
				avispa[numLibre]->addDisparo(80, DISPARO_PEQ, DISP_4OBLICUO, 2, 20);
			}
		break;
		case 4150:
			initFinalNivel2();
		break;
	}
}

void Pantalla::dibujarFinal2 () {
	
	// mostrar mapa
	//mapa->dibujarFinal(screen, juego);
	
	if (juego->getCiclos()%300==0) {
		int numLibre = elementoLibre (HELICOPTERO);
		int salida = rand()%3;
		if (numLibre != -1) {
			helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,1)) ); 
			helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
			helicoptero[numLibre]->setActivo(1);
			helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, VEL_MUYLENTO, VEL_MUYRAPIDO, -1);
			helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
			switch (salida) {
				case 0:
					helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_NORMAL, 0, -1);
					helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_NORMAL, 0, -1);
				break;
				case 1:
					helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, -VEL_NORMAL, VEL_NORMAL, -1);
					helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, -VEL_NORMAL, VEL_NORMAL, -1);
				break;
				case 2:
					helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, 0, -VEL_NORMAL, -1);
					helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, 0, -VEL_NORMAL, -1);
				break;
			}
		}
		numLibre = elementoLibre (HELICOPTERO);
		if (numLibre != -1) {
			helicoptero[numLibre]->setX( helicoptero[numLibre]->getCentrarXen(xEnPantalla(5,4)) ); 
			helicoptero[numLibre]->setY(-helicoptero[numLibre]->getAlto());
			helicoptero[numLibre]->setActivo(1);
			helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, 25, -VEL_MUYLENTO, VEL_MUYRAPIDO, -1);
			helicoptero[numLibre]->addMovimiento(MOV_PARADO, 5, VEL_MUYLENTO, VEL_NORMAL, -1);
			switch (salida) {
				case 0:
					helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_NORMAL, 0, -1);
					helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_NORMAL, 0, -1);
				break;
				case 1:
					helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, VEL_NORMAL, VEL_NORMAL, -1);
					helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, VEL_NORMAL, VEL_NORMAL, -1);
				break;
				case 2:
					helicoptero[numLibre]->addMovimiento(MOV_IMPULSAR, 10, 0, -VEL_NORMAL, -1);
					helicoptero[numLibre]->addMovimiento(MOV_MIRANDOJUGADOR, -1, 0, -VEL_NORMAL, -1);
				break;
			}
		}
	}
	
	if (juego->getCiclos()%400==0) {
		int numLibre = elementoLibre (TANQUE);
		if (numLibre != -1) {
			tanque[numLibre]->setY(tanque[numLibre]->getCentrarYen(yEnPantalla(10,1)));
			tanque[numLibre]->setActivo(1);
			if (rand()%2==0) {
				tanque[numLibre]->setX( screen_w ); 
				tanque[numLibre]->addMovimiento(0, 40, -VEL_LENTO, 0, -1);
				tanque[numLibre]->addMovimiento(MOV_PARADO_ENFINAL, 100, 1, 0, -1);
				tanque[numLibre]->addMovimiento(0, 40, VEL_LENTO, 0, -1);
			} else {
				tanque[numLibre]->setX( -tanque[numLibre]->getAncho() ); 
				tanque[numLibre]->addMovimiento(0, 40, VEL_LENTO, 0, -1);
				tanque[numLibre]->addMovimiento(MOV_PARADO_ENFINAL, 100, -1, 0, -1);
				tanque[numLibre]->addMovimiento(0, 40, -VEL_LENTO, 0, -1);
			}			
			tanque[numLibre]->addDisparo (30, DISPARO_PEQ, DISP_GRADOALJUGADOR, 5, 40);
		}
	}

	mapaagua->dibujarMapa (screen);
	
	if (juego->getCiclos()%10==0) {
		espumaPuente->selSiguienteFrame_Rebote();
	}
	espumaPuente->dibujar(screen);
	puente->dibujar(screen);

	explosiones->dibujarExplosionTierra(screen);
	moverEnemigoTierra();
	
	if (jefe2->getActivo()) {
		jefe2->crearDisparo(disp_ene, sonido);
		jefe2->dibujar(screen);
	}
	
	explosiones->dibujarExplosionAire(screen);
	moverEnemigoAire();
	
	dibujarAgregadores();
	
	crearDisparoEnemigo();
	disp_ene->moverDisparo(screen);
	
	DisparoJugador* disp_jugador = jugador->getDisparoJugador();
	
	disp_jugador->mover(screen);
	
	comprobarColisiones();
	
	int j;
	
	// comprobar colision de balas con jefe
	for (j=0; j < MAXBALAS; j++) {
		if ( disp_jugador->getDisparo(j)->getActivo())  {
			if (jefe2->getActivo()==1 && ( jefe2->colision(disp_jugador->getDisparo(j)) == TRUE ) ){
				// restar impactos para morir y eliminar bala de pantalla
				jefe2->addImpactosParaMorir(sonido, juego, explosiones);
				disp_jugador->getDisparo(j)->setActivo(0);
				crearChispa(disp_jugador->getDisparo(j)->getX(), disp_jugador->getDisparo(j)->getY());
				if (jefe2->getImpactosParaMorir() <= 0) {
					setSalirFase(juego->getCiclos());
				}
			}
		}
	}
	if (EnPoderCadista) {
		for ( j=0; j < MAX_BALON; j++) {
			if ( (disp_jugador->getBalon(j)->getActivo())  && ( jefe2->colision(disp_jugador->getBalon(j)) == TRUE ) ) {
				// restar impactos para morir y eliminar bala de pantalla
				jefe2->addImpactosParaMorir(sonido, juego, explosiones);
				crearChispa(disp_jugador->getDisparo(j)->getX(), disp_jugador->getDisparo(j)->getY());
				disp_jugador->getBalon(j)->setActivo(0);
				if (jefe2->getImpactosParaMorir() <= 0) {
					setSalirFase(juego->getCiclos());
				}
			}
		}
	}
	
	// comprobar colision de jugador con cangrejo
	if ( (jefe2->getActivo()==1) && (jugador->getFantasma()==0) && ( jefe2->colisionConJugador(jugador) == TRUE ) && (jugador->getEstado() == 2) ){
		jugador->setEstado(0); // estado de muerte de jugador			
	}
	
	dibujarJugador ();
	
	dibujarChispas();
	
	comprobarEstelaBomba();
	
	comprobarBalones();

	barra->dibujarBarra(screen, juego, intercom);
	
}

void Pantalla::crearElementoComoJugar () {
	int numLibre, i;
	
	for (i=0; i<int(movJugadorComoJugar.size()); i++) {
		//printf("%d %d\n", movJugadorComoJugar[i].ciclo_in, movJugadorComoJugar[i].ciclo_out);
		if ( (movJugadorComoJugar[i].ciclo_in<juego->getCiclos()) 
			&& (movJugadorComoJugar[i].ciclo_out>juego->getCiclos()) ) {
				if (movJugadorComoJugar[i].derecha)
					jugador->moverDerecha();
				if (movJugadorComoJugar[i].izquierda)
					jugador->moverIzquierda();
				if (movJugadorComoJugar[i].arriba)
					jugador->moverArriba();
				if (movJugadorComoJugar[i].abajo)
					jugador->moverAbajo();
		}
	}
	
	switch (juego->getCiclos()) {
		case 150:
			dibujarCartelComoJugar(0);
		break;
		case 260:
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX( gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,1)) ); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, 80 ,0);
			}
			numLibre = elementoLibre (GAVIOTA1);
			if (numLibre != -1) {
				gaviotas[numLibre]->setX(gaviotas[numLibre]->getCentrarXen(xEnPantalla(6,5))); 
				gaviotas[numLibre]->setY(-gaviotas[numLibre]->getAlto());
				gaviotas[numLibre]->setActivo(1);
				gaviotas[numLibre]->addMovimiento(0, -1, 0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas[numLibre], 1, 10, GAVIOTA1, -80 ,0);
			}
		break;
		case 270:
			jugador->crearDisparo(juego, sonido);
		break;
		case 274:
			jugador->crearDisparo(juego, sonido);
		break;
		case 282:
			jugador->crearDisparo(juego, sonido);
		break;
		case 286:
			jugador->crearDisparo(juego, sonido);
		break;
		case 290:
			jugador->crearDisparo(juego, sonido);
		break;
		case 294:
			jugador->crearDisparo(juego, sonido);
		break;
		case 298:
			jugador->crearDisparo(juego, sonido);
		break;
		case 320:
			dibujarCartelComoJugar(1);
		break;
		case 360:
			dibujarCartelComoJugar(2);
		break;
		case 460:
			dibujarCartelComoJugar(6);
		break;
		case 470:
			numLibre = elementoLibre (AGREGADOR);
			if (numLibre != -1) {
				agregadores[numLibre]->setTipo(AG_PODER);
				agregadores[numLibre]->setActivo(1);
				agregadores[numLibre]->setAgX(100);
				agregadores[numLibre]->setAgY(-35);
				agregadores[numLibre]->setAgDX(4);
				agregadores[numLibre]->setAgDY(4);
			}
		break;
		case 540:
			dibujarCartelComoJugar(7);
		break;
		case 600:
			dibujarCartelComoJugar(8);
		break;
		case 620:
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(-gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA1, 0 ,0);
			}
			numLibre = elementoLibre (GAVIOTA2);
			if (numLibre != -1) {
				gaviotas2[numLibre]->setX(screen_h+gaviotas2[numLibre]->getAncho()); 
				gaviotas2[numLibre]->setY(-gaviotas2[numLibre]->getAlto());
				gaviotas2[numLibre]->setActivo(1);
				gaviotas2[numLibre]->addMovimiento(0, 20,  -VEL_NORMAL, VEL_NORMAL, -1);
				gaviotas2[numLibre]->addMovimiento(0, -1,  0, VEL_NORMAL, -1);
				crearFormacionEnFila(gaviotas2[numLibre], 4, 10, GAVIOTA1, 0 ,0);
			}
		break;
		case 640:
			dibujarCartelComoJugar(9);
		break;
		case 680:
			juego->setPoderSel(2);
			usarPoder();
		break;
		case 720:
			intercom->abrirIntercomComoJugar(sonido);
		break;
		case 780:
			dibujarCartelComoJugar(10);
		break;
		case 800:		
			guardarImg();
			estado = JUEGO_INTERCOM;
			getIntercom()->cargarAnimacionComoJugar();
			sonido->terminarIntercom();
		break;
		case 860:
			dibujarCartelComoJugar(11);
		break;
		case 890:
			mitadLogoAbajo->setY(480);
			mitadLogoAbajo->setDY(-20);
			mitadLogoArriba->setY(-240);
			mitadLogoArriba->setDY(20);
			
			sonido->playSonido(SND_COMP_CERRAR);
		break;
		case 950:
			estado = JUEGO_OPCIONES;
		break;
	}
	
	if ( (juego->getCiclos()>720) && (juego->getCiclos()<780) ) {
		if (juego->getCiclos()%20<10) {
			flechasComoJugar->setX(420);
			flechasComoJugar->setY(240);
			flechasComoJugar->selFrame(1);
			flechasComoJugar->dibujar(screen);
		}
	}
	
}

void Pantalla::dibujarCartelComoJugar(int framecartel) {
	SDL_SetClipRect (screen, NULL);
	guardarImg();
	frameCartelMostrar = framecartel;
	cartelComoJugar->selFrame(frameCartelMostrar);
	dibujarImg();
	cartelComoJugar->dibujar(screen);
	pulsaComoJugar->dibujar(screen);
	if (framecartel==8) {
		flechasComoJugar->setX(410);
		flechasComoJugar->setY(60);
		flechasComoJugar->selFrame(0);
		flechasComoJugar->dibujar(screen);
	}
	if (framecartel==10) {
		flechasComoJugar->setX(420);
		flechasComoJugar->setY(240);
		flechasComoJugar->selFrame(1);
		flechasComoJugar->dibujar(screen);
	}
}

void Pantalla::comprobarConversacionAleatoria() {
	// metemos conversacion aleatoria
	if ( juego->getCiclos() == juego->getCicloConversarionAleatoria() ) {
		intercom->abrirIntercom(0, -1, sonido);
	}
	if ( juego->getCiclos() == juego->getCicloConversarionAleatoria()+200 ) {
		juego->setHacerClip(0);
		intercom->cerrarIntercom(sonido);
	}
}
